# -*- coding: utf-8 -*-

from global_defines import *
import npc
import dialogs
import object_events
import water
from const import *
import schedules
from dynamic_camera import *
import enemy_script
import system_events
import weapon_events
import daily_routine
import skies
import sounds
import dialog
from daily_routine import *
import spawnanimals

## äöü (better)

#***  act. Revision 46, 30.09.2004 **********************************************

def initParties():
	system.create_party(id="ANIMALS",type=PT_COMPUTER)
	system.create_party(id="UISPIELER",type=PT_HUMAN)
	system.create_party(id="DORFBEWOHNER",type=PT_COMPUTER)
	system.create_party(id="WACHEN",type=PT_COMPUTER)
	system.create_party(id="NPCS",type=PT_COMPUTER)

#chars auf immortal / mortal schalten
def init_character_states():
	npcs = system.get_npcs()
	for npc in npcs:
		objects.set_immortal_state(npc, True)

	#objects.set_attribute("LUCAS", "approach_position", [474.0,369.2])

def GetZoneEnterLocation(enterdirection):
	start_locations = \
		{	"NORTH":	(370.0, 582.0),# NORTH
	 		"SOUTH":	(370.0, 582.0),
	 		"WEST":		(370.0, 582.0),
	 		"EAST":		(370.0, 582.0),
	 	}

	if (enterdirection in start_locations.keys()):
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registerd: " + enterdirection
		
def GetZoneEnterLocationVehicles(enterdirection):
	start_locations = \
		{	"NORTH":	(370.0, 582.0),# NORTH
	 		"SOUTH":	(370.0, 582.0),
	 		"WEST":		(370.0, 582.0),
	 		"EAST":		(370.0, 582.0),
	 	}

	if (enterdirection in start_locations.keys()):
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registerd: " + enterdirection


def on_init():
	skies.init_sky_preset("yellow")
	system.set_mission_time("12:02:01")

## Questbook (eingefügt von Roger)
def initQuestbook():
	data().QB_001 = system.register_qb_entry_ex(id_name='ZONE1_AIM_01_NAME',id_desc='ZONE1_AIM_01_DESC',id_short_desc='ZONE1_AIM_01_SHORT_DESC',id_location='ZONE1_AIM_01_LOCATION',id_reward='ZONE1_AIM_01_REWARD', id_history = 'ZONE1_AIM_01_NAME')
	data().QB_002 = system.register_qb_entry_ex(id_name='ZONE1_AIM_02_NAME',id_desc='ZONE1_AIM_02_DESC',id_short_desc='ZONE1_AIM_02_SHORT_DESC',id_location='ZONE1_AIM_02_LOCATION',id_reward='ZONE1_AIM_02_REWARD', id_history = 'ZONE1_AIM_02_NAME')
	data().QB_003 = system.register_qb_entry_ex(id_name='ZONE1_AIM_03_NAME',id_desc='ZONE1_AIM_03_DESC',id_short_desc='ZONE1_AIM_03_SHORT_DESC',id_location='ZONE1_AIM_03_LOCATION',id_reward='ZONE1_AIM_03_REWARD', id_history = 'ZONE1_AIM_03_NAME')
	data().QB_004 = system.register_qb_entry_ex(id_name='ZONE1_AIM_04_NAME',id_desc='ZONE1_AIM_04_DESC',id_short_desc='ZONE1_AIM_04_SHORT_DESC',id_location='ZONE1_AIM_04_LOCATION',id_reward='ZONE1_AIM_04_REWARD', id_history = 'ZONE1_AIM_04_NAME')
	data().QB_005 = system.register_qb_entry_ex(id_name='ZONE1_AIM_05_NAME',id_desc='ZONE1_AIM_05_DESC',id_short_desc='ZONE1_AIM_05_SHORT_DESC',id_location='ZONE1_AIM_05_LOCATION',id_reward='ZONE1_AIM_05_REWARD', id_history = 'ZONE1_AIM_05_NAME')
	data().QB_006 = system.register_qb_entry('ZONE1_AIM_06', id_history = 'ZONE1_AIM_01')
	system.set_qb_entry_state(data("zone_1.zone_1").QB_006, INACTIVE)

	data('zone_6.zone_6').QB_001 = system.register_qb_entry_ex(id_name='ZONE6_AIM_01_NAME',id_desc='ZONE6_AIM_01_DESC',id_short_desc='ZONE6_AIM_01_SHORT_DESC', id_reward='ZONE6_AIM_01_REWARD')
	
	
def initWaterResources():
	water.set_water_source(345.3,476.7,4)
	#water.set_water_source(258.3,264.6,2)
	water.set_water_source(419.5,349.8,3)

def checkZoneDependencies():
	if was_zone_entered("zone_5.zone_5"):
		if data("zone_5.zone_5").phoenix_gesprochen:
			if not data().Phoenix_Info:
				data().Phoenix_Info = True
				character.set_approachable_state("WESLEY",APPROACHABLE)
				objects.cancel_commandos('WESLEY')
				objects.set_position_free('WESLEY', 412.54, 292.01, 0)
				character.set_approachable_state("PRESIDENT_HAYES",NOTAPPROACHABLE)
				#for i in [0,1,2]:
				#	ptid_init(i)
				if not data().WesleyHatVerkackt and objects.exists("WESLEY"):
					if not objects.is_active("WESLEY"):	
						objects.set_active_state("WESLEY",1)
				#Haendler bekommt LW Hammer ins Angebot.
				if not objects.exists("SEBASTIAN_LW_HAMMER"):
					objects.create_item_in_inventory("SEBASTIAN", "SET_LW_HAMMER", id = "SEBASTIAN_LW_HAMMER")
				
	if was_zone_entered("zone_8.zone_8")and data('zone_8.zone_8').BruchMitHayes :
		for id in system.get_npcs():
			if id not in ["FRANKLIN", "ABEL", "ANIE", "IAN", "LINDA", "PAULA", "ABRAHAM", "MICKEY", "SUE_Z7", "FJODR"]:
				objects.set_active_state(id,0)

def init_non_rest_areas():
	data("rest").non_rest_areas = []
	if not hasattr(data(), "has_non_rest_areas"):
		data().has_non_rest_areas = True
		#spezielle non rest regionen
		system.add_region("Ostteil",450,320,520,465)
		system.add_region("Nordteil",295,270,475,300)
		system.add_region("Westteil",340,495,250,285)
		system.add_region("Suedteil",465,420,280,525)
	
	data("rest").non_rest_areas.append("Ostteil")
	data("rest").non_rest_areas.append("Nordteil")
	data("rest").non_rest_areas.append("Westteil")
	data("rest").non_rest_areas.append("Suedteil")

def on_map_loaded():
	init_data()
	initParties()
	npc.initNPCS()
	initItems()
	initHerbs()
	initExitZones()
	initFX()
	initMinimapMarkers()
	## Tiere initialisieren
	npc.initAnimals()
	## Timer für die Tierspawns
	on_timer(data().Timer_SpawnTimeChecker)
	#system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)

	objects.set_position(object = "LUCAS",x = 474.0,y = 368.04, grid = "BUILDING_2141_INTERIOR_GRID")
	objects.turn_to_direction(object = "LUCAS",direction = DIR_SOUTH)

	## Questbook (eingefügt von Roger)
	initQuestbook()
	init_character_states()
	
	# Stefan: zone 2 is now connected to dialogue 015
	# set_zone_enabled("zone_2",True)

	# Region vor dem Praesidentenpalast: Es folgt ein einmaliger Kommentar, dass man da nicht naeher
	# rangehen soll
	system.add_region( id = "REGION_PRESIDENT_HOUSE", x1 = 310.0, y1 = 425.0, x2 = 317, y2 = 433.85 )
	system.notify_region_entered( region="REGION_PRESIDENT_HOUSE", partyid="UISPIELER" )

	system.add_region( id = data().Region_Lucas,x1=472.0,y1=364.0,x2=465.5,y2=372.0 )

	system.add_region( id = "REGION_START_AREA", x1 = 368.7, y1 = 533.3, x2 = 382.0, y2 = 557.8 )
	system.notify_region_entered( region="REGION_START_AREA", partyid="UISPIELER", permanent = True)
	
	system.add_region( id = "REGION_GRAVE_01_N", x1 = 553.0, y1 = 323.14, x2 = 577.48, y2 = 350.00 )
	system.add_region( id = "REGION_GRAVE_01_S", x1 = 553.0, y1 = 350.00, x2 = 577.48, y2 = 389.06 )
	
	system.add_region( id = "REGION_GRAVE_02", x1 = 562.35, y1 = 350.55, x2 = 570.75, y2 = 360.08 )

	system.add_region( id = "REGION_WESLEY", x1 = 415.60, y1 = 287.30, x2 = 407.10, y2 = 299.00 )

	system.add_region( id = "REGION_EXECUTION", x1 = 339.89, y1 = 469.95, x2 = 423.0, y2 = 394.0 )
	if( data().Execution < 100 ):
		system.notify_region_entered( region="REGION_EXECUTION", partyid="UISPIELER" )

	# zone_1 should be on the zone map if you leave the zone
	set_zone_enabled("zone_1", True, show_sysmsg=False)

	objects.set_active_state( "WESLEY", INACTIVE)

	system.add_region("REGION_TUTORIAL_START",287.9,318.2,302.2,298.6)
	system.add_region("REGION_TUTORIAL_PARZELLE_1",282.2,342.0,283.0,363.5)
	system.add_region("REGION_TUTORIAL_PARZELLE_2",250.47,350.82,263.43,356.67)#265.0,358.6,271.9,350.3)
	system.add_region("REGION_TUTORIAL_EXIT",293.75,358.2,298.6,347.2)
	system.add_region("REGION_TUTORIAL_EXIT_2",317,326,321,317)

	if( data().Execution == 0 ):
		sounds.load_sound(sfx_id="guillotine")
		sounds.load_sound(sfx_id="execution_audience")
	
	init_scriptuse_objects()
	InitChestsSafes()
	initWaterResources()
	checkZoneDependencies()
	schedules.init_schedules() ## immer nach dem initQuestbook()
	anim_bully()
	init_non_rest_areas()

	# close the entrance door of the presidents guest house
	#objects.add_closed_lock( "BUILDING_4078", "lock1" )
	#objects.add_closed_lock( "BUILDING_4078", "lock2" )
	init_main_npcs()

def anim_bully(objectid=None):
	objects.play_animation('BUILDING_2073','ANIM_BULLY_SCHWINGT',callback=["ONEND",anim_bully])
	sounds.play_3d_sound_object(sfx_id="gate",object="BUILDING_2073")
	
# mark objects that are used in script
def init_scriptuse_objects():
	#bonfires - for cooking
	system.mark_for_script_use('BUILDING_868')
	system.mark_for_script_use('BUILDING_80')
	
	# eingangstor
	system.mark_for_script_use('BUILDING_2073')
	
	#president guest house7
	system.mark_for_script_use('BUILDING_4078')
	
	#gates at training 
	system.mark_for_script_use('BUILDING_1850')
	system.mark_for_script_use('BUILDING_1851')
	x1,y1,z1 = objects.get_position('BUILDING_1850')
	d1 = objects.get_direction('BUILDING_1850')
	x2,y2,z2 = objects.get_position('BUILDING_1851')
	d2 = objects.get_direction('BUILDING_1851')
	system.create_object('RES3D_TRES_OBJECTS_BUILDING_ROLLADEN_OFFEN',x1,y1,'rolladen_1_offen',d1)
	objects.set_active_state('rolladen_1_offen',0)
	objects.set_immortal_state('rolladen_1_offen', True)
	system.create_object('RES3D_TRES_OBJECTS_BUILDING_ROLLADEN_OFFEN',x2,y2,'rolladen_2_offen',d2)
	objects.set_immortal_state('rolladen_2_offen', True)
	objects.set_active_state('rolladen_2_offen',0)

	#pappkameraden at training
	#sector 1
	system.mark_for_script_use('BUILDING_2058')
	system.mark_for_script_use('BUILDING_2059')
	#sector 2
	system.mark_for_script_use('BUILDING_2064')
	system.mark_for_script_use('BUILDING_2062')
	system.mark_for_script_use('BUILDING_2060')
	system.mark_for_script_use('BUILDING_2066')
	system.mark_for_script_use('BUILDING_2061')
	#sector 3
	system.mark_for_script_use('BUILDING_2063')
	#climbing at training
	system.mark_for_script_use('BUILDING_804')
	#lautsprecher exekution
	system.mark_for_script_use('ZONE_1_BUILDING_2071')
	
	# zäune ausschalten
	for fence in OBJECTS_PRESIDENT_HOUSE_FENCE:
		system.mark_for_script_use(fence)
		objects.set_attribute(fence,"climbing_allowed",False)
	#klettern beim training
	system.mark_for_script_use('BUILDING_804')
	
	# Kisten + Truhen
	system.mark_for_script_use('BUILDING_5952')
	system.mark_for_script_use('THE FALL_BUILDING_4169')

	system.mark_for_script_use('BUILDING_10251')
	system.mark_for_script_use('BUILDING_10252')
	system.mark_for_script_use('BUILDING_10281')
	system.mark_for_script_use('BUILDING_10282')
	system.mark_for_script_use('BUILDING_10283')
	system.mark_for_script_use('BUILDING_10284')
	system.mark_for_script_use('BUILDING_10285')
	system.mark_for_script_use('BUILDING_10301')
	system.mark_for_script_use('BUILDING_10303')
	system.mark_for_script_use('BUILDING_10304')
	system.mark_for_script_use('BUILDING_10332')
	
	# Bienenstöcke Zone 1
	system.mark_for_script_use('BUILDING_10467')
	system.mark_for_script_use('BUILDING_10464')
	system.mark_for_script_use('BUILDING_10463')
	
	objects.set_immortal_state('BUILDING_10304',True)

#can climb callback for wall/fence climbing
def can_climb( character_id, object_id ):
	
	#fence at president house
	if object_id in OBJECTS_PRESIDENT_HOUSE_FENCE:
		return False
	
	return object_events.can_climb( character_id, object_id )

def on_post_load():
	initFX()
	schedules.init_schedules()
	init_patch()

def on_map_reentry():
	initFX()
	location = GetZoneEnterLocationVehicles( system.zone_transfer_get_direction() )
	system.zone_transfer_place_vehicles( location[0], location[1] )
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	
	checkZoneDependencies()
	init_non_rest_areas()
	schedules.init_schedules()
	init_patch()
	if data().wesley_hat_gestanden:
		if objects.exists('WESLEY'):
			if objects.is_active("WESLEY"):	
				objects.set_active_state("WESLEY", False)

def SetPresidentGroup():
	objects.turn_to_direction( "PRESIDENT_HAYES", DIR_NORTH )
	objects.turn_to_object( "PRESIDENT_COMPANION_01", "PRESIDENT_HAYES" )
	objects.turn_to_object( "PRESIDENT_COMPANION_02", "PRESIDENT_HAYES" )
	data().PresidentRun = -11

def on_approach(target, operator):
	if not object_events.on_approach(target, operator):
		dialogs.on_approach(target, operator)

def onDlg_015_WesleyAndPlayerHug(id):
	data().wesley_ae_reached += 1
	if data().wesley_ae_reached == 2:
		#dialogs.initDlg_015_Wesley_CharCreate()
		objects.cancel_commandos("ALTER_EGO")
		objects.cancel_commandos("WESLEY")
		character.play_animation('ALTER_EGO','CM_STEHEN_UMARMEN_MANN_1')
		character.play_animation('WESLEY','CM_STEHEN_UMARMEN_MANN_2')
		objects.turn_to_object("WESLEY","ALTER_EGO")

#def onDlg_015_StartDialog(char):
#	dialogs.initDlg_015_Wesley_CharCreate()

def onDlg_011_NewCamPos2(id):
	objects.turn_to_object("ALTER_EGO","PRESIDENT_HAYES")
	objects.turn_to_object("ALTER_EGO","PRESIDENT_HAYES")
	data().RunToPresident = 1002
	system.set_camera_view(CAMVIEW_PASSAUSGABE3)

def onDlg_011_InitDialog(id):
	objects.turn_to_object(PRESIDENT_TEAM_IDS[1],"ALTER_EGO")
	objects.turn_to_object(PRESIDENT_TEAM_IDS[2],"ALTER_EGO")
	objects.turn_to_object("PRESIDENT_HAYES","ALTER_EGO")
	objects.turn_to_object("ALTER_EGO","PRESIDENT_HAYES")
	dialogs.initDlg_011_President_Companions()

def onDlg_011_NewCamPos1(id):
	objects.turn_to_object("ALTER_EGO","PRESIDENT_HAYES")
	system.set_camera_view(CAMVIEW_PASSAUSGABE1) #2
	objects.cancel_commandos("ALTER_EGO")
	objects.move_to("ALTER_EGO",466.53,370.5,"landscape",MT_SLOW, callback=["ONEND",onDlg_011_NewCamPos2])

def onDlg_011_CheckAllPresidentsCompanionsArrived(char_id):
	objects.turn_to_object(char_id,"ALTER_EGO")
	data().president_team_ids_arrived += 1
	if data().president_team_ids_arrived >= 3:
		onDlg_011_InitDialog(char_id)

def on_enter_region(id, objectid, partyid ):
	# print 'on_enter_region(', id, objectid, partyid ,')'
	# non-permanent triggers: objectid is list of all chars in region
	if isinstance(objectid,list):
		if len(objectid): objectid=objectid[0]
		else: return
	
	if id == "REGION_TUTORIAL_START" and not dialog.is_dialog_active():
		objects.move_to("DRILL_INSTRUCTOR",298.26, 299.52)
		objects.turn_to_object('DRILL_INSTRUCTOR', "ALTER_EGO")
		dialogs.initDlg_033_Instructor_SessionOne()
		character.set_approachable_state("DRILL_INSTRUCTOR", 0)
		
	if id == "REGION_TUTORIAL_EXIT":
		data().has_training_weapons = False
		dialogs.training_done()
		if data().training_aims_hit == 7:
			if not dialog.is_dialog_active():
				dialogs.initDlg_040_Instructor_ParcourEnd()
			else:
				data().training_delayed_dialog = "ParcourEnd"
				system.notify_timer(data().Timer_training_dialog_delay_2,data().Timervalue_training_dialog_delay_2)
			
		else:
			if not dialog.is_dialog_active():
				dialogs.initDlg_039_Instructor_ParcourCancelled()
			else:
				data().training_delayed_dialog = "ParcourCancelled"
				system.notify_timer(data().Timer_training_dialog_delay_2,data().Timervalue_training_dialog_delay_2)
			
			
	if id == "REGION_TUTORIAL_EXIT_2":
		if data().has_training_weapons:
			data().has_training_weapons = False
			
			if data().training_aims_hit == 7:
				if not dialog.is_dialog_active():
					dialogs.initDlg_040_Instructor_ParcourEnd()
				else:
					data().training_delayed_dialog = "ParcourEnd"
					system.notify_timer(data().Timer_training_dialog_delay_2,data().Timervalue_training_dialog_delay_2)
				
			else:
				if not dialog.is_dialog_active():
					dialogs.initDlg_039_Instructor_ParcourCancelled()
				else:
					data().training_delayed_dialog = "ParcourCancelled"
					system.notify_timer(data().Timer_training_dialog_delay_2,data().Timervalue_training_dialog_delay_2)
				
			
			#if data().training_aims_hit == 7:
			#	dialogs.initDlg_040_Instructor_ParcourEnd()
			#else:
			#	dialogs.initDlg_039_Instructor_ParcourCancelled()
			
			if data().training_break_early:
				dialogs.training_done()
			else: 
				data().training_break_early = True
			
				
	if id == "REGION_TUTORIAL_PARZELLE_1":
		system.notify_region_entered('REGION_TUTORIAL_EXIT',objectid="ALTER_EGO")
		
	if id == "REGION_TUTORIAL_PARZELLE_2":
		dialogs.initDlg_036_Instructor_SessionFour()
	
	if id == data().Region_Lucas:
		if (data().ReceivedPassport == 1 and
			not data().Cutscene_PresidentnachPassausgabeGestartet):
			data().Cutscene_PresidentnachPassausgabeGestartet = True
			system.notify_timer(data().Timer_Cutscene_Delay, data().Timervalue_Cutscene_Delay)

	if id == "REGION_PRESIDENT_HOUSE":
		if( partyid == "UISPIELER" and
			data().SpokeToPresidentGuard02 == 0 and
			data().SpokeToPresidentGuard01 == 0 and
			objects.is_active("PRESIDENT_GUARD_01") ):
			if dialog.is_dialog_active() or system.is_cutscene():
				system.notify_region_entered(region="REGION_PRESIDENT_HOUSE", partyid="UISPIELER")
				return
			dialogs.initDlg_001_ReachRangePresidentHouse( objectid )

	if id == "REGION_EXECUTION":
		# Hier müßten noch die Geräusche gestartet werden
		sounds.play_3d_sound_object(sfx_id="guillotine", object= data().Obj_Guillotine)
		enemy_script.delay(0.7, Lambda('objects.play_animation("BUILDING_2066", "GUILLOTINE")'))
		system.notify_timer( data().Timer_Execution, data().Timervalue_ExecutionWaitApplause )


	if id == "REGION_WESLEY":
		if not data().wesley_intro:
			data().wesley_intro = True
			system.start_cutscene()
			data().saved_ae_scale = objects.get_scale("ALTER_EGO")
			wesley_scale = objects.get_scale("WESLEY")
			objects.set_scale("ALTER_EGO", wesley_scale)
			objects.cancel_commandos("ALTER_EGO")
			objects.set_position("ALTER_EGO", 414.0,290.0)
			system.set_camera_view(CAMVIEW_WESLEY_INTRO)
			enemy_script.delay(0.8, Lambda('dialogs.init_dialog_015_ae_sieht_wesley()'))
			objects.cancel_commandos("WESLEY")
			objects.turn_to_object("WESLEY","ALTER_EGO")
			objects.step_to('ALTER_EGO',412.0,292.5,speed=MT_SLOW, callback=["ONEND", onDlg_015_MoveFinished])

	if id == "REGION_PRESIDENT_HOUSE2":
		data().PresRegionCheck = 1
		# objects.attack( char="PRESIDENT_GUARD_01" , target = objectpartyid )
		# objects.attack( char="PRESIDENT_GUARD_02" , target = objectpartyid )

	if id == "REGION_PRESIDENT_TUTORIAL":
		data().RunToDrillInstructor = 1
		system.start_cutscene()
		objects.move_to( object="ALTER_EGO", x=325.8, y=326.1, grid="landscape", callback=["ONEND",onRunToDrillInstructor])

	if id == "REGION_START_AREA":
		if not data().Phoenix_Info:
			if not data().zone_1_intro:
				data().zone_1_intro = True
				system.start_cutscene()
				system.set_camera_view(CAM_AE_WACHE_INTRO)
				objects.cancel_commandos("ALTER_EGO")
				objects.move_to("ALTER_EGO",374.5,555.0)
				dialogs.initDlg_043_WestGuardIntro()
			
			elif not data().grab_comment:
				if data().wesley_hinweis_grab:
					data().grab_comment = True
					dialogs.initDlg_059_SpielerWillZumGrabDesVaters()
		else:
			if data().wesley_hat_gestanden:
				if not data().zone_1_phoenix_reenter_intro:
					data().zone_1_phoenix_reenter_intro = True
					character.set_approachable_state("PRESIDENT_HAYES",APPROACHABLE)
					initPresidentGreetzPlayer()
			else:
				if was_zone_entered("zone_8.zone_8"):
					if not data().zone_1_after_z8_reenter:
						data().zone_1_after_z8_reenter = True
						dialogs.initDlg_060_DasGNOCampIstVerlassen()
	

	if id in ["REGION_GRAVE_01_S","REGION_GRAVE_01_N"]:
		if hasattr(data('zone_5.zone_5'), 'phoenix_gesprochen'):
			if data('zone_5.zone_5').phoenix_gesprochen:
				system.notify_region_entered( region="REGION_GRAVE_02", objectid="ALTER_EGO")
				return
		if not data().grave_intro:
			data().grave_intro = True
			for pc_id in system.get_pcs():
				objects.cancel_commandos(pc_id)
			dialogs.initDlg_031_FathersGrave_Detect(pc_id, id)

	if id == "REGION_GRAVE_02":
		if not data().grave_second_intro:
			objects.cancel_commandos("ALTER_EGO")
			data().grave_second_intro = True
			dialogs.initDlg_032_FathersGrave_Talk()

def onDlg_015_MoveFinished(char):
	objects.cancel_commandos('ALTER_EGO')
	objects.cancel_commandos('WESLEY')
	data().wesley_ae_reached = 0
	objects.turn_to_object("ALTER_EGO","WESLEY",callback=["ONEND",onDlg_015_WesleyAndPlayerHug])
	objects.turn_to_object("WESLEY","ALTER_EGO",callback=["ONEND",onDlg_015_WesleyAndPlayerHug])

def ptid_init(num = None):
	for num in [0,1,2]:
		pos = [[375.35, 556.07],[373.49, 555.67],[376.14, 555.42]]
		movs = [[375.4,548.4],[374.7,549.5],[376.7,549.5]]
		objects.set_active_state(PRESIDENT_TEAM_IDS[num],1)
		objects.cancel_commandos(PRESIDENT_TEAM_IDS[num])
		enemy_script.delay(0.5, Lambda('hayes_activ_test("%s")' %PRESIDENT_TEAM_IDS[num]))
		objects.set_position(PRESIDENT_TEAM_IDS[num],pos[num][0], pos[num][1])
		objects.move_to(PRESIDENT_TEAM_IDS[num],movs[num][0],movs[num][1],grid="landscape",speed=MT_SLOW, callback=["ONEND", onPresidentGreetzPlayerStartDialog])

def hayes_activ_test(char):
	if not objects.is_active(char):
		objects.set_active_state(char, 1)
		enemy_script.delay(0.5, Lambda('hayes_activ_test("%s")' %char))

def on_presindent_outtro_start():
	for i in [0,1,2]:
		ptid_init(i)
		enemy_script.delay(1.0, Lambda('objects.set_active_state(PRESIDENT_TEAM_IDS[%i],1)' %(i)))

def initPresidentGreetzPlayer():
	if not 'ALTER_EGO' in enemy_script.is_in_area(['ALTER_EGO'], 15, 'ZONE_1_BUILDING_747'):
		objects.cancel_commandos('ALTER_EGO')
		objects.set_position('ALTER_EGO', 375.24, 534.25)
	system.set_camera_view(CAMVIEW_PHOENIXINFO_2)
	system.fade(FADE_IN)
	ptid_init()
	
	if not hasattr(data(), "scene_activation"):
		data().scene_activation = 1
		pos = [(377.05, 547.46), (376.26, 545.08), (375.09, 544.11), (373.69, 545.02),
				(372.82, 546.56), (375.56, 543.72)]
		act_pos = 0
		for char in system.get_pcs():
			if char == 'ALTER_EGO':
				objects.move_to("ALTER_EGO",374.96,545.48,grid="landscape",speed=MT_SLOW, callback=["ONEND",onPresidentGreetzPlayerStartDialog])
			else:
				objects.move_to(char,pos[act_pos][0], pos[act_pos][1], grid="landscape",speed=MT_SLOW, callback=["ONEND", Lambda('objects.turn_to_object("%s", "PRESIDENT_HAYES")' %char)])
				act_pos += 1

def onPresidentGreetzPlayerStartDialog(id):
	enemy_script.delay(1.5,Lambda('system.set_camera_view(CAMVIEW_PHOENIX_INFO_CLOSE)'))
	if not hasattr(data(), "counter_pi_cutscene"):
		data().counter_pi_cutscene = 0
	data().counter_pi_cutscene += 1
	if data().counter_pi_cutscene == 4:
		data().counter_pi_cutscene = 0
		end_cutscene(chars=["ALTER_EGO"])
		dialogs.initDlg_057_PraesidentInformiertUeberSchatten()

def onRunToDrillInstructor(id):
	data().RunToDrillInstructor = 2
	end_cutscene(chars=[])
	dialogs.initDlg_017_Instructor_StartTutorial()

def setNPCIdleCycles( id, Min, Max ):
	Val1 = random.randint( Min, Max )
	Loop = 0
	while( Loop < Val1 ):
		character.play_animation( id, "CM_NPC_STEHEN_KONVERSATION_%d" % dialogs.Random1345() )
		Loop += 1

def on_begin_cutscene():
	"""is called when a cutscene is started""" 
	mobs = system.get_pcs() + system.get_npcs() + system.get_animals()
	
	system_events.handle_vehicles_in_cutscene_on_begin()
	
	for mob in mobs:
		system_events.save_foes(mob)
		system_events.save_speedfactor(mob)

	# make sure AE is available
	if objects.is_unconscious("ALTER_EGO"):
		import object_events
		object_events.on_resuscitate("ALTER_EGO", "ALTER_EGO", False)
		
	## makes chars stand
	import dynamic_camera
	for pc in system.get_pcs():
		if not data().wesley_cs_after_idcards:
			objects.cancel_commandos( pc )
			dynamic_camera.set_body_mode(char_id=pc)
	
	#make npcs and animals visible during a cutscene
	#deactivate visibility fading
	for id in (system.get_npcs() + system.get_animals()):
		objects.set_attribute(id, "visibility", UIVIS_VISIBLE)
		objects.set_attribute(id, "visibility_fade", False)

def endExecution( ):
	if not data().double_execution_endstart_checker:
		data().double_execution_endstart_checker = True

		if( data().Execution < 100 ):
			data().Execution = 100
	
			for npc in NPC_IDS:
				if objects.has_attribute(npc, 'voice_id'):
					objects.set_attribute(npc, 'voice_id', None)
				setNPCIdleCycles( npc, 0, 10 )
	
			for merc in MERCENARY_IDS:
				#finish_activity( merc )
				setNPCIdleCycles( merc, 0, 5 )
	
			for npc in ADDITIONAL_NPC_EXEIDS:
				if objects.has_attribute(npc, 'voice_id'):
					objects.set_attribute(npc, 'voice_id', None)
				setNPCIdleCycles( npc, 0, 10 )
				#allow_activity( npc )

def onPresidentRun(id):
	if data().PresidentRun > 0:
		data().PresidentRun -= 1
		if( data().PresidentRun == 0 ):
			SetPresidentGroup()

def on_timer(id):
	# print 'timer = ', id
	if id == data().Timer_Cutscene_Delay:
		dialogs.activate_president_and_team()
		system.start_cutscene()
		objects.cancel_commandos("ALTER_EGO")
		objects.turn_to_object("ALTER_EGO","PRESIDENT_HAYES")
		onDlg_011_NewCamPos1("ALTER_EGO")
		objects.move_to(PRESIDENT_TEAM_IDS[0],466.0,372.0,grid="landscape",speed=MT_SLOW, callback=["ONEND",onDlg_011_CheckAllPresidentsCompanionsArrived])#onDlg_011_InitDialog])
		objects.move_to(PRESIDENT_TEAM_IDS[1],467.0,373.0,grid="landscape",speed=MT_SLOW, callback=["ONEND",onDlg_011_CheckAllPresidentsCompanionsArrived])#Lambda('objects.turn_to_object("ALTER_EGO","PRESIDENT_HAYES")')])
		objects.move_to(PRESIDENT_TEAM_IDS[2],465.0,373.0,grid="landscape",speed=MT_SLOW, callback=["ONEND",onDlg_011_CheckAllPresidentsCompanionsArrived])#Lambda('objects.turn_to_object("ALTER_EGO","PRESIDENT_HAYES")')])
		data().RunToPresident = 1001

	if id == data().Timer_CutsceneCam_President:
		system.set_camera_view(CAMVIEW_PASSAUSGABE4)

	if id == data().Timer_President:
		objects.set_active_state( object="PRESIDENT_HAYES", state=ACTIVE)
		objects.set_active_state( object="PRESIDENT_COMPANION_01", state=ACTIVE)
		objects.set_active_state( object="PRESIDENT_COMPANION_02", state=ACTIVE)

		data().PresidentRun = 3

		objects.move_to( object="PRESIDENT_HAYES", x=320.8, y=443.8 , grid="landscape",callback=["ONEND",onPresidentRun])
		objects.move_to( object="PRESIDENT_COMPANION_01", x=318.9, y=442.8 , grid="landscape",callback=["ONEND",onPresidentRun])
		objects.move_to( object="PRESIDENT_COMPANION_02", x=322.5, y=441.8 , grid="landscape",callback=["ONEND",onPresidentRun])

	elif id == data().Timer_PresidentWarning:
		system.notify_region_entered( region="REGION_PRESIDENT_HOUSE", partyid="UISPIELER" )

	elif id == data().Timer_PresidentComment:
		dialogs.initDlg_013_PlayerLikesPresident()

	elif id == data().Timer_Execution:
		if( data().Execution == 0 ):
			sounds.play_3d_sound_object(sfx_id="execution_audience",
				object=data().Obj_Guillotine)
			data().Execution = 1
			system.notify_timer( data().Timer_Execution, data().Timervalue_ExecutionWaitDialog050 )

		elif( data().Execution == 1 ):
			dialogs.initDlg_050_Speaker()
			data().Execution = 2

		elif( data().Execution == 3 ):
			data().Execution = 4
			system.notify_timer( data().Timer_Execution, data().Timervalue_ExecutionWaitEnd )
			
		elif( data().Execution == 4 ):
			endExecution()
			
	elif id == data().Timer_training_dialog_delay:
		if data().training_break_early:
			print"break training timer"
			data().training_activated = False
			dialogs.training_unhalt_partychars()
			#data().training_di_return = True
			#dialogs.training_done()
		else:
			if objects.get_attribute("ALTER_EGO","slots").has_key("right_hand"):
				item = objects.get_attribute("ALTER_EGO","slots")['right_hand']
				if item in data().training_weapons and not dialog.is_dialog_active():
					dialogs.initDlg_034_Instructor_SessionTwo()
				elif item != None:
					if objects.has_attribute(item, 'weapon_type') and not dialog.is_dialog_active():
						dialogs.initDlg_034_Instructor_SessionTwo()
					else:
						system.notify_timer(data().Timer_training_dialog_delay,data().Timervalue_training_dialog_delay)
				else:
					system.notify_timer(data().Timer_training_dialog_delay,data().Timervalue_training_dialog_delay)
			else:
				system.notify_timer(data().Timer_training_dialog_delay,data().Timervalue_training_dialog_delay)

	elif id == data().Timer_training_dialog_delay_2:
		if data().training_delayed_dialog != "" and not dialog.is_dialog_active():
			
			if data().training_delayed_dialog == "SessionSix":
				dialogs.initDlg_038_Instructor_SessionSix()
			elif data().training_delayed_dialog == "SessionFive":
				dialogs.initDlg_037_Instructor_SessionFive()
			elif data().training_delayed_dialog == "SessionThree":
				dialogs.initDlg_035_Instructor_SessionThree()
			elif data().training_delayed_dialog == "ParcourEnd":
				dialogs.initDlg_040_Instructor_ParcourEnd()
			elif data().training_delayed_dialog == "ParcourCancelled":
				dialogs.initDlg_039_Instructor_ParcourCancelled()
				
			data().training_delayed_dialog = ""
		else:
			system.notify_timer(data().Timer_training_dialog_delay_2,data().Timervalue_training_dialog_delay_2)
		
		
		

	if (id == data().Timer_SpawnTimeChecker):
		clock = system.get_mission_time().get_day_time()
		if (clock >= time("06:00:00") and clock < time("22:00:00")):
			spawnanimals.spawnAnimals(INACTIVE)
		else:
			spawnanimals.spawnAnimals(ACTIVE)
		system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)

def on_wait_for_commando(id):
	if id in ["LUCAS","SEBASTIAN"]:
		schedules.set_approach_position(id)
	
	# Important: Set AlterEgoTalking only during cutscenes!
	#if (id == "ALTER_EGO" and system.is_cutscene() and data().AlterEgoTalking):
	#	objects.turn_to_object(id, "GUARD_CAMP_01")
	#	character.play_animation( "ALTER_EGO", "CM_NPC_STEHEN_KONVERSATION_%d" % random.randint( 1, 5 ) )
	#	return True
	# Execution
	############
	if ((data().Execution < 100)
			and	  (id in PRESIDENT_TEAM_IDS
				or id in NPC_IDS
				#or id in MERCENARY_IDS
				or id in ADDITIONAL_NPC_EXEIDS)):
		return False
	# No animations for PCs
	########################
	if id in system.get_pcs():
		return False
	# Idle Animations for GNO officials
	####################################
	if ((id in PRESIDENT_TEAM_IDS)
			and	(data().PresidentRun == -11)
			and (data().CompanionsLeave != 1)):
		character.play_animation(id, "CM_NPC_STEHEN_KONVERSATION_%d" % random.randint(1, 5))
		return True
	elif(id == "WESLEY" and data().WesleyTalking):
		character.play_animation(id, "CM_NPC_STEHEN_KONVERSATION_%d" % random.randint(1, 5))
		return True
	#elif(id == "GUARD_CAMP_01" and data().GuardCampTalking ):
	#	objects.turn_to_object(id, "ALTER_EGO")
	#	character.play_animation(id, "CM_NPC_STEHEN_KONVERSATION_%d" % random.randint(1, 5))
	#	return True
	# default schedule
	return schedules.Activity(id)

def can_examine_object( character_id, object_id ):
	if (object_id=="ZONE_1_BUILDING_489")and not data().training_weapons_taken:
		return True
	return False

def can_exchange( character_id, target_id, item_id, item_type ):
	#print "zone_1.can_exchange"
	if character_id == "ALTER_EGO" and item_id in data().training_weapons:
		return False
	return object_events.can_exchange( character_id, target_id, item_id, item_type )

def on_examine_object( character_id, object_id ):
	if (object_id == "ZONE_1_BUILDING_489") and not data().training_weapons_taken:
		dialogs.training_init_weapons()
		object_events.on_examine_object( character_id, object_id )
		return True
	return False

def initItems():
	if not hasattr(data(),"patch_patrick"):
		data().patch_patrick = 1

	# Fass am Eingang des Dorfes
	objects.create_item_in_inventory(	object="BUILDING_1716",equipment=["SET_WALTER_PPK"])
	# Kieshaufen
	objects.create_item_in_inventory(	object="BUILDING_1739",equipment=["SET_SMALL_SAND_SHOVEL"])
	# Auf dem Sandspielplatz
	system.create_object(equipmenttype="SET_AMMOPACK_7_65_MM",x=518,y=381,direction=47)
	# Holzplanken
	objects.create_item_in_inventory(	object="BUILDING_861",equipment=["SET_SAW"])
	# Waescheleine
	objects.create_item_in_inventory(	object="BUILDING_1771",equipment=["SET_LOW_SHOES"])
	# Waescheleine
	objects.create_item_in_inventory(	object="BUILDING_1757",equipment=["SET_LEATHER_CLOTHES"])
	# Waescheleine
	objects.create_item_in_inventory(	object="BUILDING_1754",equipment=["SET_NORMAL_CLOTHES_3"])
	# Holzkiste im Soeldnerlager
	objects.create_item_in_inventory(	object="BUILDING_1746",equipment=["SET_GUN_POWDER","SET_AMMOPACK_38"])
	# Fass im Soeldnerlager
	objects.create_item_in_inventory(	object="BUILDING_238",equipment=["SET_SPECIAL_38","SET_WIRE_WHISK"])
	# Muellkontainer beim Praesidenten-Haus
	objects.create_item_in_inventory(	object="BUILDING_1744",equipment=["SET_MEAT_RAW_TINY"])
	# Hang beim Präsidenten-Haus
	#system.create_object(equipmenttype="SET_BICYLE_SEAT",x=313,y=525,direction=47)
	# Hang beim Präsidenten-Haus
	system.create_object(equipmenttype="SET_LEATHER_GLOVES",x=320,y=526,direction=47)
	#NEU
	#Kistenstapel in Halle mit Händler
	objects.create_item_in_inventory(	object="THE FALL_BUILDING_3866",equipment=["SET_COLT_ANACONDA"])
	#Müll in Haus
	objects.create_item_in_inventory(	object="THE FALL_BUILDING_3864",equipment=["SET_GUN_POWDER"])
	#in Bett in Haus
	objects.create_item_in_inventory(	object="THE FALL_BUILDING_3956",equipment=["SET_SPECIAL_38"])
	# Kommode in Schlafsaal
	objects.create_item_in_inventory(	object="BUILDING_5948",equipment=["SET_AMMOPACK_38"])
	# im Raum des Gaestequartiers
	system.create_object(equipmenttype="SET_SMALL_PICTURE_FRAME",x=308.53,y=474.71,direction=47)
	# Kommode in Haus
	objects.create_item_in_inventory(	object="THE FALL_BUILDING_4162",equipment=["SET_WATER_BOTTLE"])
	
	
	## TA-NPC Items (Items für NPCs die auch sterben können)
	objects.create_item_in_inventory("KATHARINE",["SET_WIRE_WHISK","SET_RAT_MEAT"])
	#objects.create_item_in_inventory("WILMA",    [""])
	objects.create_item_in_inventory("HERB",     ["SET_STAPLE_GUN"])
	objects.create_item_in_inventory("AARON",    ["SET_NORMAL_CLOTHES_2", "SET_KNIFE"])
	objects.create_item_in_inventory("JON",      ["SET_NORMAL_CLOTHES_5"])
	objects.create_item_in_inventory("ORSON",    ["SET_BROKEN_POCKET_CALCULATOR"])
	
	# Händler
	objects.create_item_in_inventory("SEBASTIAN",
				[
				"SET_UZI",#Uzi
				"SET_COLT_ANACONDA",#Colt Anaconda
				"SET_SPECIAL_38",#38er Special
				"SET_BERETTA_92F",#Beretta
				# "SET_LANDMINE",#Landmine
				"SET_HEGRENADE",#HE granate
				"SET_MOLOTOV_COCKTAIL",#Molotov
				"SET_BASEBALL_BAT",#Baseballschläger
				"SET_RUSTY_IRON_ROD",#Rostiger Eisenstab
				"SET_BRASS_KNUCKLES",#Schlagring
				"SET_KNIFE",#Knife
				"SET_AMMOPACK_9_MM",#5 Packen 9mm Munition
				"SET_AMMOPACK_9_MM",
				"SET_AMMOPACK_9_MM",
				"SET_AMMOPACK_9_MM",
				"SET_AMMOPACK_9_MM",
				"SET_AMMOPACK_44",#1 Packen .44er Munition
				"SET_AMMOPACK_7_65_MM",#4 Packen 7,65mm Munition
				"SET_AMMOPACK_7_65_MM",
				"SET_AMMOPACK_7_65_MM",
				"SET_AMMOPACK_7_65_MM",
				"SET_AMMOPACK_38",#2 Packen .38er Munition
				"SET_AMMOPACK_38",
				"SET_AMMOPACK_45",
				"SET_AMMOPACK_45",
				"SET_LEATHER_CAP",#Lederkappe
				"SET_LEATHER_GLOVES",#Lederhandschuhe
				"SET_WATER_DETECTOR",#water_detector
				"SET_BREAD",#bread
				"SET_APPLE",#apple
				"SET_MEAT_RAW_TINY",#meat_raw_tiny
				"SET_MEAT_RAW_SMALL",#meat_raw_small
				"SET_WATER_SKIN",#3 x water_skin
				"SET_WATER_SKIN",
				"SET_WATER_SKIN",
				"SET_WATER_BOTTLE",#Water_bottle
				"SET_FLUTE",#Flute
				"SET_BEAR_SKIN",#Bear_skin
				"SET_TIGER_TEETH",#tiger_teet
				"SET_OINTMANT_JAR",#Salbentopf
				"SET_OINTMANT_JAR",#Salbentopf
				"SET_OINTMANT_JAR",#Salbentopf
				"SET_ANTIDOTE",#Gegengift
				"SET_GAS_CANISTER",# Benzinkanister
				"SET_PLIERS", # Zange um Dietrich zu bauen
				"SET_THROWING_KNIFE",
				"SET_LONG_LEATHER_STRAP",
				"SET_DART",
				"SET_GUN_POWDER",
				"SET_COAL_PILLS",
				"SET_PAN",
				"SET_SPIT"]
				)

	# Bienenstöcke Z1
	objects.create_item_in_inventory( 'BUILDING_10467', equipment=[ 'SET_BEESWAX' ] )
	objects.create_item_in_inventory( 'BUILDING_10464', equipment=[ 'SET_BEESWAX', 'SET_BEESWAX' ] )
	objects.create_item_in_inventory( 'BUILDING_10463', equipment=[ 'SET_BEESWAX' ] )
	
	# Items in Kisten
	objects.create_item_in_inventory( 'BUILDING_10251', equipment=[ 'SET_DUCT_TAPE', 'SET_GLOCK_21', 'SET_AMMOPACK_44' ] )
	objects.create_item_in_inventory( 'BUILDING_10252', equipment=[ 'SET_LEATHER_CLOTHES', 'SET_WATER_SKIN', 'SET_DRUGS_PILLS_01','SET_STEEL_PLATES' ] )
	objects.create_item_in_inventory( 'BUILDING_10281', equipment=[ 'SET_THROWING_KNIFE', 'SET_AMMOPACK_44', 'SET_LEATHER_GLOVES' ] )
	objects.create_item_in_inventory( 'BUILDING_10282', equipment=[ 'SET_WALTER_PPK', 'SET_AMMOPACK_45' ] )
	objects.create_item_in_inventory( 'BUILDING_10283', equipment=[ 'SET_BASEBALL_BAT', 'SET_GIANT_KNIFE', 'SET_BULLET_CATCH' ] )
	objects.create_item_in_inventory( 'BUILDING_10284', equipment=[ 'SET_SALT_ACID', 'SET_AK_47' ] )
	objects.create_item_in_inventory( 'BUILDING_10285', equipment=[ 'SET_AMMOPACK_7_65_MM', 'SET_AMMOPACK_38', 'SET_MEAT_RAW_TINY' ] )
	objects.create_item_in_inventory( 'BUILDING_10301', equipment=[ 'SET_WATERING_CAN', 'SET_MOLOTOV_COCKTAIL', 'SET_AMMOPACK_9_MM' ] )
	objects.create_item_in_inventory( 'BUILDING_10303', equipment=[ 'SET_BRASS_KNUCKLES' ] )
	objects.create_item_in_inventory( 'BUILDING_10304', equipment=[ 'SET_SPECIAL_38', 'SET_LOW_SHOES' ] )
	objects.create_item_in_inventory( 'BUILDING_10332', equipment=[ 'SET_LEATHER_CAP', 'SET_CALICO_M900' ] ) #, 'SET_LANDMINE'
	objects.create_item_in_inventory( 'BUILDING_5952', equipment=[ 'SET_LEATHER_CAP', 'SET_CALICO_M900',  'SET_MOLOTOV_COCKTAIL' ] ) 
	data().patch_patrick = 2
	objects.create_item_in_inventory( 'BUILDING_10251', equipment=[ 'SET_SHURIKEN'] )
	objects.create_item_in_inventory( 'BUILDING_10303', equipment='SET_DART' )
	objects.create_item_in_inventory( 'BUILDING_10282', equipment=[ 'SET_SHURIKEN'] )
	
	
def initHerbs():
	# Grab des Vaters
	system.create_object(equipmenttype="SET_ALOE_VERA", x=565.07, y=356.50)
	# Berg im SW
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=210.75, y=554.40)
	# Berg bei Grab
	system.create_object(equipmenttype="SET_ALOE_VERA", x=567.03, y=263.60)
	# Kuhle im NO (in Basis)
	system.create_object(equipmenttype="SET_ALOE_VERA", x=516.84, y=310.27)
	# Kuhle im NW (in Basis)
	system.create_object(equipmenttype="SET_ALOE_VERA", x=339.73, y=256.12)
	# neben Gaestehaus (bei Baeumen)
	system.create_object(equipmenttype="SET_ALOE_VERA", x=295.00, y=507.44)
	
def initExitZones():
	system.add_region( id = "REGION_EXIT_NORD", x1 = 0.00, y1 = 0.00, x2 = 799.00, y2 = 209.3 )
	system.register_exit(regionname = "REGION_EXIT_NORD" )
	system.add_region( id = "REGION_EXIT_SUED", x1 = 799.00, y1 = 799.00, x2 = 200.00, y2 = 590.0 )
	system.register_exit(regionname = "REGION_EXIT_SUED" )
	system.add_region( id = "REGION_EXIT_WEST", x1 = 0.00, y1 = 799.00, x2 = 200.00, y2 = 209.3 )
	system.register_exit(regionname = "REGION_EXIT_WEST" )
	system.add_region( id = "REGION_EXIT_OST", x1 = 799.00, y1 = 209.3, x2 = 578.00, y2 = 590.0 )
	system.register_exit(regionname = "REGION_EXIT_OST" )

def initMinimapMarkers():
	pass

def initFX():
	
	if was_zone_entered("zone_8.zone_8"):
		return True
	#	Lagerfeuer beim Söldnercamp
	fxLagerFeuer("BUILDING_80")
	#	Lagerfeuer beim Spielplatz
	fxLagerFeuer("BUILDING_868")
	#	Brennende Tonne beim Drill Instructor Gelände
	fxBrennendeTonne("BUILDING_561")
	#	Brennende Tonnen am Eingang zur Stadt
	fxBrennendeTonne("BUILDING_1008")
	fxBrennendeTonne("BUILDING_2151")
	fxBrennendeTonne("BUILDING_2148")
	fxBrennendeTonne("BUILDING_2149")
	return None
	

## Feuereffekte: brennende Tonne
def fxBrennendeTonne(_objectid):
	#system.start_effect_object(object=_objectid,node="sort0",parameter=fx_smoke_brennende_tonne)
	system.start_effect_object(object=_objectid,node="sort1",parameter=fx_fire_brennende_tonne)
	sounds.play_3d_sound_object(sfx_id="campfire_small",object=_objectid,loop=True)

## Feuereffekte: Lagerfeuer
def fxLagerFeuer(_objectid):
	system.start_effect_object(object=_objectid,node="effekt_feuer",parameter=fx_fire_lagerfeuer)
	#system.start_effect_object(object=_objectid,node="effekt_feuer",parameter=fx_smoke_lagerfeuer)
	system.start_effect_object(object=_objectid,node="effekt_feuer01",parameter=fx_fire_lagerfeuer_01)
	system.start_effect_object(object=_objectid,node="effekt_feuer02",parameter=fx_fire_lagerfeuer_02)
	system.start_effect_object(object=_objectid,node="effekt_feuer03",parameter=fx_fire_lagerfeuer_03)
	system.start_effect_object(object=_objectid,node="effekt_feuer04",parameter=fx_fire_lagerfeuer_04)
	sounds.play_3d_sound_object(sfx_id="campfire_big",object=_objectid,loop=True)

def on_pick_up( character_id, item_id, item_type ):
	if item_id in data().training_weapons:
		if not data().training_weapons_taken:
			data().training_weapons_taken = True
			data().has_training_weapons = True
			data().training_break_early = False
			system.notify_region_entered(region="REGION_TUTORIAL_EXIT_2", objectid="ALTER_EGO")
			#dialogs.initDlg_034_Instructor_SessionTwo()
			system.notify_timer(data().Timer_training_dialog_delay,data().Timervalue_training_dialog_delay)

	return object_events.on_pick_up( character_id, item_id, item_type)

def on_object_killed(victim, attacker, weapon_type, weapon_id, victims_party):
	
	if victim in [	'ZONE_1_BUILDING_2058','ZONE_1_BUILDING_2059','ZONE_1_BUILDING_2060',
					'ZONE_1_BUILDING_2061','ZONE_1_BUILDING_2062','ZONE_1_BUILDING_2063',
					'ZONE_1_BUILDING_2064']:
						
		# wenn pappkamerad schon umgefallen ist
		if objects.get_immortal_state(victim):
			object_events.on_object_killed(victim, attacker, weapon_type, weapon_id, victims_party)
			return
		
		objects.set_immortal_state(victim, True)
		objects.play_animation(victim, 'ANIM_PAPPKAMERAD')
		
		data().training_aims_hit += 1
		
		#first parcelle done
		if data().training_aims_hit == 2:
			data().training_sector_done += 1
			if not dialog.is_dialog_active():
				dialogs.initDlg_035_Instructor_SessionThree()
			else:
				data().training_delayed_dialog = "SessionThree"
				system.notify_timer(data().Timer_training_dialog_delay_2,data().Timervalue_training_dialog_delay_2)
			
		
		#last hidden aim hit
		if victim == 'ZONE_1_BUILDING_2063':
			data().training_aim_7_killed = True
		
		#all aims hit
		if data().training_aims_hit >= 7:
			if not dialog.is_dialog_active():
				dialogs.initDlg_038_Instructor_SessionSix()
			else:
				data().training_delayed_dialog = "SessionSix"
				system.notify_timer(data().Timer_training_dialog_delay_2,data().Timervalue_training_dialog_delay_2)
				try:
					dialog.jump_to("ENDDIALOG","DH_D_Instructor_SessionFour_2")
				except:
					pass
			
		#one aim to go
		elif data().training_aims_hit == 6:
			if not data().training_aim_7_killed:
				if not dialog.is_dialog_active():
					dialogs.initDlg_037_Instructor_SessionFive()
				else:
					data().training_delayed_dialog = "SessionFive"
					system.notify_timer(data().Timer_training_dialog_delay_2,data().Timervalue_training_dialog_delay_2)
				try:
					dialog.jump_to("ENDDIALOG","DH_D_Instructor_SessionFour_2")
				except:
					pass
				
		
	if victim == "WESLEY":
		data().wesley_killed = True
		system.start_cutscene()
		enemy_script.delay(4, Lambda('dialogs.init_ego_hayes()'))
		enemy_script.delay(3.5, Lambda('system.fade(FADE_OUT)'))
	
	object_events.on_object_killed(victim, attacker, weapon_type, weapon_id, victims_party)

def can_leave_zone():
	return (data().map_available and not system.in_combat_mode())
	
def can_leave_zone_context_menu():
	if data().wesley_hat_gestanden and not is_zone_enabled("zzone_3"):
		return False
		
	if not data().training_finish:
		return False
	
	return True
	
def on_trade(target,operator):
	if not object_events.on_trade(target,operator):
		return False
	lambda_string = 'system.trading_screen(trader="%s",char="%s")' %(target,operator)
	location = get_location(target)
	objects.cancel_commandos(target)
	
	if target=="SEBASTIAN":
		if location == 1:
			prohibit_activity(target)

	objects.turn_to_object(operator, target)
	objects.turn_to_object(target, operator, callback=["ONEND", Lambda(lambda_string)])
	return None

def on_exit_trader( trader_id, negotiator_id, profit ):
	if trader_id=="SEBASTIAN":
		allow_activity(trader_id)
	return object_events.on_exit_trader( trader_id, negotiator_id, profit)

# 
def InitChestsSafes():
	objects.add_closed_lock("BUILDING_10251", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_10252", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_10281", "lock1", closure_type='lock-trap')
	objects.add_closed_lock("BUILDING_10282", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_10283", "lock1", closure_type='poison-trap')
	objects.add_closed_lock("BUILDING_10284", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_10285", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_10301", "lock1", closure_type='lock-trap')
	objects.add_closed_lock("BUILDING_10303", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_10304", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_10332", "lock1", closure_type='normal')
	
def can_enter_building( character_id, building_id ):
	if building_id == "ZONE_1_BUILDING_4078":
		if character_id in system.get_pcs():
			return False
	return object_events.can_enter_building( character_id, building_id )	

def on_weapon_ignition(weapon_id=None,weapon_type = None,startx = 0,starty = 0,startz = 0,endx = 0,endy = 0,endz = 0):
	#print 'on_weapon_ignition(',weapon_type, startx, starty, startz, endx, endy, endz,')'
	for id in [	'ZONE_1_BUILDING_2058','ZONE_1_BUILDING_2059','ZONE_1_BUILDING_2060',
				'ZONE_1_BUILDING_2061','ZONE_1_BUILDING_2062','ZONE_1_BUILDING_2063',
				'ZONE_1_BUILDING_2064']:
		if objects.get_distance_to_position(id, startx, starty) < 4:
			objects.set_attribute(id, 'hitpoints', 0)
			on_object_killed(id, 'ALTER_EGO', "", weapon_type, None)
	weapon_events.on_weapon_ignition(weapon_type,startx,starty,startz,endx,endy,endz)

def can_steal_from(thief, victim):
	WACHEN = ['PRESIDENT_GUARD_01', 'PRESIDENT_GUARD_02', 
			  'GUARD_CAMP_01', 'GUARD_CAMP_02', 
			  'GUARD_QUARTERS_01', 'GUARD_QUARTERS_02',
			  'GENE', 'LINDA_Z1', 'CARL_Z1', 'FRANK', 'WALLY']
	if victim in WACHEN:
		return False
	else:
		return object_events.can_steal_from(thief, victim)

def on_steal(target, operator):
	
	if (objects.get_attribute(operator, "pick_pocket") >= 70) and target == "PRESIDENT_HAYES":
		if not objects.exists("HAYES_SUPERLW"):
			objects.create_item_in_inventory('PRESIDENT_HAYES', 'SET_SUPERLW', "HAYES_SUPERLW")
		
	object_events.on_steal(target, operator)
		
def init_patch():
	if "ANIE" in system.get_npcs():
		if objects.is_active("ANIE"):
			data("zone_7.zone_7").anie_folgt = True
	
	if not hasattr(data('zone_6.zone_6'), 'QB_001'):
		data('zone_6.zone_6').QB_001 = -1
	if data('zone_6.zone_6').QB_001 == -1:
		data('zone_6.zone_6').QB_001 = system.register_qb_entry_ex(id_name='ZONE6_AIM_01_NAME',id_desc='ZONE6_AIM_01_DESC',id_short_desc='ZONE6_AIM_01_SHORT_DESC',id_location='ZONE6_AIM_01_LOCATION',id_reward='ZONE6_AIM_01_REWARD')
	
	character.set_approachable_state("UNDEAD_1",NOTAPPROACHABLE)
	character.set_approachable_state("UNDEAD_2",NOTAPPROACHABLE)
	character.set_approachable_state("UNDEAD_3",NOTAPPROACHABLE)
	init_main_npcs()
	if objects.has_attribute("BUILDING_4078", "locked" ):
		objects.remove_closed_lock_by_name("BUILDING_4078", "lock1")
		objects.remove_closed_lock_by_name("BUILDING_4078", "lock2")
	# in old savegames the president is to early 
	if data().Phoenix_Info and not data().wesley_hat_gestanden:
		for i in [0,1,2]:
			objects.set_active_state(PRESIDENT_TEAM_IDS[i],0)
	
	if data().wesley_hat_gestanden and not "zzone_3" in sys.data.zone_enabled:
		for i in [0,1,2]:
			objects.set_active_state(PRESIDENT_TEAM_IDS[i],1)
			
	if data().training_activated:
		for id in [	'ZONE_1_BUILDING_2058','ZONE_1_BUILDING_2059','ZONE_1_BUILDING_2060',
					'ZONE_1_BUILDING_2061','ZONE_1_BUILDING_2062','ZONE_1_BUILDING_2063',
					'ZONE_1_BUILDING_2064']:
						if objects.get_attribute(id, 'hitpoints') >= 1:
							objects.set_immortal_state(id, False)
							
	training_aims_hit_temp = 0
	for victim in [	'ZONE_1_BUILDING_2058','ZONE_1_BUILDING_2059','ZONE_1_BUILDING_2060',
					'ZONE_1_BUILDING_2061','ZONE_1_BUILDING_2062','ZONE_1_BUILDING_2063',
					'ZONE_1_BUILDING_2064']:
		# wenn pappkamerad schon umgefallen ist
		if objects.get_immortal_state(victim):
			training_aims_hit_temp += 1
	if not data().training_aims_hit >= training_aims_hit_temp:
		data().training_aims_hit = training_aims_hit_temp
	
	for animal in ['ANTILOPE_1', 'ANTILOPE_2', 'ANTILOPE_3']:
		if not objects.has_attribute(animal, 'foes'):
			objects.set_attribute(animal, 'foes', ['UISPIELER'])
		else:
			if not 'UISPIELER' in objects.get_attribute(animal, 'foes'):
				objects.set_attribute(animal, 'foes', ['UISPIELER'])
	
	# Zusaetzliche Ende Region fuers Training
	if not hasattr(data(),"has_training_weapons"):
		system.add_region("REGION_TUTORIAL_EXIT_2",317,326,321,317)
		data().has_training_weapons = False
		data().training_break_early = False
		for wp in data().training_weapons:
			for pc in system.get_pcs():
				if objects.count_in_inventory(pc, wp):
					data().has_training_weapons = True
					break

	if not hasattr(data(), "patch_patrick"):
		objects.create_item_in_inventory("SEBASTIAN",["SET_OINTMANT_JAR","SET_OINTMANT_JAR","SET_OINTMANT_JAR","SET_ANTIDOTE"])
		objects.create_item_in_inventory( 'BUILDING_10251', equipment=[ 'SET_SHURIKEN', 'SET_THROWING_KNIFE' ] )
		objects.create_item_in_inventory( 'BUILDING_10303', equipment='SET_DART' )
		objects.create_item_in_inventory( 'BUILDING_10282', equipment=[ 'SET_SHURIKEN', 'SET_DART' ] )
		data().patch_patrick = 2
	else:
		if not data().patch_patrick:
			data().patch_patrick = 1
			objects.create_item_in_inventory("SEBASTIAN",["SET_OINTMANT_JAR","SET_OINTMANT_JAR","SET_OINTMANT_JAR","SET_ANTIDOTE"])
		if data().patch_patrick < 2:
			data().patch_patrick = 2
			objects.create_item_in_inventory( 'BUILDING_10251', equipment=[ 'SET_SHURIKEN', 'SET_THROWING_KNIFE' ] )
			objects.create_item_in_inventory( 'BUILDING_10303', equipment='SET_DART' )
			objects.create_item_in_inventory( 'BUILDING_10282', equipment=[ 'SET_SHURIKEN', 'SET_DART' ] )
	
	if not objects.has_attribute("SEBASTIAN", "voice_id"):
		objects.set_attribute("SEBASTIAN", "voice_id", "trader_02")
		
		
	# Training Updates
	if not hasattr(data(), "training_updates"):
		data().training_updates = True
		data().Timer_training_dialog_delay = 20
		data().Timervalue_training_dialog_delay = 2 * 1000
		data().Timer_training_dialog_delay_2 = 21
		data().Timervalue_training_dialog_delay_2 = 1 * 1000
		data().training_delayed_dialog = ""
		
		import globaltext
		#Dialog Dummy
		system.create_character(
			id="DRILL_DUMMY",
			gender="male",
			party="DORFBEWOHNER",
			x=322,
			y=326,
			name=globaltext.NAME_DRILL_INSTRUCTOR,
			direction = 90,
			resourceui="drill_instructor.png" )
			
		objects.set_position_free("DRILL_DUMMY",300,300,300)
		objects.set_attribute("DRILL_DUMMY", "faction", "VILLAGE_PEOPLE")
		objects.set_attribute("DRILL_DUMMY", "level", 1 )
		objects.set_attributes("DRILL_DUMMY",
			model="low",
			gender="male",
			skin="white",
			clothes="ll_gno_guard",
			face="drill_instructor")
		character.update_appearance("DRILL_DUMMY")
		character.scale("DRILL_DUMMY",1.85)
		objects.set_active_state("DRILL_DUMMY",False)
		
		#Savegame problems
		#if (hasattr("DRILLINSTRUCTOR","approachable") and 
		#	objects.get_attribute("DRILLINSTRUCTOR","approachable") == False and 
		#	not data().training_activated):
		#	system.notify_timer(data().Timer_training_dialog_delay,data().Timervalue_training_dialog_delay)
	
	if not hasattr(data('zone_1.zone_1'), 'QB_006'):
		data().QB_006 = system.register_qb_entry('ZONE1_AIM_06', id_history = 'ZONE1_AIM_01')
		system.set_qb_entry_state(data("zone_1.zone_1").QB_006, INACTIVE)
	
def init_main_npcs():
	npcs = system.get_npcs()
	if "SEBASTIAN" in npcs:
		character.set_main_quest_npc_state(char="SEBASTIAN", state=True)

# Pappkameraden umwerfen(Molotov)
def do_throw_weapon_fx(pShooter,pWeapon,pTarget,fTargetX,fTargetY,fTargetZ):
	weapon_events.do_throw_weapon_fx(pShooter,pWeapon,pTarget,fTargetX,fTargetY,fTargetZ)
	for id in [	'ZONE_1_BUILDING_2058','ZONE_1_BUILDING_2059','ZONE_1_BUILDING_2060',
					'ZONE_1_BUILDING_2061','ZONE_1_BUILDING_2062','ZONE_1_BUILDING_2063',
					'ZONE_1_BUILDING_2064']:
		if objects.get_distance_to_position(id, fTargetX, fTargetY) < 4:
			objects.set_attribute(id, 'hitpoints', 0)
			on_object_killed(id, pShooter, "", pWeapon, None)

def on_party_left( character_id ):
	object_events.on_party_left(character_id)
	#if character_id in ["MERCENARY_AGNES","MERCENARY_CARMEN","MERCENARY_VASQUEZ","MERCENARY_IVANA","MERCENARY_SALLY","MERCENARY_BUTCH","MERCENARY_FRANCIS","MERCENARY_VICTOR"]:
	daily_routine.allow_activity(character_id)
	on_wait_for_commando(character_id)


