# -*- coding: utf-8 -*-
from global_defines import *
import dialogs
import npc
import debug
import const
from const import *
import schedules
import water
import object_events
import enemy_script
import sounds
import char_autogeneration
import random
import daily_routine
import vehicle
import dynamic_camera
import skies
import dialog
import spawnanimals


#*********************************************************************
#	aktuelle revison: Revision 37, 6.09.2004
# TODO: TA Doris - Spaziergang, TA Falk - Spaziergang
# - JUDY braucht ein Haus und dann gibts auch ihren TA (der ist noch gar nicht (bis auf die Struktur) vorhanden)
# - TYRON: Im Dorf herumlaufen und mit potentiellen Wählern reden (z.B. Judy und Jaffar)(auf JUDYs Haus warten)
#*********************************************************************


################################################################################
### Initialisierung ############################################################
################################################################################

### initParties
################
def initParties():
	system.create_party(id="UISPIELER",type=PT_HUMAN)
	system.create_party(id="NPCS",type=PT_COMPUTER)
	system.create_party(id="RATSKULLS_DROGENLABOR",type=PT_COMPUTER)
	system.create_party(id="RATSKULLS_GEISELCAMP",type=PT_COMPUTER)
	system.create_party(id="ADRIAN",type=PT_COMPUTER)
	system.create_party(id="ANIMALS",type=PT_COMPUTER)
	system.create_party(id="ZOO",type=PT_COMPUTER)

### initRegions
#################
def initRegions():
	############
	# Regionen #
	#############
	# Übersicht:
	#
	# Region_Colins_Dad:  Beim betreten greifen die Hyänen den Spieler an
	# Region_Hostagecamp: Region um das Geiselcamp die das frühe Betreten
	#					  verindert (in const definiert)
	# Region_Hostages_Close: Region um die Geiseln, in der sie angesprochen werden
	#					  Wenn alle Bewacher tot sind
	# Region_Fort_Gate:   Region vor dem Tor des RS-Stützpunktes, dient zum
	#					  Triggern von Passwortdialogen
	# atack-region um den Leichnahm von Colins Vater (x=424 y=237)
	
	system.add_region("REGION_JIMBOB",665,305,685,340)
	
	system.add_region("REGION_WOHNWAGEN_LEILA",348.07, 460.12, 318.20, 484.11)#665,305,685,340)

	system.add_region("REGION_NIGEL",515,565,525,575)
	system.notify_region_entered(region="REGION_NIGEL", objectid="ALTER_EGO")
	
	system.add_region("GEISEL_LAGER",214,496,299,588)
	system.notify_region_entered("GEISEL_LAGER", partyid="UISPIELER")
	
	system.add_region("Region_Colins_Dad", 405, 218, 443, 256)
	system.notify_region_entered(region="Region_Colins_Dad", partyid="UISPIELER")
	system.add_region("Region_Hostagecamp", const.Region_Hostagecamp[0],
										   const.Region_Hostagecamp[1],
										   const.Region_Hostagecamp[2],
										   const.Region_Hostagecamp[3])
	system.notify_region_entered(region="Region_Hostagecamp", partyid="UISPIELER")
	system.add_region("Region_Fort_Gate", 303, 379, 327, 364)
	
	system.add_region("Region_Fort_Gate_SAVEGAME", 303, 379, 327, 364)
	system.notify_region_entered(region="Region_Fort_Gate_SAVEGAME", partyid="UISPIELER")
	data().Region_Fort_Gate_Angelegt = True
	
	system.notify_region_entered(region="Region_Fort_Gate", partyid="UISPIELER")
	system.add_region("Region_Hostages_Close", 254, 545, 240, 567)
	# system.notify_region_entered(region="Region_Hostages_Close", partyid="UISPIELER")
	# Tierareale
	#system.add_region(data().Region_Hirsche1  ,345,485,455,560)
	#system.add_region(data().Region_Hirsche2  ,785,485,715,390)
	#system.add_region(data().Region_Woelfe    ,515,295,455,335)
	pt  = objects.get_position(const.OBJECT_THRESHER)
	pc  = objects.get_position("CHUCK")
	pfa = objects.get_position(const.OBJECT_FIRE_ALERT)
	system.add_region("REGION_THRESNER", pt[0]-10, pt[1]-10, pt[0]+10,pt[1]+10)
	system.add_region("REGION_CHUCK", pc[0]-7, pc[1]-7, pc[0]+7, pc[1]+7)
	system.add_region("REGION_FIRE_ALERT", pfa[0]-7, pfa[1]-7, pfa[0]+7, pfa[1]+7)
	
### initWaterResources
#######################
def initWaterResources():
	water.set_water_source(554.7,301.3, 4)
	water.set_water_source(582.0,554.0, 3)
	water.set_water_source(309.6,443.6, 2)
	
### initExitZones
##################
def initExitZones():
	# die Namen hier müssen nicht unbedingt mit den Richtungen übereinstimmen ;-)
	system.add_region(id= "REGION_EXIT_NORD",  x1=1000, y1= 799, x2= 810, y2=   0)
	system.add_region(id= "REGION_EXIT_SUED",  x1= 210, y1= 799, x2=   0, y2=   0)
	system.add_region(id= "REGION_EXIT_WEST1", x1= 810, y1= 799, x2= 532, y2= 590)
	system.add_region(id= "REGION_EXIT_WEST2", x1= 494, y1= 799, x2= 532, y2= 600)
	system.add_region(id= "REGION_EXIT_WEST3", x1= 494, y1= 799, x2= 210, y2= 590)
	system.add_region(id= "REGION_EXIT_OST",   x1= 810, y1= 210, x2= 210, y2=   0)
	system.register_exit(regionname = "REGION_EXIT_NORD")
	system.register_exit(regionname = "REGION_EXIT_SUED")
	system.register_exit(regionname = "REGION_EXIT_WEST1")
	system.register_exit(regionname = "REGION_EXIT_WEST2")
	system.register_exit(regionname = "REGION_EXIT_WEST3")
	system.register_exit(regionname = "REGION_EXIT_OST")

### initEquipment
##################
## Equipment für NPCs die auch sterben können (TAs und Nebenquest)
def initEquipment():
	if not hasattr(data(),"patch_patrick"):
		data().patch_patrick = 1
	# Nebenquest NPCs
	objects.create_item_in_inventory("NIGEL",  ["SET_NORMAL_CLOTHES_4","SET_LEATHER_BOOTS"])
	objects.create_item_in_inventory("WILLIAM",["SET_NORMAL_CLOTHES_6","SET_BOTTLE_OF_WHISKEY"])
	objects.create_item_in_inventory("ADRIAN", ["SET_LOW_SHOES","SET_WATER_SKIN","SET_TIN_CAN"])
	objects.create_item_in_inventory("COLIN",  ["SET_GAME_JOY"])
	# TA NPCs Casa Verde
	objects.create_item_in_inventory("FRED",   ["SET_HYENA_PELT"])
	objects.create_item_in_inventory("TIM",    ["SET_NORMAL_CLOTHES_2","SET_POWER_DRILL"])
	objects.create_item_in_inventory("RUDOLPH",["SET_SPECIAL_38","SET_AMMOPACK_38"])
	objects.create_item_in_inventory("MARY",   ["SET_LEATHER_BOOTS"])
	objects.create_item_in_inventory("CAREN",  ["SET_LOW_SHOES","SET_HAIRSTYLE_MAGAZINE"])
	objects.create_item_in_inventory("ELVIRA", ["SET_NORMAL_CLOTHES_2","SET_LEATHER_CAP"])
	#objects.create_item_in_inventory("HULDA",  [""])
	objects.create_item_in_inventory("JON",    ["SET_NORMAL_CLOTHES_4"])
	# TA NPCs Hayden Valley
	objects.create_item_in_inventory("TOM",    ["SET_NORMAL_CLOTHES_3"])
	objects.create_item_in_inventory("ANDY",   ["SET_NORMAL_CLOTHES_6"])
	objects.create_item_in_inventory("STEVEN", ["SET_NORMAL_CLOTHES_5","SET_LEATHER_BOOTS"])
	objects.create_item_in_inventory("PEGGY",  ["SET_CAKE_TIN","SET_WIRE_WHISK"])
	objects.create_item_in_inventory("SHEILA", ["SET_NORMAL_CLOTHES_1","SET_LOW_SHOES"])
	objects.create_item_in_inventory("DOROTHY",["SET_LEATHER_BOOTS","SET_TENT_CANVAS"])
	objects.create_item_in_inventory("SUSAN",  ["SET_NORMAL_CLOTHES_2","SET_LOW_SHOES"])
	objects.create_item_in_inventory("MATTHEW",["SET_SMALL_STOOL"])
	
	####################
	# Händlerinventare #
	####################
	# Gene: (Allroundhändler)
	objects.create_item_in_inventory("GENE", 
		[
		"SET_MP5",# MP5
		"SET_COLT_45",# Colt 45er
		"SET_COLT_ANACONDA",# Colt Anaconda
		"SET_HK_USP_45",# HK USP 45
		"SET_BIG_KNIFE",# Großes Messer
		"SET_M14", #schlechte schw. Waffe
		"SET_REMINGTON_M870"] #Shotgun
		+ ["SET_AMMOPACK_9_MM"] * 8 # 8 Packen 9mm Munition
		+ ["SET_AMMOPACK_9_MM_SUBSONIC"] * 2 # 2 Packen 9mm Subsonicmunition
		+ ["SET_AMMOPACK_50"] * 4 # 4 Packen .50AE Munition
		+ ["SET_AMMOPACK_5_56_MM"] * 2 # 2 Packen 5,56 Munition
		+ ["SET_AMMOPACK_44_CORBON"] * 4 # 4 Packen .44er Munition
		+ ["SET_AMMOPACK_45"] * 6 # 6 Packen .45er Munition
		+ ["SET_AMMOPACK_45_SUBSONIC"] # 1 Packen .45er Subsonicmunition
		+ ["SET_AMMOPACK_2_12_MM"] # 7 Packen 2“12Cal
		+ ["SET_AMMOPACK_5_45_MM"] * 2 # 2 Packen 5.45 mm Russisch
		+ ["SET_AMMOPACK_7_62SOVJET_MM"] * 3 # 2 Packen Russische Muni
		+ ["SET_AMMOPACK_7_62NATO_MM"] * 2 # 2 Packen Nato Muni
		+ ["SET_AMMOPACK_7_62_54_MMR"] # Drakunov Muni
		+ ["SET_MEAT_COOKED_HUMONGOUS"] # meat_cooked_humongous
		+ ["SET_MEAT_RAW_HUMONGOUS"] # meat_raw_humongous
		+ ["SET_MEAT_RAW_BIG"] * 2 # 2 x meat raw big
		+ ["SET_MEAT_COOKED"] * 2 # 2 x meat_cooked
		+ ["SET_MEAT_RAW"] * 4 # 4 meat_raw
		+ ["SET_BREAD"] * 3 # 3 x bread
		+ ["SET_CHEESE"] * 2 # 2 x Käse
		+ ["SET_WATER_SKIN"] * 5 # 5 x water_skin
		+ ["SET_MEDIPACK_SMALL"] * 4 # 4 x medipack_small
		+ ["SET_MEDIPACK_BIG"] * 2 # 2 x medipack_big
		+ ["SET_CHAIN_MAIL",# Kettenhemd
		"SET_LEATHER_CAP",# Lederkappe
		"SET_APPLE",# apple
		"SET_WATER_BOTTLE",# water_bottle
		"SET_DRUGS_PILLS_02",# drugs_pills_02
		"SET_DRUGS_SYRINGE",# drugs_syringe
		"SET_DRUGS_VIALS_01",# drugs_vials_01
		"SET_PITCHER",# pitcher
		"SET_GARLIC_PRESS",# garlic_press
		"SET_TENT_CANVAS",# tent_canvas
		"SET_WATER_DETECTOR",# water_detector
		"SET_OINTMANT_JAR",# 3 x ointment_jar
		"SET_OINTMANT_JAR",
		"SET_OINTMANT_JAR",
		"SET_STEEL_PLATES",
		"SET_LONG_LEATHER_STRAP",
		"SET_ANTIDOTE",# antidote
		"SET_GUN_POWDER",
		"SET_GUN_POWDER",
		"SET_GAS_CANISTER",# Benzinkanister
		"SET_GAS_CANISTER",# Benzinkanister
		"SET_PAN",
		"SET_POT_ON_A_BAR"]
		 )

def make_miles_trader():
	# Miles: (Waffenhändler)
	objects.create_item_in_inventory("MILES",
		[
		"SET_STEYR_TMP_W_SILENCER",# TMP Silent
		"SET_DESERT_EAGLE_W_LASERPOINTER",# Desert Eagle
		"SET_SPAS_15",
		"SET_AUTOMAG_3",# Automag
		"SET_MAC_10",# Steyr TMP
		"SET_AK_47",# AK47
		"SET_PSG_1",# PSG-1 (sniper)
		"SET_M_16", # M 16 (schw)
		"SET_SIG_SG_552", # Sig(schw)
		"SET_KNIFE",# Messer
		"SET_MANSLAYER", #nette Nahkampfwaffe
		"SET_THROWING_KNIFE",
		"SET_SHURIKEN",# Shurrikan
		"SET_C4_TIMEBASED"] #explosives
		+ ["SET_AMMOPACK_9_MM"] * 5 # 5 Packen 9mm Munition
		+ ["SET_AMMOPACK_9_MM_SUBSONIC"] * 3 # 3 Packen 9mm Subsonicmunition
		+ ["SET_AMMOPACK_9_MM_DUMDUM"] * 4 # 4 9mm Dumdum
		+ ["SET_AMMOPACK_45"] * 5 # 45 Dumdum
		+ ["SET_AMMOPACK_45_DUMDUM"] * 3 # 45 Dumdum
		+ ["SET_AMMOPACK_45_SUBSONIC"] * 3 # 45 Silent
		+ ["SET_AMMOPACK_44"] * 4 # 44er Muni
		+ ["SET_AMMOPACK_50_AE_DUMDUM"] * 6 # 6 Packen .50AE Munition
		+ ["SET_AMMOPACK_5_7_MM"] * 5 # 5 Packen 5.7 mm
		+ ["SET_AMMOPACK_2_12_MM"] * 6 # 6 Packen Shotgunshells
		+ ["SET_AMMOPACK_2_12_MM_QB_8"] * 3 # Spezial Shotgun
		+ ["SET_AMMOPACK_7_62NATO_MM"] * 4 # 4 Packen 7,62x51 nato Munition
		+ ["SET_AMMOPACK_7_62NATO_MM_DUPLEX"] #  Packen  7,62x51 nato Duplex
		+ ["SET_AMMOPACK_7_62NATO_MM_SABOT"] # Nata spezial
		+ ["SET_AMMOPACK_5_56_MM"] * 12 # 12 Packen 5,56 Munition
		+ ["SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE"] * 3 # Packen 5,56 Spezial
		+ ["SET_AMMOPACK_7_62SOVJET_MM"] * 5 # 5 Packen 7,62x39 sovjet Munition
		+ ["SET_AMMOPACK_5_45_MM"] * 5 # 5 PAcken Russische 5.45
		+ ["SET_AMMOPACK_50_BMG"] * 2 # Barret Muni
		+ ["SET_AMMOPACK_3_12_MM"] * 2 # Caw Shotgunshells
		+ ["SET_AMMOPACK_7_62_54_MMR"] * 2 # Drakunov
		+ ["SET_AMMOPACK_LASER_GUN"] # Laser Gun
		+ ["SET_HEGRENADE"] * 4 # leichte Granaten
		+ ["SET_FRAGGRENADE"] * 2 # schw Granaten
		+ ["SET_REMOTE_FUSE"] * 3 # Zünder: falls man doch mal Sprengstoff bauen kann
		+ ["SET_RASP",
		"SET_LEATHER_GLOVES",# Lederhandschuhe
		"SET_BULLET_PROOF_CLOTHES",
		"SET_STEEL_CLAD_BOOTS",
		"SET_PLATE_GLOVES"]# Plattenhandschuhe
		)

### initItems
##############
def initItems():
	if not hasattr(data(), "patch_patrick"):
		data().patch_patrick = 2
	# in Blumentopf bei Friseur
	objects.create_item_in_inventory(object='BUILDING_3505', equipment=["SET_RED_SHARD"])
	# an Waescheleine bei Maren
	objects.create_item_in_inventory(object='BUILDING_479', equipment=["SET_NORMAL_CLOTHES_3"])
	# bei Schrotthaufen
	objects.create_item_in_inventory(object='BUILDING_427', equipment=["SET_STAPLE_GUN"])
	objects.create_item_in_inventory(object='BUILDING_15617', equipment=["SET_MEAT_RAW"])
	objects.create_item_in_inventory(object='BUILDING_520', equipment=["SET_BATTERY"]) #TODO: verschliessen
	system.create_object(equipmenttype="SET_BROKEN_SHOVEL", x = 692.16, y = 331.21)
	system.create_object(equipmenttype="SET_BICYCLE_SEAT", x = 686.28, y = 331.31)
	system.create_object(equipmenttype="SET_POWER_DRILL", x = 687.90, y = 343.60)
	system.create_object(equipmenttype="SET_GRAPHICS_CARD", x = 680.78, y = 335.35)
	# Kommode in Haus ???
	objects.create_item_in_inventory(object='BUILDING_9674', equipment=["SET_SHURIKEN"])
	# Holzscheite bei Haus ???
	objects.create_item_in_inventory(object='BUILDING_482', equipment=["SET_RUSTY_IRON_ROD"])
	# Kistenstapel bei Chuck
	objects.create_item_in_inventory(object='BUILDING_4055', equipment=["SET_WATER_SKIN", "SET_SPADE"]) #TODO: verschliessen
	# grosses Gebaude im oberen Dorf
	system.create_object(equipmenttype="SET_AMMOPACK_4_6_MM", x = 523.73, y = 465.09)
	# in Hundehuette bei Saeufer
	objects.create_item_in_inventory(object='BUILDING_3784', equipment=["SET_MEAT_RAW_SMALL"])
	# Ruine im oberen Dorf
	system.create_object(equipmenttype="SET_COOKING_POT", x = 509.54, y = 529.57)
	# Marktplatz
	objects.create_item_in_inventory(object='BUILDING_3765', equipment=["SET_DART"])
	objects.create_item_in_inventory(object='BUILDING_3746', equipment=["SET_AMMOPACK_5_7_MM"])
	objects.create_item_in_inventory(object='BUILDING_3775', equipment=["SET_TRASH_CAN"])
	# Muelltonne/Muellsack bei Marktplatz
	objects.create_item_in_inventory(object='BUILDING_3747', equipment=["SET_HAIR_DRYER"])
	# Schrottauto + Reifenstapel im oberen Dorf
	objects.create_item_in_inventory(object='BUILDING_999', equipment=["SET_STAPLE_GUN", "SET_LONG_LEATHER_STRAP"])
	objects.create_item_in_inventory(object='BUILDING_1003', equipment=["SET_HEAD_REST"])
	# bei Leila in Kiste
	objects.create_item_in_inventory(object='BUILDING_1120', equipment=["SET_BIG_KNIFE"]) #TODO: verschliessen
	# auf Tisch in Haus ???
	system.create_object(equipmenttype="SET_EMPTY_BOTTLE", x = 534.87, y = 569.24, id="empty bottle")
	objects.set_position_free("empty bottle", x = 534.87, y = 569.24, z = 1.1)
	# Schrankwand in Haus ???
	objects.create_item_in_inventory(object='BUILDING_9881', equipment=["SET_FLUTE"])
	# Waescheleine bei Adrian
	objects.create_item_in_inventory(object='BUILDING_367', equipment=["SET_BULLET_PROOF_CLOTHES"])
	
	#Drugfort
	# auf Tisch in Haus ???
	system.create_object(equipmenttype="SET_DRUGS_PILLS_01", x = 287.97, y = 340.07, id="drug pills")
	objects.set_position_free("drug pills", x = 287.97, y = 340.07, z = 0.8)
	# Truhe in Huette
	objects.create_item_in_inventory(object='BUILDING_12715', equipment=["SET_HEGRENADE", "SET_AMMOPACK_7_62NATO_MM", 'SET_AMMOPACK_5_56_MM']) #TODO: verschliessen
	# Kistenstapel+Kiste
	objects.create_item_in_inventory(object='BUILDING_6520', equipment=["SET_CAKE_TIN"])
	# in langer Halle
	objects.create_item_in_inventory(object='BUILDING_9703', equipment=["SET_WATER_BOTTLE"])
	temp_id = system.create_object(equipmenttype="SET_PLASTIC_BOWL", x = 335.11, y = 310.34)
	objects.set_position_free(temp_id, x = 335.11, y = 310.34, z = 1.8, grid = "BUILDING_90_INTERIOR_GRID")
	
	# Laborschlüssel (Grüne Kiste)
	objects.create_item_in_inventory(object='BUILDING_4087',
								 equipment='SET_BIG_KEY', #todo: hier gehört ein Gefängisschlüssel hin
								 id='Z4PRISON_KEY')
								 
	# Bienenstöcke Z4
	objects.create_item_in_inventory( 'BUILDING_610', equipment=[ 'SET_BEESWAX' ] )
	objects.create_item_in_inventory( 'BUILDING_612', equipment=[ 'SET_BEESWAX', 'SET_BEESWAX' ] )
	objects.create_item_in_inventory( 'BUILDING_614', equipment=[ 'SET_BEESWAX' ] )
			
	# Items in Kisten
	objects.create_item_in_inventory( 'BUILDING_16869', equipment=[ 'SET_DESERT_EAGLE_W_LASERPOINTER', 'SET_SHURIKEN','SET_AMMOPACK_50_AE_DUMDUM'] )
	objects.create_item_in_inventory( 'BUILDING_16870', equipment=[ "SET_GUN_POWDER",'SET_AMMOPACK_9_MM', 'SET_AMMOPACK_50', 'SET_AMMOPACK_9_MM', 'SET_MEDIPACK_SMALL','SET_AMMOPACK_BOLT'] )
	objects.create_item_in_inventory( 'BUILDING_16871', equipment=[ 'SET_BULLET_PROOF_CLOTHES', 'SET_ORDINARY_HELMET', 'SET_WATER_BOTTLE' ] )
	objects.create_item_in_inventory( 'BUILDING_16892', equipment=[ 'SET_CRANK','SET_REEL_OF_STEEL_WIRE','SET_STEEL_CLAD_BOOTS','SET_AMMOPACK_7_62_54_MMR','SET_FAMAS'] ) #, 'SET_ANTITANKMINE' ] )
	objects.create_item_in_inventory( 'BUILDING_16928', equipment=[ 'SET_RPK_74', 'SET_AMMOPACK_9_MM_DUMDUM', 'SET_MEDIPACK_BIG' ] )
	objects.create_item_in_inventory( 'BUILDING_16929', equipment=[ 'SET_RUSTY_IRON_ROD', 'SET_AMMOPACK_357', 'SET_LEATHER_CLOTHES' ] )
	objects.create_item_in_inventory( 'BUILDING_16934', equipment=[ 'SET_MEAT_RAW', 'SET_ANTIDOTE', 'SET_MACHETE', 'SET_BELT' ] )
	objects.create_item_in_inventory( 'BUILDING_9656', equipment=[ 'SET_AMMOPACK_45_SUBSONIC_DUMDUM', 'SET_BULLET_CATCH' ] )
	objects.create_item_in_inventory( 'BUILDING_9423', equipment=[ "SET_GUN_POWDER",'SET_WATERTIGHT_RING', 'SET_AMMOPACK_9_MM_SUBSONIC_DUMDUM' ] )
	
	#wurfwaffenpatch
	objects.create_item_in_inventory(object='BUILDING_3765', equipment='SET_DART')
	objects.create_item_in_inventory(object='BUILDING_9674', equipment=['SET_SHURIKEN', 'SET_SHURIKEN'] )
	objects.create_item_in_inventory( 'BUILDING_9423', equipment=[ 'SET_THROWING_KNIFE', 'SET_THROWING_KNIFE' ] )

	

### initHerbs
#############
def initHerbs():
	system.create_object(equipmenttype="SET_ALOE_VERA", x=407.92, y=568.67)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=223.23, y=576.63)
	system.create_object(equipmenttype="SET_BURNET", x=785.07, y=487.48)
	system.create_object(equipmenttype="SET_ALOE_VERA", x=267.20, y=458.37)
	system.create_object(equipmenttype="SET_ALOE_VERA", x=242.16, y=303.66)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=435.18, y=211.91)
	system.create_object(equipmenttype="SET_ANGELICA", x=414.48, y=505.36)
	system.create_object(equipmenttype="SET_ALOE_VERA", x=396.16, y=500.1)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=681.57, y=249.8)
	system.create_object(equipmenttype="SET_ALOE_VERA", x=491.72, y=326.52)
	
### initFX
###########
def initFX():
	sounds.load_sound(sfx_id='audience_applause')
	sounds.load_sound(sfx_id='laughing_audience')
	sounds.load_sound(sfx_id='splashing_water')
	sounds.load_sound(sfx_id='working_windmill')
	sounds.load_sound(sfx_id='shot_calico_m950')
	sounds.load_sound(sfx_id='crane_setting_down_container')
	
	if not hasattr(data(), "windmill_working"):
		data().windmill_working = True
		sounds.play_3d_sound_object(sfx_id="working_windmill",object="BUILDING_3817",loop=True)
	
	# Windmühle Animation starten
	WindmuehleAnimation('bla')
	# Bühne Animation starten
	BuehnenAnimation('bla')
	if not data().Thresher_sabotaged:
		#print 'ThresherOn'
		ThresherOn()
	elif data().Thresher_repared:
		ThresherOn()
	else:
		#print 'ThresherOff'
		ThresherOff()
	## Lagerfeuer
	for id in const.FIRE_PLACES:
		system.start_effect_object(object=id,node="effekt_feuer",parameter=fx_fire_lagerfeuer)
		#system.start_effect_object(object=id,node="effekt_feuer",parameter=fx_smoke_lagerfeuer)
		system.start_effect_object(object=id,node="effekt_feuer01",parameter=fx_fire_lagerfeuer_01)
		system.start_effect_object(object=id,node="effekt_feuer02",parameter=fx_fire_lagerfeuer_02)
		system.start_effect_object(object=id,node="effekt_feuer03",parameter=fx_fire_lagerfeuer_03)
		system.start_effect_object(object=id,node="effekt_feuer04",parameter=fx_fire_lagerfeuer_04)
		sounds.play_3d_sound_object(sfx_id="campfire_big",object=id,loop=True)
	
	## kochen geht nicht da script_use das feuer bei savegames verschwinden lassen würde
	system.start_effect_object(object='BUILDING_9328',node="effekt_feuer",parameter=fx_fire_lagerfeuer)
	#system.start_effect_object(object=id,node="effekt_feuer",parameter=fx_smoke_lagerfeuer)
	system.start_effect_object(object='BUILDING_9328',node="effekt_feuer01",parameter=fx_fire_lagerfeuer_01)
	system.start_effect_object(object='BUILDING_9328',node="effekt_feuer02",parameter=fx_fire_lagerfeuer_02)
	system.start_effect_object(object='BUILDING_9328',node="effekt_feuer03",parameter=fx_fire_lagerfeuer_03)
	system.start_effect_object(object='BUILDING_9328',node="effekt_feuer04",parameter=fx_fire_lagerfeuer_04)
	sounds.play_3d_sound_object(sfx_id="campfire_big",object='BUILDING_9328',loop=True)
	
	
	## Feuertonnen:
	for id in const.FIRE_BARRELS:
		#system.start_effect_object(object=id,node="sort0",parameter=fx_smoke_brennende_tonne)
		system.start_effect_object(object=id,node="sort1",parameter=fx_fire_brennende_tonne)
		sounds.play_3d_sound_object(sfx_id="campfire_small",object=id,loop=True)

### initSchedules
##################
def initSchedules():
	## Haustiere spawnen:
	system.create_animal(id="DOROTHY_PET1", type=ANIMAL_COW, party="ANIMALS", x=493.51, y=586.92)
	system.create_animal(id= "SUSAN_MAGGOT_SOURCE", type = ANIMAL_PIG, party="ANIMALS",
						x = const.SUSAN_GUT_POINT[0],
						y = const.SUSAN_GUT_POINT[1])
	
### initQuests
###############
def initQuests():
	## Questbookeinträge registrieren
	#for nr in range(1, 23):
	#	snr = "QB_" + (("00" + str(nr))[-3:])
	#	data().__dict__[snr] = system.register_qb_entry(snr)
	#	#Exec("data()." + snr + " = system.register_qb_entry('" + snr + "')")
	data().QB_002 = system.register_qb_entry('ZONE4_AIM_02', id_history = 'ZONE4_AIM_02')
	data().QB_003 = system.register_qb_entry('ZONE4_AIM_03', id_history = 'ZONE4_AIM_02')
	data().QB_004 = system.register_qb_entry('ZONE4_AIM_04', id_history = 'ZONE4_AIM_04')
	data().QB_005 = system.register_qb_entry('ZONE4_AIM_05', id_history = 'ZONE4_AIM_04')
	data().QB_006 = system.register_qb_entry('ZONE4_AIM_06', id_history = 'ZONE4_AIM_04')
	data().QB_007 = system.register_qb_entry('ZONE4_AIM_07', id_history = 'ZONE4_AIM_04')
	data().QB_008 = system.register_qb_entry('ZONE4_AIM_08', id_history = 'ZONE4_AIM_07')
	data().QB_009 = system.register_qb_entry('ZONE4_AIM_09', id_history = 'ZONE4_AIM_04')
	data().QB_010 = system.register_qb_entry('ZONE4_AIM_10', id_history = 'ZONE2_AIM_14')
	data().QB_011 = system.register_qb_entry('ZONE4_AIM_11', id_history = 'ZONE4_AIM_11')
	data().QB_012 = system.register_qb_entry('ZONE4_AIM_12', id_history = 'ZONE4_AIM_11')
	data().QB_013 = system.register_qb_entry('ZONE4_AIM_13', id_history = 'ZONE4_AIM_13')
	data().QB_014 = system.register_qb_entry('ZONE4_AIM_14', id_history = 'ZONE4_AIM_13')
	data().QB_015 = system.register_qb_entry('ZONE4_AIM_15', id_history = 'ZONE4_AIM_13')
	data().QB_016 = system.register_qb_entry('ZONE4_AIM_16', id_history = 'ZONE4_AIM_13')
	data().QB_017 = system.register_qb_entry('ZONE4_AIM_17', id_history = 'ZONE4_AIM_13')
	data().QB_018 = system.register_qb_entry('ZONE4_AIM_18', id_history = 'ZONE4_AIM_18')
	data().QB_019 = system.register_qb_entry('ZONE4_AIM_19', id_history = 'ZONE4_AIM_18')
	data().QB_020 = system.register_qb_entry('ZONE4_AIM_20', id_history = 'ZONE4_AIM_20')
	data().QB_021 = system.register_qb_entry('ZONE4_AIM_21', id_history = 'ZONE4_AIM_21')
	data().QB_022 = system.register_qb_entry('ZONE4_AIM_22', id_history = 'ZONE4_AIM_20')
		
	## Quests initialisieren:
	MarktQuestInit()
	ColinQuestInit()
	JimBobQuestInit()
	MainQuestInit()
	## Questitems initialisieren:
	quest_items = [	'MARENS_SOAP',
			'COLINS_NECKLACE',
			'ADRIANS_TEDDY_BEAR',
			'Thresher_destroyer']
	map(lambda o: objects.set_attribute(o, "generic_item", False), quest_items)

# setzt chars mortal bzw immortal
def init_character_states():
	npcs = system.get_npcs()
	for npc in npcs:
		objects.set_immortal_state(npc, True)
		if objects.has_attribute(npc, "foes"):
			if objects.get_attribute(npc, "foes") != None:
				objects.set_immortal_state(npc, False)
		if npc in ["MAREN", "CHUCK", "WILLIAM", "COLIN_DAD", "MERCENARY_KENO"]:
			objects.set_immortal_state(npc, False)
	
	for ratskull in data().FortRatSkulls:
		character.set_approachable_state(ratskull, NOTAPPROACHABLE)
		objects.set_immortal_state(ratskull, True)
		
	for ratskull in data().HostageCampRatSkulls:
		character.set_approachable_state(ratskull, NOTAPPROACHABLE)
		if not objects.is_destroyed(ratskull):
			objects.set_immortal_state(ratskull, True)
	
	for id in ["DRUGMANA", "DRUGMANB", 'RSWACHE']:
		character.set_approachable_state(id, NOTAPPROACHABLE)
		objects.set_immortal_state(id, True)

	for id in ["DADKILLER1","DADKILLER2","DADKILLER3"]:
		objects.set_attribute(id, attribute="foes", value=['UISPIELER'])
		
		
	for id in ["JEFF","WISSENSCHAFTLER1","WISSENSCHAFTLER2"]:
		character.set_approachable_state(id,False)
		
	daily_routine.prohibit_activity('COLIN')

# initialisiert die questitems, die man durch das killen eines npcs bekommen kann
def init_questitems():
	objects.create_item_in_inventory( object='CHUCK', equipment='SET_RAT_FUR_JACKET', id='CHUCKS_JACKET')
	objects.set_attribute(object='CHUCKS_JACKET', attribute="generic_item", value=False)
	objects.create_item_in_inventory( object='CHUCK', equipment='SET_WATER_SKIN')

################################################################################
### Events #####################################################################
################################################################################

def on_post_load():
	if not data().Thresher_sabotaged:
		sounds.load_sound(sfx_id='treshing_machine')
	initFX()
	schedules.init_schedules()
	init_patch()
	
### on_init
###########
def on_init():
	skies.init_sky_preset("orange")

def init_non_rest_areas():
	data("rest").non_rest_areas = []
	if not hasattr(data(), "has_non_rest_areas"):
		data().has_non_rest_areas = True
		#spezielle non rest regionen
		system.add_region("Dorf_Casa_Verde",600,250,705,380)
		system.add_region("Dorf_2",480,445,565,600)
		system.add_region("Leilas_Wohnwagen",345,460,315,480)
		system.add_region("Geiselcamp",210,515,290,590)
		system.add_region("Drogenlabor",265,365,370,235)
		system.notify_region_entered(region="Drogenlabor", partyid="UISPIELER",permanent=True)

	data("rest").non_rest_areas.append("Dorf_Casa_Verde")
	data("rest").non_rest_areas.append("Dorf_2")
	data("rest").non_rest_areas.append("Leilas_Wohnwagen")
	data("rest").non_rest_areas.append("Geiselcamp")
	data("rest").non_rest_areas.append("Drogenlabor")
	

### on_map_loaded
################
def on_map_loaded():
	const.init_data()
	initParties()
	#place transfer vehicles
	location = GetZoneEnterLocationVehicles( system.zone_transfer_get_direction() )
	system.zone_transfer_place_vehicles( location[0], location[1] )
	## chars generieren:
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	import debug; debug.cheat_party(party=False, x=location[0], y=location[1])
	npc.initNPCS()
	npc.initEnemies()
	## tiere initialisieren:
	npc.initAnimals()
	char_autogeneration.init_mercenary('MERCENARY_KENO')
	if not objects.exists('SALLY'):	
		objects.create_item_in_inventory("MERCENARY_KENO", "SET_PSG_1", id = "SALLY")
		objects.set_attribute('SALLY', 'nickname', 'Sally')
		if hasattr(data("zone_4.zone_4"), "Keno_has_his_Sally"):
			data("zone_4.zone_4").Keno_has_his_Sally = True
			
	on_timer(data().Timer_SpawnTimeChecker)
	#system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
	
	## items generieren:
	initItems()
	initHerbs()
	initEquipment()
	## chars initialisieren:
	initSchedules()
	initQuests()
	## level initialisieren:
	
	initFX()
	initMinimapMarkers()
	sounds.load_sound(sfx_id='treshing_machine')
	initRegions()
	initExitZones()
	initWaterResources()
	#RSGateOpen() #no gate at the fort!
	schedules.init_schedules() ## immer nach dem initQuestbook()

	init_character_states()
	init_questitems()
	init_scriptuse_objects()
	InitChestsSafes()
	generate_animation_rsgate()
	init_non_rest_areas()
	init_lock_state(OBJECT_PRISON, 'lock')
	#leilas wagen für immer abgeschlossen (nur für die pcs)
	init_lock_state("ZONE_4_BUILDING_3849", 'lock')
	init_main_npcs()

# markiert objekte die im script modifiziert werden
def init_scriptuse_objects():
	for lf in const.FIRE_PLACES:
		system.mark_for_script_use(lf)
	system.mark_for_script_use('BUILDING_3918')
	system.mark_for_script_use('BUILDING_4082')
	#tor am fort
	system.mark_for_script_use('BUILDING_3862')
	system.mark_for_script_use('BUILDING_3817')
	system.mark_for_script_use(OBJECT_PRISON)
	
	
	#kisten, truhen, tresore
	system.mark_for_script_use('BUILDING_16896')

	system.mark_for_script_use('BUILDING_16869')
	system.mark_for_script_use('BUILDING_16870')
	system.mark_for_script_use('BUILDING_16871')
	system.mark_for_script_use('BUILDING_16892')
	system.mark_for_script_use('BUILDING_16928')
	system.mark_for_script_use('BUILDING_16929')
	system.mark_for_script_use('BUILDING_16934')
	system.mark_for_script_use('BUILDING_9656')
	system.mark_for_script_use('BUILDING_9423')

	# Bienenstöcke Zone 4
	system.mark_for_script_use('BUILDING_610')
	system.mark_for_script_use('BUILDING_612')
	system.mark_for_script_use('BUILDING_614')


### on_map_reentry
#################
def on_map_reentry():
	location = GetZoneEnterLocationVehicles( system.zone_transfer_get_direction() )
	system.zone_transfer_place_vehicles( location[0], location[1] )
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	if ( isinstance(data().JIMBOB_AMORE_FINISH_TIME,time) ):
		if (system.get_mission_time() - data().JIMBOB_AMORE_FINISH_TIME) > time("72:00:00"):
			data().JIMBOB_DANA_DIRTY = True
			objects.set_attributes("JIMBOB",
				model="low",
				gender="male",
				skin="white",
				clothes="rat_fur_jacket",
				face="jim_bob",
				dialog_face="jim_bob_tidy.png")
			character.update_appearance("JIMBOB")
			objects.set_attributes("DANA",
				model="low",
				gender="female",
				skin="white",
				clothes="sl_001",
				face="dana_untidy",
				dialog_face="dana_untidy.png")
			character.update_appearance("DANA")
	init_non_rest_areas()
	if not data().Thresher_sabotaged:
		sounds.load_sound(sfx_id='treshing_machine')
	initFX()
	schedules.init_schedules()
	print" checke sq3 Quest"
	if was_zone_entered("sqzone_3.sqzone_3"):
		print "Punkt vermessen?",data("sqzone_3.sqzone_3").PunktNordenVermessen
#		if data("sqzone_3.sqzone_3").SQZ3_PunkteVermessen >= 3:
		if data("sqzone_3.sqzone_3").PunktNordenVermessen and data("sqzone_3.sqzone_3").PunktWestenVermessen and data("sqzone_3.sqzone_3").PunktSuedenVermessen:
			print "setze Status"
			if not data().myriam_quest_status >= 1:
				data().myriam_quest_status = 1
				
	# Fahrzeug an richtigen Zeitpunkt setzen
	Drugcar_Shortcuts()
	
	init_patch()

def initMinimapMarkers():
	system.add_minimap_marker(303.50,310.47,"MM_001")#Drogenlabor der Ratskulls

### on_approach
################
def on_approach(target, operator):
	if not object_events.on_approach(target, operator):
		dialogs.on_approach(target, operator)

#makes char_id equip a weapon if one is found
def un_equip_weapon(char_id):
	inventory = objects.get_inventory_ids(char_id)
	weapon = get_equiped_weapon(char_id, inventory)
	if weapon:
		character.un_equip_direct(char_id, weapon)

#checks if chars has a weapon, 
#  returns False if no weapon is equiped
#  returns type of weapons that is equiped
def get_equiped_weapon(char_id, inventory):
	import character
	for item in inventory:
		if len(item[0]):
			item_type = item[0][0]
			if objects.has_attribute(item_type, "weapon_type"):
				if character.is_equiped(char=char_id, equipment=item_type):
					return item_type
	return False

### on_wait_for_commando
#########################
def on_wait_for_commando(id):
	if id in data().AttendsToPerformance:
		if id in data().PerformancePositionTaken:
			return False
		data().PerformancePositionTaken.append(id)
		objects.cancel_commandos(id)
		un_equip_weapon(id)
		objects.set_position(id, data().PerformanceWatchingPositions[0][0],
					  	  data().PerformanceWatchingPositions[1][0])
		del data().PerformanceWatchingPositions[0][0]
		del data().PerformanceWatchingPositions[1][0]
		objects.turn_to_object(id, 'ADRIAN')
		return True
	if id in system.get_pcs():
		if system.is_cutscene():
			if id in data().PlayAnimation and data().PlayAnimation[id] != "":
				animation = data().PlayAnimation[id]
				if animation == "conversate":
					if not dynamic_camera.check_for_equiped_weapon(id):
						animation = "CM_NPC_STEHEN_KONVERSATION_%d" % random.randint( 1, 5 )
					else:
						return schedules.Activity(id)
				if animation == "wait":
					animation = "CM_NPC_STEHEN_WARTEN_%d" % random.randint( 1, 5 )
				if animation == "sit_on_ground":
					animation = 'CM_NPC_SITZEN_BODEN_LOOP'
				if animation == "sit_on_bench":
					animation = 'CM_NPC_SITZEN_BANK_LOOP'
				if animation == 'wash':
					animation = random.choice(['CM_NPC_STEHEN_WAESCHE_WASCHEN_LOOP_SCHWITZEN'] +
											  ['CM_NPC_STEHEN_WAESCHE_WASCHEN_LOOP'] * 5)
				character.play_animation(id, animation)
				return True
	else:
		if id in data().PlayAnimation and data().PlayAnimation[id] != "":
			animation = data().PlayAnimation[id]
			if animation == "conversate":
				animation = "CM_NPC_STEHEN_KONVERSATION_%d" % random.randint( 1, 5 )
			if animation == "wait":
				animation = "CM_NPC_STEHEN_WARTEN_%d" % random.randint( 1, 5 )
			if animation == "sit_on_ground":
				animation = 'CM_NPC_SITZEN_BODEN_LOOP'
			if animation == "sit_on_bench":
				animation = 'CM_NPC_SITZEN_BANK_LOOP'
			if animation == 'wash':
				animation = random.choice(['CM_NPC_STEHEN_WAESCHE_WASCHEN_LOOP_SCHWITZEN'] +
										  ['CM_NPC_STEHEN_WAESCHE_WASCHEN_LOOP'] * 5)
			character.play_animation(id, animation)
			return True
	#return False
	return schedules.Activity(id)

### on_enter_region
####################
def on_enter_region(id, objectid, partyid):
	# print 'on_enter_region(', id, objectid, partyid, ')'
	# non-permanent triggers: objectid is list of all chars in region
	if isinstance(objectid,list):
		if len(objectid):
			objectid=objectid[0]
		else: 
			if id == "Drogenlabor":
				enableRest()
#				print "Resting enabled"
			return
	
	if id == "Drogenlabor":
		disableRest()
#		print "Resting disabled"

	if id == "REGION_WOHNWAGEN_LEILA":
		data().region_wohnwagen_entered = True
		data().region_wohnwagen_notified = False
		if not character.get_vehicle_from_char("ALTER_EGO"):
			objects.cancel_commandos('ALTER_EGO')
			objects.turn_to_object("ALTER_EGO", "ZONE_4_BUILDING_3849")
		if not hasattr(data(),"caravan_comment_active"):
			return False
		else:
			if data().caravan_comment_active:
				if not data().player_knows_leila:
					dialogs.initDlg_156_SpielerSiehtRatskullsImWohnwagen_KenntLeilaNicht()
				else:
					if not data().player_needs_password:
						dialogs.initDlg_157_SpielerSiehtRatskullsImWohnwagen_KenntLeilaAberWeissNixVonPasswort()
					else:
						if ((system.get_qb_entry_state(data().QB_004) == COMPLETE)): # or (system.get_qb_entry_state(data().QB_009) == COMPLETE)
							dialogs.initDlg_159_SpielerSiehtRatskullsImWohnwagen_KenntLeilaWeissVonPasswortHatWanze()
						else:
							dialogs.initDlg_158_SpielerSiehtRatskullsImWohnwagen_KenntLeilaAberWeissVonPasswort()
	
	if id == "REGION_JIMBOB":
		if (data().player_knows_leila and 
			data().player_needs_password and 
			not system.get_qb_entry_state(data().QB_009) in [UNCOMPLETE, COMPLETE] and
			not system.get_qb_entry_state(data().QB_005) in [UNCOMPLETE, COMPLETE] and
			not system.get_qb_entry_state(data().QB_006) in [UNCOMPLETE, COMPLETE] and
			not system.get_qb_entry_state(data().QB_007) in [UNCOMPLETE, COMPLETE] and
			not system.get_qb_entry_state(data().QB_004) in [UNCOMPLETE, COMPLETE]):
			dialogs.initDlg_151_SpielerEntdecktJimbobsBastlerladen()
	
	if id == "REGION_NIGEL":
		if system.get_qb_entry_state(data().QB_013)==INACTIVE:
			objects.cancel_commandos(objectid)
			objects.turn_to_object(objectid, "NIGEL", callback=["ONEND",dialogs.initDlg_075_Nigel_preist_an])
	
	if id == "REGION_CHUCK":
		if not objects.is_destroyed("CHUCK"):
			if objects.get_distance(objectid, "CHUCK") <= 15.0:
				if system.get_qb_entry_state(data().QB_007) in [UNCOMPLETE]:
					if not data().region_comment_given[id][0]:
						dialogs.initDlg_147_SpielerBewundertChucksSakko(objectid)
						data().region_comment_given[id][0] = True
				else:
					if not data().region_comment_given[id][1]:
						dialogs.initDlg_149_SpielerUeberlegtChuckSakkoAbzuknoepfen(objectid)
						data().region_comment_given[id][1] = True
	
	elif id == "REGION_THRESNER":
		if not objects.is_destroyed("CHUCK"):
			if not data().region_comment_given[id][0]:
				dialogs.initDlg_148_DreschmaschineBringtSpielerAufDummeIdeen(objectid)
				data().region_comment_given[id][0] = True
	
	elif id == "REGION_FIRE_ALERT":
		if not objects.is_destroyed("CHUCK"):
			if data().Chuck_repairs:
				if not data().region_comment_given[id][0]:
					objects.cancel_commandos(objectid)
					objects.turn_to_object(objectid, const.OBJECT_FIRE_ALERT)
					dialogs.initDlg_150_SpielerMoecheteGerneAlarmAusloesen(objectid)
					data().region_comment_given[id][0] = True

	elif id == "Region_Colins_Dad" and partyid == "UISPIELER" \
			and not data().Dad_killers_are_foes:
		#nicht mehr benutzt
		DadKillerAttackPlayer(objectid)
		data().Dad_killers_are_foes = True;
	
	elif id == "Region_Hostagecamp":
		if system.get_qb_entry_state(data().QB_011) == INACTIVE:
			g = []
			for c in system.get_pcs():
				x = objects.get_attribute(c, 'x')
				y = objects.get_attribute(c, 'y')
				if const.Region_Hostagecamp[0] < x and \
				   x < const.Region_Hostagecamp[2] and \
				   const.Region_Hostagecamp[1] < y and \
				y < const.Region_Hostagecamp[3]:
					g.append(c)
			if data().Camp_escape_flag:
				system.start_cutscene()
			for c in g:
				objects.cancel_commandos(c)
				px = objects.get_attribute(c, "x")
				py = objects.get_attribute(c, "y")
				if abs(const.Region_Hostagecamp[0] - px) \
				< abs(const.Region_Hostagecamp[2] - px):
					shortestX = const.Region_Hostagecamp[0] - px
				else:
					shortestX = const.Region_Hostagecamp[2] - px
				if abs(const.Region_Hostagecamp[1] - py) \
				< abs(const.Region_Hostagecamp[3] - py):
					shortestY = const.Region_Hostagecamp[1] - py
				else:
					shortestY = const.Region_Hostagecamp[3] - py
				if abs(shortestY) < abs(shortestX):
					objects.move_to(c, px, py + (shortestY / abs(shortestY) * 5), "landscape", MT_FAST,
					["ONEND", Lambda('system.notify_region_entered(region="Region_Hostagecamp", partyid="UISPIELER")')])
					if data().Camp_escape_flag:
						dialogs.initDlg_072_Achtung_Geiseln()
				else:
					objects.move_to(c, px + (shortestX / abs(shortestX) * 5), py, "landscape", MT_FAST,
					["ONEND", Lambda('system.notify_region_entered(region="Region_Hostagecamp", partyid="UISPIELER")')])
					if data().Camp_escape_flag:
						dialogs.initDlg_072_Achtung_Geiseln()
			
	elif id == 'Region_Hostages_Close':
		if objectid == 'ALTER_EGO':
			if not data().Region_Hostages_Close:
				data().Region_Hostages_Close = True
				dialogs.initDlg_069_Geiseln_befreit()
		else:
			Delay(5, Lambda('system.notify_region_entered(region="Region_Hostages_Close", partyid="UISPIELER")'))
			return
	
	elif id == "Region_Fort_Gate":
		data().Region_Fort_Gate = True
		if data().alter_ego_rampage:
			return
		
		if data().Fort_escape_flag:
			Delay(2, Lambda('system.notify_region_entered(region="Region_Fort_Gate", partyid="UISPIELER")'))
			return
		
		data().Fort_escape_flag = True
		map(objects.cancel_commandos, system.get_pcs())
		dialogs.on_approach("RSWACHE", objectid)
		
	# region wurde eingeführt um das betreten des forts auch mit kaputten savegames möglich zu machen ('Region_Fort_Gate')
	if id == 'Region_Fort_Gate_SAVEGAME' and not data().Region_Fort_Gate:
		if data().alter_ego_rampage:
			return
		
		if data().Fort_escape_flag:
			Delay(2, Lambda('system.notify_region_entered(region="Region_Fort_Gate", partyid="UISPIELER")'))
			return
		
		data().Fort_escape_flag = True
		map(objects.cancel_commandos, system.get_pcs())
		dialogs.on_approach("RSWACHE", objectid)
	
	elif id == "GEISEL_LAGER":
		if not data().player_knows_geiselcamp:
			data().player_knows_geiselcamp = True
			system.add_minimap_marker(249.20, 553.06,"MM_005")# Geiselcamp
	return None

def generate_animation_rsgate():
	close_x = 315.0
	close_y = 363.7
	direction = 246
	#direction = objects.get_direction("BUILDING_3862")
	objects.set_active_state("BUILDING_3862", 0)
	system.create_object("RES3D_SCHULBUS_TOR_OPEN",close_x,close_y,"BUS_TOR_OFFEN",direction=direction)
	objects.set_active_state("BUS_TOR_OFFEN", 0)
	system.create_object("RES3D_SCHULBUS_TOR",close_x,close_y,"BUS_TOR_ZU",direction=direction)
	#damit sie nicht angreifbar sind
	objects.set_immortal_state('BUS_TOR_OFFEN', True)
	objects.set_immortal_state('BUS_TOR_ZU', True)
	
def animate_rsgate(state="opening"):
	if  data().tor_animation_frame < len(data().tor_anmation_frames):
		x = data().tor_anmation_frames[data().tor_animation_frame][0]
		y = data().tor_anmation_frames[data().tor_animation_frame][1]
	else:
		if state == "opening":
			data().gate_state = "opened"
		elif state == "closing":
			data().gate_state = "closed"
	
	# wanna open da gate?
	if state == "opening":
		if not data().gate_state == "opened":
			data().gate_state  = "opening"
			objects.set_position_free('BUILDING_3862',x,y, 0)
			data().tor_animation_frame -= 1
			system.notify_timer(data().Timer_BusTorAnimation, data().Timervalue_BusTorAnimation)
			if data().tor_animation_frame <= 0:
				data().gate_state = "opened"
	
	# wanna close da gate?
	elif state == "closing":
		if not data().gate_state == "closed":
			data().gate_state  = "closing"
			objects.set_position_free('BUILDING_3862',x,y, 0)
			data().tor_animation_frame += 1
			system.notify_timer(data().Timer_BusTorAnimation, data().Timervalue_BusTorAnimation)
			if data().tor_animation_frame >= len(data().tor_anmation_frames):
				data().gate_state = "closed"

### on_timer
#############
def on_timer(id):
	print 'timer', id
	# checkt ob cutscene laeuft und startet weiter wenn negativ
	if id == data().Timer_Cutscene:
		if system.is_cutscene() or dialog.is_dialog_active():
			system.notify_timer(data().Timer_Cutscene,data().Timervalue_Cutscene)
		else:
			if data().cutscene_name == "drugcar_start":
				drugcar_reaches_leila()
	
	if id == data().Timer_BusTorAnimation:
		animate_rsgate(data().gate_state)
	
	if id == data().Timer_DialogQueue:
		if dialog.is_dialog_active() or system.is_cutscene():
			system.notify_timer(data().Timer_DialogQueue, data().Timervalue_DialogQueue)
		else:
			if data().dialog_queue == 'D_125':
				dialogs.initDlg_125_Spieler_beschaedigt_die_Muehle()
			elif data().dialog_queue == 'D_160':
				dialogs.initDlg_160_Spieler_Soll_Warten()
			data().dialog_queue = None
	if id in data().ActiveMisc: #delay Timer
		for exp in data().ActiveMisc[id]:
			exp()
		del data().ActiveMisc[id]
		data().Timer_Misc.append(id)
	
	elif id == data().Chuckwalk:
		if objects.is_destroyed("CHUCK"):
			return False
		
		if data().Chuck_is_away:
			return;
		data().Chuck_is_away = True
		map(lambda p: objects.move_to("CHUCK", p[0], p[1], "landscape", MT_SLOW),
			const.ChuckWalkWaypoints[:-2])
		objects.move_to("CHUCK", const.ChuckWalkWaypoints[-1][0], 
							   const.ChuckWalkWaypoints[-1][1],
							   "landscape", MT_SLOW,["ONEND", ChuckIsBack])

	elif id == data().Timer_Fort_Alert:
		data().Timercount_Fort_Alert -= 1
		if data().Timercount_Fort_Alert == 0:
			makePeace()
			FortAlertOff()
	
	## Zeitauslöser, triggert jede Stunde
	if (id==data().Timer_SpawnTimeChecker):
		clock = system.get_mission_time().get_day_time()
		system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
		if (clock >= time("06:00:00") and clock < time("22:00:00")):
			spawnanimals.spawnAnimals(INACTIVE)
		else:
			spawnanimals.spawnAnimals(ACTIVE)
			
	# checkt den start des drogenautos
	if id==data().Timer_DrugCarStart:
		clock = system.get_mission_time()
		data().last_call_of_drugcar_timer = clock
		#print"Mission_time",clock
		clock_day = system.get_mission_time().get_day_time()
		if (time("09:00:00") < clock_day < time("9:31:59")) and (data().Drug_Car_Next_Time < clock):#todo: richtige Zeit messen, damit der Wagen um ca. 10 bei Leila ankommt
			#data().Drug_Car_Next_Time = clock + time("1:00:00")
			
			#print"Next_Start_time", data().Drug_Car_Next_Time
			#if not data().drugcar_started and not data().Stop_Car:
			if data().Stop_Car:
				return
			else:
				data().drugcar_started = True
				system.notify_timer(data().Timer_DrugCarStart, data().Timervalue_DrugCarCheck)
				DrugTransportPhase1()
				#nach hinten verlegt, damit es bei exception nicht gesetzt wird und der Timer es nochmal versucht
				data().Drug_Car_Next_Time = clock + time("1:00:00")
		else:
			system.notify_timer(data().Timer_DrugCarStart, data().Timervalue_DrugCarCheck)
	
	# checkt den start des drogenautos von leila aus
	if id == data().Timer_DrugCarLeaveLeila:
		
		drugcar_leaving_caravan_1()
		
	if id == data().Timer_DrugCarSetInactive:
		objects.set_active_state('DRUGCAR', INACTIVE)
		
	if id == data().Timer_DrugCarActiveDelay:
		#data().DrugCarActiveDelay_Active = False
		Drugcar_Shortcuts_Run()
		
	if id == data().Timer_DrugCarDoorCutscene:
		Drugcar_Shortcuts_Try_Cutscene_Door()
	return None
	
#################
# on_attack     #
#################
def on_attack(operator_id, target_id):
	if operator_id not in system.get_pcs():
		return

	if target_id == "MAREN":
		if not objects.has_attribute("MAREN", "foes"): 
			dialogs.onDlg_024_Kampf()
	
	if target_id == "CHUCK":
		if not objects.has_attribute("CHUCK", "foes"):
			dialogs.onDlg_037_Kampf()
	
	if target_id == "WILLIAM":
		if not objects.has_attribute("WILLIAM", "foes"):
			dialogs.onDlg_083_Kampf()
			
	if target_id == "DRUGMANA" and data().player_has_entered_fort:
		if data().FortRunner == "":
			makeFullEnemy(target_id)
			ensureRunner()
		if data().FortRunner == target_id:
			pass
		else:
			if not objects.has_attribute(target_id, "foes"):
				objects.create_item_in_inventory(target_id, ["SET_HK_USP_45_W_SILENCER","SET_AMMOPACK_45"])
				objects.set_attribute(target_id, "foes", ['UISPIELER'])
				on_attack(operator_id,"DRUGMANB")
				
			elif objects.has_attribute(target_id, 'foes'):
				if objects.get_attribute(target_id, 'foes') == []:
					objects.create_item_in_inventory(target_id, ["SET_HK_USP_45_W_SILENCER","SET_AMMOPACK_45"])
					objects.set_attribute(target_id, "foes", ['UISPIELER'])
					on_attack(operator_id,"DRUGMANB")
				
	elif target_id == "DRUGMANB" and data().player_has_entered_fort:
		if data().FortRunner == "":
			makeFullEnemy(target_id)
			ensureRunner()
		if data().FortRunner == target_id:
			pass
		else:
			if not objects.has_attribute(target_id, "foes"):
				objects.create_item_in_inventory(target_id, ["SET_AUTOMAG_3","SET_AMMOPACK_7_62NATO_MM"])
				objects.set_attribute(target_id, "foes", ['UISPIELER'])
				on_attack(operator_id,"DRUGMANA")
				
			elif objects.has_attribute(target_id, 'foes'):
				if objects.get_attribute(target_id, 'foes') == []:
					objects.create_item_in_inventory(target_id, ["SET_AUTOMAG_3","SET_AMMOPACK_7_62NATO_MM"])
					objects.set_attribute(target_id, "foes", ['UISPIELER'])
					on_attack(operator_id,"DRUGMANA")
			
	elif target_id == "ENEMY_FORT_G10" and data().player_has_entered_fort:
		if data().FortRunner == "":
			makeFullEnemy(target_id)
			ensureRunner()
		if data().FortRunner == target_id:
			pass
		else:
			if not objects.has_attribute(target_id, "foes"):
				objects.step_away(target_id)
				character.equip_direct(target_id,"SET_SPECIAL_38",direct_ammo_load=True)
				objects.set_attribute(target_id, "foes", ['UISPIELER'])
			
			elif objects.has_attribute(target_id, 'foes'):
				if objects.get_attribute(target_id, 'foes') == []:
					objects.step_away(target_id)
					character.equip_direct(target_id,"SET_SPECIAL_38",direct_ammo_load=True)
					objects.set_attribute(target_id, "foes", ['UISPIELER'])

	elif target_id in ["ENEMY_FORT_P02", "ENEMY_FORT_G03"] and data().player_has_entered_fort:
		if data().FortRunner == "":
			makeFullEnemy(target_id)
			ensureRunner()
		if data().FortRunner == 'ENEMY_FORT_P02':
			for char in ["ENEMY_FORT_P02", "ENEMY_FORT_G03"]:
				if not objects.has_attribute(char, "foes"):
					objects.set_attribute(char, "foes", ['UISPIELER'])
					if char == 'ENEMY_FORT_G03':
						on_attack(operator_id,"ENEMY_FORT_G03")
				elif objects.get_attribute(char, "foes") == []:
					objects.set_attribute(char, "foes", ['UISPIELER'])
					if char == 'ENEMY_FORT_G03':
						on_attack(operator_id,"ENEMY_FORT_G03")
		elif data().FortRunner == 'ENEMY_FORT_G03':
			for char in ["ENEMY_FORT_P02", "ENEMY_FORT_G03"]:
				if not objects.has_attribute(char, "foes"):
					objects.set_attribute(char, "foes", ['UISPIELER'])
					if char == 'ENEMY_FORT_G02':
						on_attack(operator_id,"ENEMY_FORT_G02")
				elif objects.get_attribute(char, "foes") == []:
					objects.set_attribute(char, "foes", ['UISPIELER'])
					if char == 'ENEMY_FORT_G02':
						on_attack(operator_id,"ENEMY_FORT_G02")
			
	elif target_id in ["RSWACHE", "ENEMY_FORT_G19", "ENEMY_FORT_G20", "RSGUARD_FRONT",'ENEMY_FORT_G01'] and data().player_has_entered_fort:
		if data().FortRunner == "":
			makeFullEnemy(target_id)
			ensureRunner()
		if not data().alter_ego_rampage:
			if not data().player_knows_password:
				for rs in ["RSWACHE", "ENEMY_FORT_G19", "ENEMY_FORT_G20", "RSGUARD_FRONT"]:
					if data().FortRunner == rs:
						pass
					elif not objects.is_destroyed(rs):
						objects.set_attribute(rs, "maxhitpoints", 1000)
						objects.set_attribute(rs, "hitpoints", 1000)
						objects.set_position('RSGUARD_FRONT', 309.49, 387.48)
						if not objects.has_attribute(rs, 'foes'):
							objects.set_attribute(rs, "foes", ["UISPIELER"])
						elif objects.has_attribute(rs, 'foes'):
							if objects.get_attribute(rs, 'foes') == []:
								objects.set_attribute(rs, "foes", ["UISPIELER"])
						objects.turn_to_object(rs, operator_id)
				data().alter_ego_rampage = True
			if not data().gate_open:
				RSGateOpen()
			for id in ["RSWACHE", "ENEMY_FORT_G19", "ENEMY_FORT_G20", "RSGUARD_FRONT", 'ENEMY_FORT_G01']:
				if data().FortRunner == id:
					pass
				elif not objects.is_destroyed(id):
					objects.turn_to_object(id, operator_id)
					if not objects.has_attribute(id, 'foes'):
						objects.set_attribute(id, "foes", ["UISPIELER"])
					elif objects.has_attribute(id, 'foes'):
						if objects.get_attribute(id, 'foes') == []:
							objects.set_attribute(id, "foes", ["UISPIELER"])
	
	elif target_id in ['ENEMY_FORT_G04', 'ENEMY_FORT_G05', 'ENEMY_FORT_P01',
					   'ENEMY_FORT_P02', 'ENEMY_FORT_P03', 'ENEMY_FORT_P04', 
					   'ENEMY_FORT_P05', 
					   'ENEMY_FORT_G06', 'ENEMY_FORT_G12', 'ENEMY_FORT_G13',
					   'ENEMY_FORT_G08', 'ENEMY_FORT_G09', 'ENEMY_FORT_G11'] and data().player_has_entered_fort:
		data().FriedenFlag = False
		if data().FortRunner == "":
			makeFullEnemy(target_id)
			ensureRunner()
	if data().FortAlert and data().player_has_entered_fort:
		makeFullEnemy(target_id)
		if data().FortRunner == "":
			ensureRunner()
		for id in data().FortRatSkulls:
			if not objects.is_destroyed(id):
				objects.turn_to_object(id, operator_id)
				if not objects.has_attribute(id, 'foes'):
					objects.set_attribute(id, "foes", ["UISPIELER"])
				elif objects.has_attribute(id, 'foes'):
					if objects.get_attribute(id, 'foes') == []:
						objects.set_attribute(id, "foes", ["UISPIELER"])
	
	if data().ui_spotter_list != [] and data().player_has_entered_fort:
		for feind in data().ui_spotter_list:
			if not objects.has_attribute(feind, 'foes'):
				objects.set_attribute(feind, "foes", ["UISPIELER"])
			elif objects.has_attribute(feind, 'foes'):
				if objects.get_attribute(feind, 'foes') == []:
					objects.set_attribute(feind, "foes", ["UISPIELER"])
	
	object_events.on_attack(operator_id, target_id)

def on_ui_player_spotted(spotter):
	# print 'debug: on_ui_player_spotted(',spotter,')'
	
	if not hasattr(data('zone_4.zone_4'), 'ui_spotter_list'):
		data().ui_spotter_list = []
	if spotter in data().FortRatSkulls:
		if not spotter in data().ui_spotter_list:
			data().ui_spotter_list.append(spotter)
		
	object_events.on_ui_player_spotted(spotter)
		
def on_ui_player_out_of_view(spotter):
	# print 'debug: on_ui_player_out_of_view(',spotter,')'
	
	if not hasattr(data('zone_4.zone_4'), 'ui_spotter_list'):
		data().ui_spotter_list = []
	if spotter in data().FortRatSkulls:
		if spotter in data().ui_spotter_list:
			data().ui_spotter_list.remove(spotter)
	
	object_events.on_ui_player_out_of_view(spotter)

####################
# on_enemy_spotted #
####################
def on_enemy_spotted(object_id):
	# print  'on_enemy_spotted(', object_id ,')'
	if object_id not in (data().HostageCampRatSkulls + data().FortRatSkulls):
		object_events.on_enemy_spotted(object_id)
		return

	if object_id != 'RSWACHE':
		npc.stopEnemyActivity(object_id)
	
	if object_id in data().FortRatSkulls:
		data().FriedenFlag = False
		if (data().FortAlert % 2) == 1:	# A (Alarm ausgelöst)
			resetAlertTimer()
		
		elif data().KriegImFort:
			makeFullEnemy(object_id)
			if data().FortRunner == "":
				ensureRunner()

	object_events.on_enemy_spotted(object_id)
	
#################
# onKilled 	    #
#################
def on_object_killed(victim, attacker, weapon_type, weapon_id, victims_party):
	
	if victim == "CHUCK":
		if not data().ratfurjacket_picked_up:
			objects.set_attributes('CHUCK', model='low', gender='male',
				skin='white', clothes='sl_004', face='chuck')
			character.update_appearance('CHUCK')
			try:
				objects.drop_item("CHUCK","CHUCKS_JACKET")
			except:
				pass
	
	if victim in data().HostageCampRatSkulls:
		data().HostageCampRatSkulls.remove(victim)
		if data().HostageCampRatSkulls == []:
			system.notify_region_entered(region="Region_Hostages_Close", partyid="UISPIELER")

	elif victim in data().FortRatSkulls:
		data().FortRatSkulls.remove(victim)
		if data().FeindeImFort.count(victim) > 0:
			data().FeindeImFort.remove(victim)
		if (data().FortAlert % 2) == 1:	# A (Alarm ausgelöst)
			pass
		elif data().KriegImFort:
			if victim == data().FortRunner:
				# print 'data().FortRunner = ""'
				data().FortRunner = ""
			if data().FeindeImFort == []:
				makePeace()
			else:
				if data().FortRunner == "":
					ensureRunner()
		if data().FortRatSkulls == []:
			data().Fort_liberated = True
			character.add_experience_party(data().Exp_LaborEingenommen)
			system.set_qb_entry_state(data().QB_010, COMPLETE)
			#torsten: Aktiviert DRUGCAR
			objects.set_attribute('DRUGCAR', 'accepted_drivers', ['UISPIELER'])
			objects.set_immortal_state('DRUGCAR',False)
			if was_zone_entered('zone_3.zone_3'):
				if system.get_qb_entry_state(data("zone_3.zone_3").QB_004) in [UNCOMPLETE]:
					Delay(2, dialogs.initDlg_131_Der_Spieler_denkt_an_Zone_3)
					
	object_events.on_object_killed(victim, attacker, weapon_type, weapon_id, victims_party)
	

######################
# on_sector_cleared. #
######################
def on_sector_cleared(object_id):
	if object_id in data().HostageCampRatSkulls:
		npc.enemyActivity(object_id)
	elif object_id in data().FortRatSkulls:
		npc.enemyActivity(object_id)

#####################
# on_corpse_spotted #
#####################
def on_corpse_spotted(object_id):
	pass
	#if object_id in ['ENEMY_FORT_P01', 'ENEMY_FORT_P02', 'ENEMY_FORT_P03',
	#				 'ENEMY_FORT_P04', 'ENEMY_FORT_P05']:
		#if (data().FortAlert % 2) == 1:	# Alarm ausgelöst:
		#	npc.stopEnemyActivity(object_id)
		#else:
		#	pass # Kommentar von Feiden gibts nicht

#################
# onExamine&Co. #
#################
def pre_examine_object( character_id, object_id ):
	if object_id.endswith(const.OBJECT_STAGE) or object_id.endswith(const.OBJECT_STAGE + '_INTERIOR'):
		objects.set_attribute(object_id, "on_examine_coordinates", [519.9,564.45, 0])
	#return object_events.pre_examine_object( character_id, object_id )

def can_examine_object( character_id, object_id ):
	if object_id == 'DRUGCAR':
		return True
	
	if character_id == 'ALTER_EGO' and (
			object_id.endswith(const.OBJECT_THRESHER) or
			object_id.endswith(const.OBJECT_STAGE) or
			object_id.endswith(const.OBJECT_FIRE_ALERT) or
			object_id.endswith(const.OBJECT_STAGE + '_INTERIOR')):
		return True
	if object_id.endswith('BUILDING_4087'):
		return True
	
	if object_id.endswith(OBJECT_PRISON):
		if data().scientists_rescued:
			return False
		if hasattr(data(),"jail_open"):
			return 
		return True
		
	if object_id == 'COLIN_DAD':
		return True
		
	if object_id == 'COLINS_NECKLACE':
		return True
	
	return False

def on_examine_object( character_id, object_id ):
	if object_id == 'DRUGCAR':
		if character_id == "ALTER_EGO":
			dialogs.initDlg_060_SpielerUntersuchtFahrzeug()
		else:
			dialogs.initDlg_060_SpielerUntersuchtFahrzeug_merc(character_id)
	
	if object_id != None:
		if object_id.endswith(const.OBJECT_THRESHER):
			if objects.is_destroyed("CHUCK"):
				return True
	
			if data().Thresher_repared:
				dialogs.initDlg_124_Spieler_untersucht_Muehle_nachher()
			elif data().Thresher_sabotaged:
				dialogs.initDlg_123_Spieler_untersucht_Muehle_kaputt()
			else:
				dialogs.initDlg_122_Spieler_untersucht_Muehle_vorher()
		
		elif object_id.endswith(const.OBJECT_STAGE) or object_id.endswith(const.OBJECT_STAGE + '_INTERIOR'):
			objects.turn_to_direction(character_id, DIR_NORTH, callback=["ONEND", Lambda('dialogs.initDlg_074_Spieler_untersucht_Schild_am_Markt()')])
	
		elif object_id.endswith(const.OBJECT_FIRE_ALERT):
			dialogs.initDlg_045_Alarm_untersuchen()
		
		elif object_id.endswith('BUILDING_4087'):
			if objects.get_inventory_list(object_id):
				system.item_panel(character_id, object_id)
		
		elif object_id.endswith(OBJECT_PRISON):
			if data().Fort_liberated:
				if system.get_qb_entry_state(data().QB_011) == INACTIVE:
					if objects.count_in_inventory(character_id, 'Z4PRISON_KEY'):
						if character_id != None: #== 'ALTER_EGO':
							init_lock_state(OBJECT_PRISON, 'unlock')
							open_knast(character_id, True)
							#dialogs.initDlg_141_Spieler_oeffnet_Gefaengnis()
						else:
							not_open_knast(character_id)
							return True
					else:
						if character_id == 'ALTER_EGO':
							dialogs.initDlg_140_Spieler_kann_Gefaengnis_nicht_oeffnen()
						else:
							not_open_knast(character_id)
					return True
			else:
				if not dialog.is_dialog_active():
					dialogs.initDlg_130_Spieler_will_Gefaengnis_nicht_oeffnen()
				return True
	
	if object_id == 'COLIN_DAD':
		dialog.init_dialog(type=DIALOGSMALL)
		dialog.add_text(text='EXAMINE_LEICHEN', speaker=character_id, follower = 'ENDDIALOG')
		dialog.start()
		
	if object_id == 'COLINS_NECKLACE':
		dialog.init_dialog(type=DIALOGSMALL)
		dialog.add_text(text='EXAMINE_NECKLACE', speaker=character_id, follower = 'ENDDIALOG')
		dialog.start()
	return False

#################
# on_pick_up    #
#################
def on_pick_up( character_id, item_id, item_type ):
	if item_id == 'COLINS_NECKLACE' and system.get_qb_entry_state(data().QB_018) == UNCOMPLETE:
		if data().One_time_only_D098:
			dialogs.initDlg_098_Spieler_findet_Kette()
			data().One_time_only_D098 = False
	
	if item_id == "ADRIANS_TEDDY_BEAR":
		if not data().teddy_picked_up:
			data().teddy_picked_up = True
			if data().Adrian_plays_with_puppies:
				dialogs.initDlg_081_Spieler_finded_Teddy_wissend()
			else:
				dialogs.initDlg_080_Spieler_finded_Teddy_unwissend()
	
	if item_id == "CHUCKS_JACKET":
		if system.get_qb_entry_state(data().QB_007) != COMPLETE:
			if not data().ratfurjacket_picked_up:
				if data().Chuck_is_away or data().FireAlert or objects.is_destroyed("CHUCK"):
					data().ratfurjacket_picked_up = True
					data().Jacket_stolen = True
					if (system.get_qb_entry_state(data().QB_007) == UNCOMPLETE or
						system.get_qb_entry_state(data().QB_008) == UNCOMPLETE):
	
						system.set_qb_entry_state(data().QB_007, COMPLETE)
						if system.get_qb_entry_state(data().QB_008) == UNCOMPLETE:
							system.set_qb_entry_state(data().QB_008, INACTIVE)
						character.add_experience_party(data().Exp_JackeBeschafft)
					CheckIfAllThingsAreReadyForJimbob()
				else:
					dialogs.initDlg_048_Cuck_passt_auf()
					return False
	
	if item_id == "MARENS_SOAP":
		if not data().soap_picked_up:
			if not data().Soap_traded:
				# Seife nehmen, wenn Maren tot
				if objects.is_destroyed("MAREN"):
					set_maren_qb_entry()
					CheckIfAllThingsAreReadyForJimbob()
					return True

				# Seifen diebstahl:
				if (objects.get_attribute(character_id, 'pick_pocket') <= const.MAREN_MINIMAL_PICKPOCKET):
					dialogs.initDlg_132_Maren_bewacht_Seife()
					return False
				else:
					data().Soap_stolen = True
					set_maren_qb_entry()
					CheckIfAllThingsAreReadyForJimbob()
					return True
			else:
				set_maren_qb_entry()
				CheckIfAllThingsAreReadyForJimbob()
				return True
	return object_events.on_pick_up( character_id, item_id, item_type)

def set_maren_qb_entry():
	data().soap_picked_up = True
	if system.get_qb_entry_state(data().QB_005) == UNCOMPLETE:
		system.set_qb_entry_state(data().QB_005, COMPLETE)
		character.add_experience_party(data().Exp_SeifeBeschafft)

#################
# onExchange    #
#################
def can_exchange( character_id, target_id, item_id, item_type ):
	if target_id == "COLIN" and item_id == 'COLINS_NECKLACE' and \
			character_id == 'ALTER_EGO':
		return True
	elif target_id not in ['JIMBOB'] + system.get_pcs() and (item_id == 'MARENS_SOAP' or item_id == 'CHUCKS_JACKET'):
		return False
	elif target_id == 'JIMBOB' and (item_id == 'MARENS_SOAP' or item_id == 'CHUCKS_JACKET'):
		return True
	elif target_id == 'DRUGCAR' and item_id == 'JIMBOS_BUG':
		return True
	return object_events.can_exchange( character_id, target_id, item_id, item_type )
	
def on_exchange( character_id, target_id, item_id, item_type ):
	if target_id == "COLIN" and item_id == 'COLINS_NECKLACE':
		dialogs.initDlg_099_Schlechte_Nachricht(True)
		return True
	elif target_id == 'JIMBOB' and (item_id == 'MARENS_SOAP' or item_id == 'CHUCKS_JACKET' or item_type == 'SET_SOAP'):
		if (objects.count_in_inventory('JIMBOB', 'MARENS_SOAP') +
			objects.count_in_inventory('JIMBOB', 'CHUCKS_JACKET')) == 1 and \
			character_id == 'ALTER_EGO':
				dialogs.on_approach('JIMBOB', 'ALTER_EGO')
		return True
	elif target_id == 'DRUGCAR' and item_id == 'JIMBOS_BUG':
		character.play_animation(character_id, 'CM_STEHEN_TASCHENDIEBSTAHL_VORN',
			['ONEND', dialogs.initDialog_061_Spieler_befestigt_Wanze])
		return True
	return object_events.on_exchange( character_id, target_id, item_id, item_type )

###################
# can_use         #
###################
def can_use( character_id, object_id ):
	if object_id == 'DRUGCAR':
		return True

	if object_id == "CHUCKS_JACKET":
		return True
	
	#if character_id != 'ALTER_EGO':
	#	return False
	
	if object_id != None:
		if object_id.endswith(OBJECT_PRISON):
			if data().scientists_rescued or not objects.count_in_inventory(character_id, 'Z4PRISON_KEY'):
				if  character_id == 'ALTER_EGO':
					return True
				else:
					return False
			return True
		
	if object_id != None and character_id == 'ALTER_EGO':
		
		if object_id.endswith(const.OBJECT_FIRE_ALERT):
			if not data().FireAlert and objects.is_alive_and_active('CHUCK'):
				return True
		
		if object_id.endswith(const.OBJECT_THRESHER):
			return True

	return object_events.can_use(character_id, object_id)

def on_use(operatorid, targetid, objectid, equipmenttype):
	#print 'on_use(', operatorid, targetid, objectid, equipmenttype,')'
	
	#if(operatorid != 'ALTER_EGO' and equipmenttype == "SET_IRON_BAR"): # was soll dieser Quatsch?
	if (operatorid != 'ALTER_EGO' and isinstance(targetid, str) and targetid.endswith(const.OBJECT_THRESHER)):
		dialogs.MercenaryDenyTalk(operatorid, "default")
		return True
		
	
	if objectid == "CHUCKS_JACKET":
		return True
	
	if targetid == 'DRUGCAR' and objectid==None and not enemy_script.count_party_inventory(20, 'DRUGCAR', items = 'JIMBOS_BUG'): # operatorid == "ALTER_EGO" and 
		if objects.get_distance_to_object('ALTER_EGO', 'DRUGCAR') < 20:
			dialogs.initDlg_142_SpielerWillNichtPickUpFahren('ALTER_EGO')
		else:
			dialogs.initDlg_142_SpielerWillNichtPickUpFahren(operatorid)
		return True
	
	if isinstance(targetid, str) and targetid.endswith(OBJECT_PRISON):
		if data().Fort_liberated:
			if system.get_qb_entry_state(data().QB_011) == INACTIVE:
				if (objects.count_in_inventory(operatorid, 'Z4PRISON_KEY') or 
					objectid != None and objectid == 'Z4PRISON_KEY'):
					init_lock_state(OBJECT_PRISON, 'unlock')
					data().scientists_rescued = True
					open_knast(operatorid, True)
					#dialogs.initDlg_141_Spieler_oeffnet_Gefaengnis()
				else:
					if operatorid == 'ALTER_EGO':
						dialogs.initDlg_140_Spieler_kann_Gefaengnis_nicht_oeffnen()
					else:
						return False
				return True
		return False
	
	if isinstance(targetid, str) and operatorid == 'ALTER_EGO':
		if targetid.endswith(const.OBJECT_THRESHER) and (
			objectid == "Thresher_destroyer" or (
			equipmenttype == "SET_IRON_BAR" or
			equipmenttype == "SET_BROOM" or
			equipmenttype == "SET_LEAD_PIPE" or
			equipmenttype == "SET_SHOVEL" or
			equipmenttype == "SET_SPADE" or
			equipmenttype == "SET_TAIL_ROTOR")):
				
			if objects.is_destroyed("CHUCK"):
				return True
			else:
				if data().Chuck_is_away or data().FireAlert:
					if not dialog.is_dialog_active():
						dialogs.initDlg_125_Spieler_beschaedigt_die_Muehle()
					else:
						data().dialog_queue = 'D_125'
						system.notify_timer(data().Timer_DialogQueue, data().Timervalue_DialogQueue)
					if objectid == "Thresher_destroyer":
						objects.remove_item_from_inventory(operatorid, objectid)
					else:
						objects.remove_item_from_inventory(operatorid, equipmenttype)
					return True
				else:
					if not dialog.is_dialog_active():
						dialogs.initDlg_160_Spieler_Soll_Warten()
					else:
						data().dialog_queue = 'D_160'
						system.notify_timer(data().Timer_DialogQueue, data().Timervalue_DialogQueue)
					return True
		elif targetid.endswith(const.OBJECT_FIRE_ALERT) and objectid == None:
			if data().Thresher_sabotaged and not data().Thresher_repared:
				if data().Chuck_repairs:
					data().FireAlert = True
					FireAlertOn()
					if data().AlertCount == 0:
						dialogs.initDlg_047_Alarm_ausloesen1()
					elif data().AlertCount == 1:
						dialogs.initDlg_127_Alarm_ausloesen2()
					else:
						dialogs.initDlg_128_Alarm_ausloesenx()
					data().AlertCount += 1
					return True
				else:
					return False
			else:
				return False
		
	### Drugcar and Bug combinations
	if ((targetid == 'DRUGCAR' and objectid == 'JIMBOS_BUG') or
		(targetid == 'DRUGCAR' and objectid == None and enemy_script.count_party_inventory(20, 'DRUGCAR', items = 'JIMBOS_BUG'))):
			#time check
			#if data().Drugcar_Actual_Phase == 'CARAVAN': 
			if system.is_cutscene():
				return False
			character.play_animation(operatorid, 'CM_STEHEN_TASCHENDIEBSTAHL_VORN',
				['ONEND', dialogs.initDialog_061_Spieler_befestigt_Wanze])
			return True
			#else:
			#	return False
	if (targetid == None and objectid == 'JIMBOS_BUG' and objects.get_distance_to_object(operatorid, 'DRUGCAR') < 20):
		#if data().Drugcar_Actual_Phase == 'CARAVAN':
		if not objects.is_active('DRUGCAR'):
			return False
		objects.cancel_commandos(operatorid)
		objects.move_to_object(operatorid, 'DRUGCAR', speed = MT_AUTO)
		character.play_animation(operatorid, 'CM_STEHEN_TASCHENDIEBSTAHL_VORN',
			['ONEND', dialogs.initDialog_061_Spieler_befestigt_Wanze])
		return True
		#else:
		#	return False
		
		
		
	#print 'global.on_use(', operatorid, targetid, objectid, equipmenttype,')'

	return object_events.on_use( operatorid, targetid, objectid, equipmenttype )
	

def on_use_failed( character_id, object_id, item_id, item_type ):
	if character_id != 'ALTER_EGO':
		return object_events.on_use_failed( character_id, object_id, item_id, item_type )
	elif object_id != None:
		if object_id.endswith(const.OBJECT_THRESHER) and item_id == "Thresher_destroyer":
			dialogs.initDlg_138_Chuck_laesst_Spieler_nicht_an_Dreschmaschine()
			return True
		elif object_id.endswith(const.OBJECT_PRISON):
			dialogs.initDlg_130_Spieler_will_Gefaengnis_nicht_oeffnen()
			return True
		elif object_id.endswith(const.OBJECT_FIRE_ALERT):
			dialogs.initDlg_046_Alarm_nicht_ausloesen()
			return True
	return object_events.on_use_failed( character_id, object_id, item_id, item_type )

############
# on_trade #
############
def on_trade(target,operator):
	if not object_events.on_trade(target,operator):
		return False
	if target=="MILES":
		system.trading_screen(trader="MILES",char=operator)
	elif target=="GENE":
		system.trading_screen(trader="GENE",char=operator)
	return None

def on_update_trader(trader):
	object_events.on_update_trader(trader)


################################################################################
### Misc. ######################################################################
################################################################################

### Delay
##########
# Delay(Zeit in Sekunden, Callbackliste) führt code Zeitverzögert aus
#  dazu werden zusätzliche Timer dynamisch aktiviert...
def Delay(delta_t, expressions):
	## expressions zu einer Liste machen
	if callable(expressions):
		expressions = [expressions]
	if data().Timer_Misc == []:
		#print "Error: No more timer slots for delay!"
		return
	t_nr = data().Timer_Misc[0]
	#print "[debug: tnr=",str(t_nr),"delta_t=", str(delta_t),"]"
	data().ActiveMisc[t_nr] = expressions
	system.notify_timer(t_nr, delta_t * 1000)
	data().Timer_Misc.remove(t_nr)

def GetZoneEnterLocation(enterdirection):
	start_locations = {
			"NORTH":	(800.8, 260.3),
	 		"SOUTH":	(750.0, 580.0),
	 		"WEST":		(316.84, 511.74),
	 		"EAST":		(700.0, 440.0),
	 	}

	if (enterdirection in start_locations.keys()):
		#import debug
		#print debug.get_info()
		#print start_locations[enterdirection]
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registerd: " + enterdirection
def GetZoneEnterLocationVehicles(enterdirection):
	start_locations = {
			"NORTH":	(776.63, 259.67),
	 		"SOUTH":	(750.56, 588.46),
	 		"WEST":		(333.43, 504.11),
	 		"EAST":		(689.22, 422.35),
	 	}

	if (enterdirection in start_locations.keys()):
		#import debug
		#print debug.get_info()
		#print start_locations[enterdirection]
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registerd: " + enterdirection		

################################################################################
### Kampf ######################################################################
################################################################################
def makePeace():
	data().FriedenFlag = True
	Delay(3, delaydings)
	
def delaydings():
	#print 'delaydings'
	if data().FriedenFlag:
		data().KriegImFort = False
		map(lambda c: objects.set_attribute(c, 'foes', []), data().FortRatSkulls)
		data().FeindeImFort = []

def makeFullEnemy(enemy):
	# print 'makeFullEnemy', enemy
	# print enemy in data().FortRatSkulls + ['DRUGMANA', 'DRUGMANB']
	if enemy in data().FortRatSkulls + ['DRUGMANA', 'DRUGMANB']:
		if enemy not in data().FeindeImFort:
			if not objects.has_attribute(enemy, 'foes'):
				objects.set_attribute(enemy, 'foes', ['UISPIELER'])
			elif objects.has_attribute(enemy, 'foes'):
				if objects.get_attribute(enemy, 'foes') == []:
					objects.set_attribute(enemy, 'foes', ['UISPIELER'])
			data().FeindeImFort.append(enemy)
			if enemy not in ['DRUGMANA', 'DRUGMANB']:
				objects.cancel_commandos(enemy)
		data().KriegImFort = True

def makePCPartialEnemy(pc):
	if 'ENEMY_FORT_G10' in data().FortRatSkulls:
		data().FortRatSkulls.remove('ENEMY_FORT_G10')
		data().EnemyDefaultOccupation['ENEMY_FORT_G10'][2] = 'alerted'
		daily_routine.prohibit_activity('ENEMY_FORT_G10')
		objects.set_attribute('ENEMY_FORT_G10', 'foes', ['UISPIELER']) 
	if 'ENEMY_FORT_G02' in data().FortRatSkulls:
		data().FortRatSkulls.remove('ENEMY_FORT_G02')
		data().EnemyDefaultOccupation['ENEMY_FORT_G02'][2] = 'alerted'
		daily_routine.prohibit_activity('ENEMY_FORT_G02')
		objects.set_attribute('ENEMY_FORT_G02', 'foes', ['UISPIELER'])
	for rs in data().FortRatSkulls:
		if objects.has_attribute(rs, "foes"):
			objects.set_attribute(rs, 'foes', ['UISPIELER']) #[pc] + objects.get_attribute(rs, 'foes'))
			objects.cancel_commandos(pc)
		elif objects.has_attribute(rs, 'foes'):
			if objects.get_attribute(rs, 'foes') == []:
				objects.set_attribute(rs, 'foes', ['UISPIELER']) #[pc] + objects.get_attribute(rs, 'foes'))
				objects.cancel_commandos(pc)
		else:
			if not objects.has_attribute(rs, 'foes'):
				objects.set_attribute(rs, 'foes', [pc])
			elif objects.has_attribute(rs, 'foes'):
				if objects.get_attribute(rs, 'foes') == []:
					objects.set_attribute(rs, "foes", [pc])
		if rs not in data().FeindeImFort and character.get_visible_enemies(rs) != []:
			on_enemy_spotted(rs)

def ensureRunner():
	# print 'ensureRunner'
	if data().FortRunner == "" and (data().FortAlert % 2) == 0:
		run = 100
		runner = ""
		for ratskull in data().FeindeImFort:
			dist = objects.get_distance_to_object(ratskull, 'ZONE_4_BUILDING_1208')
			if objects.get_distance_to_object(ratskull, 'ZONE_4_BUILDING_1208') < run :
				run = dist 
				runner = ratskull
		# run starten:
		if runner != "":
			if not objects.is_destroyed(runner):
				objects.cancel_commandos(runner)
				objects.move_to(runner, const.FORT_ALERT_POINT[0],
									  const.FORT_ALERT_POINT[1], "landscape", MT_FASTEST)
				objects.turn_to_object(runner, const.FORT_ALERT_OBJECT)
				character.play_animation(runner, 'CM_STEHEN_TASCHENDIEBSTAHL_VORN')
				objects.turn_to_direction(runner, 0, ['ONEND',runnerAtGoal])
				data().RunnerContactPoint = (objects.get_x(runner), objects.get_y(runner))
			data().FortRunner = runner
		else:
			if data().FeindeImFort:
				ensureRunner()

def runnerBackToWar():
	enemies = character.get_visible_enemies(data().FortRunner)
	if enemies == []:
		objects.move_to(data().FortRunner, data().RunnerContactPoint[0],
										 data().RunnerContactPoint[1],
										 "landscape", MT_FAST)
	else:
		if not objects.is_destroyed(enemies[0]):
			objects.attack(data().FortRunner, enemies[0])

def resetAlertTimer():
	pass
	#system.notify_timer(data().Timer_Fort_Alert, data().Timervalue_Fort_Alert)
	data().Timercount_Fort_Alert += 1

def totalWar(foeList):
	if not (isinstance(foeList, list) or isinstance(foeList, tuple)):
		foeList = [foeList]
	map(lambda c: objects.set_attribute(c, 'foes', ["UISPIELER"]), foeList)

def runnerAtGoal(id = "1337"):
	# print 'totalWar :-)'
	FortAlertOn()
	runnerBackToWar()
	resetAlertTimer()
	totalWar(data().FortRatSkulls)

################################################################################
### Questspezifische Funktionen ################################################
################################################################################

### Main Quest
###############
def MainQuestInit():
	# feinde scriptfertig machen
	map(lambda c: objects.set_attribute(c, 'foes', []), data().FortRatSkulls)
	data().FeindeImFort = []
	data().KriegImFort = False
	data().FortRunner = ""
	# Wissenschaftler bereit machen:
	character.play_animation('WISSENSCHAFTLER1', 'CM_NPC_SITZEN_BODEN_HINSETZEN')
	character.play_animation('WISSENSCHAFTLER2', 'CM_NPC_STEHEN_HINSETZEN')
	data().PlayAnimation['WISSENSCHAFTLER1'] = 'sit_on_ground'
	data().PlayAnimation['WISSENSCHAFTLER2'] = 'sit_on_bench'
	
	
	#system.set_qb_entry_state(data().QB_001, UNCOMPLETE) # 1 Quest starten
	objects.create_item_in_inventory(object="RSWACHE",
		equipment=["SET_CALICO_M950",'SET_AMMOPACK_9_MM', 'SET_AMMOPACK_9_MM',"SET_BOTTLE_OF_BOOZE"])
	character.equip("RSWACHE","SET_CALICO_M950")

def RSGateOpen():
	if not data().player_has_entered_fort:
		data().gate_open = True
		data().Drugcar_Busdoor_Open = True
		objects.play_animation("BUS_TOR_ZU","ANIM_SCHOOLBUSGATE_OPEN", callback=["ONEND", open_bus_model])
		sounds.play_3d_sound_object(sfx_id="pickup_loop_idle",object="BUS_TOR_ZU")
		
def open_bus_model(object_id=None):
	if data().Drugcar_Busdoor_Open:
		objects.set_active_state("BUS_TOR_OFFEN",1)
		objects.set_active_state("BUS_TOR_ZU",0)

def RSGateClose():
	
	if not data().player_has_entered_fort and data().Drugcar_Busdoor_Open:
		close_bus_model()
		objects.play_animation("BUS_TOR_ZU","ANIM_SCHOOLBUSGATE_CLOS", callback=['ONEND', Lambda('data().gate_open = False')])
		sounds.play_3d_sound_object(sfx_id="pickup_loop_idle",object="BUS_TOR_ZU")
		data().Drugcar_Busdoor_Open = False

def close_bus_model(object_id=None):
	objects.set_active_state("BUS_TOR_OFFEN",0)
	objects.set_active_state("BUS_TOR_ZU",1)


def EntryOfTheScientists(param=None):
	if not hasattr(data(), "scientists_are_back"):
		data().scientists_are_back = True
		del data().PlayAnimation['WISSENSCHAFTLER1']
		del data().PlayAnimation['WISSENSCHAFTLER2']
		character.play_animation('WISSENSCHAFTLER1', 'CM_NPC_SITZEN_BODEN_AUFSTEHEN')
		character.play_animation('WISSENSCHAFTLER2', 'CM_NPC_SITZEN_BANK_AUFSTEHEN')
		# raus
		objects.cancel_commandos('JEFF')
		objects.step_away('JEFF')#, 300.05, 293.93, MT_SLOW)
		objects.step_away('WISSENSCHAFTLER1')#, 300.05, 293.93, MT_SLOW)
		objects.step_away('WISSENSCHAFTLER2')#, 300.05, 293.93, MT_SLOW)
		# auf die Endpositionen
		objects.move_to('ALTER_EGO',301.5,298.5)
		objects.turn_to_object("ALTER_EGO", "JEFF")
		objects.move_to('WISSENSCHAFTLER1', 298.51, 297.38, grid="landscape", speed=MT_SLOW)
		objects.move_to('WISSENSCHAFTLER2', 300.19, 292.93, grid="landscape", speed=MT_SLOW)
		objects.move_to("JEFF", 301.09, 297.20, grid="landscape", speed=MT_SLOW, callback=
			["ONEND", EntryOfTheScientists_2])
			#["ONEND", Lambda('Delay(2, dialogs.initDlg_065_Erste_Begegnung)', "char")])
		objects.turn_to_position("WISSENSCHAFTLER1", 301.09, 297.20)
		objects.turn_to_position("WISSENSCHAFTLER2", 301.09, 297.20)

def EntryOfTheScientists_2(param=None):
	if system.is_cutscene():
		system.end_cutscene()
	dialogs.initDlg_065_Erste_Begegnung()
	
#####################################
### Colin Quest
### Colins Dad mit Kette versorgen und töten
def ColinQuestInit():
	## Klunker ins Inventar
	objects.create_item_in_inventory(object="COLIN_DAD", equipment="SET_NECKLACE", id='COLINS_NECKLACE')
	objects.set_attribute(object='COLINS_NECKLACE', attribute="generic_item", value=False)
	## Hyänen erzeugen...
	system.create_animal(id="DADKILLER1", type=ANIMAL_WOLF, party="ZOO", x=421.90, y=236.67)
	objects.set_attribute('DADKILLER1', 'level', 4)
	system.create_animal(id="DADKILLER2", type=ANIMAL_WOLF, party="ZOO", x=434.00, y=238.00)
	objects.set_attribute('DADKILLER2', 'level', 4)
	system.create_animal(id="DADKILLER3", type=ANIMAL_WOLF, party="ZOO", x=430.00, y=233.00)
	objects.set_attribute('DADKILLER3', 'level', 4)
	## ...und auf Papa hetzen
	objects.set_attribute( "DADKILLER1", attribute="foes", value=["COLIN_DAD"])
	objects.set_attribute( "DADKILLER2", attribute="foes", value=["COLIN_DAD"])
	objects.set_attribute( "DADKILLER3", attribute="foes", value=["COLIN_DAD"])
	#objects.attack("DADKILLER1","COLIN_DAD")
	#objects.attack("DADKILLER2","COLIN_DAD")
	#objects.attack("DADKILLER3","COLIN_DAD")
	#objects.destroy("COLIN_DAD")
	character.play_animation('COLIN_DAD','CM_STERBEN_FALLEN_NACH_HINTEN', callback = ['ONEND', Lambda('KillDad()')])

def KillDad():
	objects.set_attribute("COLIN_DAD","hitpoints",0)
	objects.drop_item("COLIN_DAD", "COLINS_NECKLACE")
	
def KeepEatingColinsDad():
	if not data().Dad_killers_are_foes:
		eater= str(random.randint(1, 3))
		for dummy in range(1, random.randint(3, 5)):
			objects.attack("DADKILLER" + eater,"COLIN_DAD")
		Delay(random.randint(3, 10), [KeepEatingColinsDad])

### Die Hyänen bei Colins Vater greifen den Spieler an:
def DadKillerAttackPlayer(objectid):  #Parameter: 1. Char der die Region betritt
	if objects.exists("DADKILLER1") and not objects.is_destroyed("DADKILLER1"):
		objects.set_attribute("DADKILLER1", attribute="foes", value=['UISPIELER'])
		objects.attack("DADKILLER1",objectid)
	if objects.exists("DADKILLER2") and not objects.is_destroyed("DADKILLER2"):
		objects.set_attribute("DADKILLER2", attribute="foes", value=['UISPIELER'])
		objects.attack("DADKILLER2",objectid)
	if objects.exists("DADKILLER3") and not objects.is_destroyed("DADKILLER3"):
		objects.set_attribute("DADKILLER3", attribute="foes", value=['UISPIELER'])
		objects.attack("DADKILLER3",objectid)

#####################################
### Markt Quest
def MarktQuestInit():
	#Teddy erzeugen, onExmaine reggen
	system.create_object(equipmenttype="SET_TEDDY_BEAR",	x=610.46, y=408.90, id="ADRIANS_TEDDY_BEAR")

#####################################
### Jim-Bob Quest
def JimBobQuestInit():
	# Seife erzeugen
	system.create_object(equipmenttype="SET_SOAP", id="MARENS_SOAP",x=676.99, y=269.40)
	objects.set_position_free('MARENS_SOAP', 683.54, 265.26, 0.65)
	objects.move_to_object('MAREN', const.WASHING_TABLE_CV, 'dmyp_001', MT_SLOW)
	character.play_animation('MAREN', 'CM_NPC_STEHEN_WAESCHE_WASCHEN_START')
	data().PlayAnimation['MAREN'] = 'wash'
	# Eisenstange an der Mühle erzeugen
	system.create_object(equipmenttype="SET_IRON_BAR", x=548.90, y=450.03, id="Thresher_destroyer")
	#Drogenkuriere ins Auto setzen und alles verschwinden lassen
	system.create_object('SET_PICKUP', 742, 576, "DRUGCAR", 215)
	character.set_in ('DRUGMANA', 'DRUGCAR')
	character.set_in ('DRUGMANB', 'DRUGCAR')
	objects.set_immortal_state('DRUGCAR', True)
	#objects.set_active_state("DRUGMANA",INACTIVE)
	#objects.set_active_state("DRUGMANB",INACTIVE)
	objects.set_active_state('DRUGCAR', INACTIVE)
	objects.set_attribute('DRUGCAR',"accepted_drivers",["RATSKULLS_DROGENLABOR"])
	data().Drug_state = "anfahrt"
	
	#old:
	#system.notify_timer(data().Drug_timer,data().Drug_timer_TICK)
	
	#new drugcar
	system.notify_timer(data().Timer_DrugCarStart,data().Timervalue_DrugCarCheck)
	
	
### Testen ob alle Aufgaben erledigt sind um Jimbo einen neuen Look zu verpassen
def CheckIfAllThingsAreReadyForJimbob():
	pcs = system.get_pcs()
	for pc in pcs:
		if objects.count_in_inventory(pc, "MARENS_SOAP") or objects.count_in_inventory(pc, "SET_SOAP"):
			if system.get_qb_entry_state(data().QB_005) == UNCOMPLETE:
				system.set_qb_entry_state(data().QB_005, COMPLETE)
				character.add_experience_party(data().Exp_SeifeBeschafft)
		
		if objects.count_in_inventory(pc, "CHUCKS_JACKET"):
			if system.get_qb_entry_state(data().QB_007) == UNCOMPLETE:
				system.set_qb_entry_state(data().QB_007, COMPLETE)
				character.add_experience_party(data().Exp_JackeBeschafft)
			if system.get_qb_entry_state(data().QB_008) == UNCOMPLETE:
				system.set_qb_entry_state(data().QB_008, INACTIVE)
			
	if (system.get_qb_entry_state(data().QB_005) == COMPLETE and
	   system.get_qb_entry_state(data().QB_006) == COMPLETE and
	   (system.get_qb_entry_state(data().QB_007) == COMPLETE or
	   system.get_qb_entry_state(data().QB_008) == COMPLETE)):
		   system.set_qb_entry_state(data().QB_009, UNCOMPLETE)
		   system.set_qb_entry_state(data().QB_004, INACTIVE)

### Chuck kommt wieder zur Mühle
def ChuckIsBack(id = ""):
	if system.is_cutscene() or dialog.is_dialog_active():
		Delay(5, Lambda("ChuckIsBack()"))
		return
	data().Chuck_is_away = False
	if objects.is_alive_and_active('CHUCK'):
		if data().Jacket_stolen:
			if data().One_Time_Only_D050:
				dialogs.initDlg_050_Cuck_Alarm_Ende_Jacke_weg()
				objects.cancel_commandos("CHUCK")
				data().One_Time_Only_D050 = False
		elif data().Thresher_sabotaged:
			if data().One_time_only_D040:
				dialogs.initDlg_040_Chuck_verzweifelt()
				data().One_time_only_D040 = False
			else:
				dialogs.chuckStartRepair()
		else:
			objects.move_to('CHUCK', 654.22, 479.98, 'landscape', MT_SLOW)
			objects.turn_to_direction("CHUCK", 275)
			system.notify_timer(data().Chuckwalk, random.randint(60, 180) * 1000)

### Der Feuer Alarm wurde ausgelöst:
def FireAlertOn():
	if data().Chuck_repairs: #data().Thresher_sabotaged and not data().Thresher_repared and not data().Chuck_is_away:
		dialogs.initDlg_049_Cuck_Alarm_ausgeloest()
	else:
		objects.cancel_commandos('CHUCK')
		objects.move_to('CHUCK', 488.57, 525.96, 'landscape', MT_FAST)
		objects.turn_to_direction('CHUCK', 180)
	sounds.load_sound(sfx_id='alarm_firehorn')
	playSound= Lambda('sounds.play_3d_sound_object(sfx_id="alarm_firehorn",object=const.OBJECT_FIRE_ALERT)')
	for i in range(1, 20):
		Delay(i*1.5, playSound)
	# data().FireAlert = True
	data().Chuck_repairs = False
	data().Chuck_is_away = True
	Delay(random.randint(90, 120), [FireAlertOff])

def FireAlertOff():
	if objects.is_alive_and_active('CHUCK'):
		objects.move_to("CHUCK", 642.57, 476.83, "landscape", MT_FAST,["ONEND", ChuckIsBack])
	data().FireAlert = False

################################
## Auftritt der Drogenkuriere ##
################################
def rest_finished():
	Drugcar_Shortcuts()
	pass
	
def Drugcar_Shortcuts():
	print"****DRUGCAR-SETTING-CHECK****"
	if not objects.exists("DRUGCAR") or objects.is_destroyed("DRUGCAR"):
		return
	if data().Stop_Car:
		return
	if data().DrugCarActiveDelay_Active:
		return
	actual_time = system.get_mission_time().get_day_time()
	
	data().DrugCarRunRoutine = Drugcar_Shortcuts_Pass
	#Drugcar_Shortcuts_State_Dependancies()
	if actual_time >= time("09:00:00") and actual_time < time("09:30:00"):
		#Drugcar_Shortcuts_Start()
		pass
	elif actual_time >= time("09:30:00") and actual_time < time("11:30:00"):
		data().DrugCarRunRoutine = Drugcar_Shortcuts_Leila
	elif actual_time >= time("11:30:00") and actual_time < time("12:15:00"):
		data().DrugCarRunRoutine = Drugcar_Shortcuts_Door
	elif actual_time >= time("12:15:00") and actual_time < time("13:30:00"):
		data().DrugCarRunRoutine = Drugcar_Shortcuts_Return
	elif data().drugcar_started:
		data().DrugCarRunRoutine = Drugcar_Shortcuts_Deactivate
	
	#print "CAR steht bei:",objects.get_position("DRUGCAR")
	if data().DrugCarRunRoutine != Drugcar_Shortcuts_Pass:
		data().Drugcar_Old_Phase = data().Drugcar_Actual_Phase
		data().Drugcar_Actual_Phase = "UNKNOWN"
		Drugcar_Shortcuts_Clear()
	

def Drugcar_Shortcuts_Clear():
	# Sicherung für Türproblem
	#print"Shortcuts:Clear"
	objects.cancel_commandos("LEILA")
	objects.cancel_commandos("DRUGMANA")
	objects.cancel_commandos("DRUGMANB")
	if data().Drugcar_Changing_Grid:
		objects.stack_callback(data().Drugcar_Changing_Grid,callback = Drugcar_Shortcuts_Run)
		
	objects.set_attribute("DRUGCAR", "reversing", False)
	
	if not objects.is_active("DRUGCAR"):
		objects.set_active_state("DRUGCAR",True)
		data().DrugCarActiveDelay_Active = True
		system.notify_timer(data().Timer_DrugCarActiveDelay, data().Timervalue_DrugCarActiveDelay)
	else:
		objects.cancel_commandos("DRUGCAR")
		vehicle.stop_vehicle("DRUGCAR")
		data().DrugCarActiveDelay_Active = True
		system.notify_timer(data().Timer_DrugCarActiveDelay, data().Timervalue_DrugCarActiveDelay)
		#Drugcar_Shortcuts_Run()
	
def Drugcar_Shortcuts_Run(character_id = "LEILA"):
	# Sicherung für Türproblem
	#print"Shortcuts:Run"
	if data().Drugcar_Changing_Grid:
		data().Drugcar_Changing_Grid = None
		if data().DrugCarActiveDelay_Active:
			return
	
	data().DrugCarActiveDelay_Active = False
	
	if callable(data().DrugCarRunRoutine):
		data().DrugCarRunRoutine()
	else:
		raise ValueError, "Drugcar_Shortcuts:Keine Funktion!"
	
def Drugcar_Shortcuts_Crew(put_crew_in = True):
	actual_crew = vehicle.get_crew("DRUGCAR")
	if put_crew_in:
		for id in ["DRUGMANA","DRUGMANB"]:
			if not id in actual_crew:
				if objects.exists(id) and not objects.is_destroyed(id):
					objects.cancel_commandos(id)
					objects.set_position(id,730.1, 578.1,grid = "landscape")
					
					daily_routine.prohibit_activity(id)
					character.set_in(id,"DRUGCAR")
	
def Drugcar_Shortcuts_State_Dependancies(current_state):
	print"Dependancies:",current_state
	if data().Drugcar_LeaveLeila_Timer_active:
		data().Drugcar_LeaveLeila_Timer_active = False
	if current_state == "START":
		pass
	elif current_state == "LEILA":
		objects.cancel_commandos("LEILA")
		character.set_approachable_state("LEILA", APPROACHABLE)
		objects.set_position("LEILA",347.17, 459.54,grid="landscape") #347.17, 459.54
		objects.set_direction("LEILA",45)
		data().caravan_comment_active = False
		
	elif current_state == "CARAVAN":
		
		data().counter_drugmen_leila_in_caravan = 0
		objects.add_closed_lock("ZONE_4_BUILDING_3849", "lock1", closure_type='normal')
		objects.cancel_commandos("LEILA")
		character.set_approachable_state("LEILA", APPROACHABLE)
		objects.set_position("LEILA",347.17, 459.54,grid="landscape")
		objects.set_direction("LEILA",45)
		
	elif current_state == "DOOR":
		pass
		#objects.set_active_state("BUS_TOR_OFFEN",0)
		#objects.set_active_state("BUS_TOR_ZU",1)
		
		#objects.play_animation("BUS_TOR_ZU","ANIM_SCHOOLBUSGATE_CLOS")
		#objects.set_attribute("DRUGCAR", "reversing", False)
	elif current_state == "TURN":
		objects.set_attribute("DRUGCAR", "reversing", False)
	
	if data().Drugcar_Busdoor_Open:
		objects.set_active_state("BUS_TOR_OFFEN",0)
		objects.set_active_state("BUS_TOR_ZU",1)
		objects.play_animation("BUS_TOR_ZU","ANIM_SCHOOLBUSGATE_CLOS")
		data().Drugcar_Busdoor_Open = False


	       
	elif current_state == "RETURN":
		pass
	else:
		pass
	#print "Shortcut:Dependancies End"
	
def Drugcar_Shortcuts_Start():
	print"Drugcar_Start"
	#current_state = data().Drugcar_Actual_Phase
	data().Drugcar_Actual_Phase = "START"
	#Drugcar_Shortcuts_Clear()
	Drugcar_Shortcuts_Crew(True)
	Drugcar_Shortcuts_State_Dependancies(data().Drugcar_Old_Phase)
	#objects.set_position("DRUGCAR",680.67, 622.93)
	#objects.set_direction("DRUGCAR",45)
	objects.set_position("DRUGCAR",742, 576)
	objects.set_direction("DRUGCAR",215)
	data().drugcar_started = True
	
	drugcar_start()
	
def Drugcar_Shortcuts_Leila():
	print"Drugcar_Leila"
	#current_state = data().Drugcar_Actual_Phase
	data().Drugcar_Actual_Phase = "START"
	#Drugcar_Shortcuts_Clear()
	Drugcar_Shortcuts_Crew(True)
	Drugcar_Shortcuts_State_Dependancies(data().Drugcar_Old_Phase)
	data().Drugcar_Actual_Phase = "START"
	objects.set_position("DRUGCAR",454.95,450.05)# 494.43,417.53)
	objects.set_direction("DRUGCAR",55)
	#print"Position Drugcar:",objects.get_position("DRUGCAR")
	#print"Position Drugmen:",objects.get_position("DRUGMANB")
	#print"Grid Drugman",objects.get_attribute("DRUGMANB","grid")
	#print"Animation Drugman", character.get_act_animation_name("DRUGMANB")
	data().drugcar_started = True
	vehicle_add_path("DRUGCAR", DRUGCAR_LEILA_SHORT)
	objects.move_to('DRUGCAR',0,0,grid='landscape',speed=MT_FAST,callback=["ONEND", drugcar_reaches_leila])
	
def Drugcar_Shortcuts_Door():
	print"Drugcar_Door"
	#current_state = data().Drugcar_Actual_Phase
	data().Drugcar_Actual_Phase = "TODOOR"
	#Drugcar_Shortcuts_Clear()
	Drugcar_Shortcuts_Crew(True)
	Drugcar_Shortcuts_State_Dependancies(data().Drugcar_Old_Phase)
	#data().Drugcar_Actual_Phase = "TODOOR"
	
	if display_drugcar_scene_as_cutscene():
		data().Drugcar_Meeting_Leila_is_cutscene = True
	else:
		data().Drugcar_Meeting_Leila_is_cutscene = False
	
	if not data().Drugcar_Meeting_Leila_is_cutscene:
		objects.set_position("DRUGCAR",345.73,450.69)
		objects.set_direction("DRUGCAR",112)
		data().drugcar_started = True
		vehicle_add_path("DRUGCAR", const.DrugCarWaypoints2)
		objects.move_to('DRUGCAR', 0,0, 'landscape', MT_FAST, callback = ['ONEND', drugcar_to_door_2])
	
	else:
		Drugcar_Shortcuts_Try_Cutscene_Door()
		#data().drugcar_started = True
		#system.fade(FADE_OUT, callback = drugcar_to_door_cutscene)
		
def Drugcar_Shortcuts_Try_Cutscene_Door():
	if (not system.is_cutscene() and not dialog.is_dialog_active()):
		system.start_cutscene()
		data().drugcar_started = True
		system.fade(FADE_OUT, callback = drugcar_to_door_cutscene)
	else:
		system.notify_timer(data().Timer_DrugCarDoorCutscene, data().Timervalue_DrugCarCheck)
	
def Drugcar_Shortcuts_Return():
	print"Drugcar_Return"
	#current_state = data().Drugcar_Actual_Phase
	data().Drugcar_Actual_Phase = "DEACTIVATE"
	#Drugcar_Shortcuts_Clear()
	Drugcar_Shortcuts_Crew(True)
	Drugcar_Shortcuts_State_Dependancies(data().Drugcar_Old_Phase)
	data().drugcar_started = True
	#data().Drugcar_Actual_Phase = "DEACTIVATE"
	objects.set_position("DRUGCAR",315.00,370.90)
	objects.set_direction("DRUGCAR",335)
	vehicle_add_path("DRUGCAR", const.DrugCarWaypointsBack[1:])
	objects.move_to('DRUGCAR',0,0, speed=MT_FAST, callback=['ONEND', deactivate_drugcar])
	
def Drugcar_Shortcuts_Deactivate():
	print"Drugcar_Deactivate"
	#current_state = data().Drugcar_Actual_Phase
	data().Drugcar_Actual_Phase = "INACTIVE"
	#Drugcar_Shortcuts_Clear()
	Drugcar_Shortcuts_Crew(True)
	Drugcar_Shortcuts_State_Dependancies(data().Drugcar_Old_Phase)
	data().drugcar_started = False
	#data().Drugcar_Actual_Phase = "INACTIVE"
	objects.set_position("DRUGCAR",742.1,576.06)
	objects.set_direction("DRUGCAR",215)
	system.notify_timer(data().Timer_DrugCarSetInactive, data().Timervalue_DrugCarSetInactive)
	
def Drugcar_Shortcuts_Pass():
	pass
	
def DrugTransportPhase1(param=None):
	#print "Phase1:Aufbrechen", system.get_mission_time().get_day_time()
	#start drugcar routing
	objects.set_active_state('DRUGCAR', ACTIVE)
	objects.cancel_commandos('DRUGCAR')
	#objects.set_position('DRUGCAR', 680.67, 622.93)#, 0)#const.DrugCarWaypoints1[0][0],const.DrugCarWaypoints1[0][1])
	#objects.set_direction("DRUGCAR", DIR_NORTH_EAST)
	
	if not hasattr(data(), "first_drugcar_start"):
		data().first_drugcar_start = True
		drugcar_start()
	else:
		#Fahrzeug zurueck setzen und starten
		data().DrugCarRunRoutine = Drugcar_Shortcuts_Start
		data().Drugcar_Old_Phase = data().Drugcar_Actual_Phase
		data().Drugcar_Actual_Phase = "UNKNOWN"
		Drugcar_Shortcuts_Clear()
		#Drugcar_Shortcuts_Start()
	
	"""
	else:
		vehicle_add_path("DRUGCAR", const.PATH_TURN_START)
		
		objects.move_to('DRUGCAR',0,0,grid='landscape',speed=MT_FAST,callback=["ONEND", drugcar_start])
		
	"""
	
def drugcar_start(car=None):
	data().Drugcar_Actual_Phase = "START"
	vehicle_add_path("DRUGCAR", const.DrugCarWaypoints1)
	#print """vehicle_add_path("DRUGCAR", const.DrugCarWaypoints1)"""
	objects.move_to('DRUGCAR',0,0,grid='landscape',speed=MT_FAST,callback=["ONEND", drugcar_reaches_leila])
	#print """objects.move_to('DRUGCAR',0,0,grid='landscape',speed=MT_FAST,callback=["ONEND", drugcar_reaches_leila])"""

#helper checks if as cutscene or not as cutscene
def display_drugcar_scene_as_cutscene():
	if (system.get_qb_entry_state(data().QB_004) == COMPLETE):# and system.get_qb_entry_state(data().QB_009) == COMPLETE
		if not data().player_knows_password:
			return True
	return False
	
def drugcar_reaches_leila(char=None):
	#print"Leila Erreicht"
	if data().Drugcar_Actual_Phase != "START":
		#print"Callback-Break:START",data().Drugcar_Actual_Phase
		return
	
	if (not system.is_cutscene() and not dialog.is_dialog_active()):
		data().Drugcar_Actual_Phase = "LEILA"
		if display_drugcar_scene_as_cutscene():
			data().Drugcar_Meeting_Leila_is_cutscene = True
		else:
			data().Drugcar_Meeting_Leila_is_cutscene = False
		if data().Drugcar_Meeting_Leila_is_cutscene:
			system.start_cutscene()
			system.fade(FADE_OUT, callback = drugcar_couriers_approach_leila)
			#system.set_camera_view(const.CamView_Drug_Leila_view1)
		else:
			drugcar_meet_leila()
	else:
		data().cutscene_name = "drugcar_start"
		system.notify_timer(data().Timer_Cutscene,data().Timervalue_Cutscene)

def drugcar_couriers_approach_leila(param = None):
	#system.set_camera_view(const.CamView_Drug_Leila_view1)
	system.set_camera_view(const.CamView_Drug_Leila_view2)
	system.fade(FADE_IN, callback = drugcar_meet_leila)
	#if display_drugcar_scene_as_cutscene() and system.is_cutscene():
	#	system.fade(FADE_OUT, callback = DrugTransportPhase2)
	#else:
	#	DrugTransportPhase2()

def drugcar_meet_leila(param=None):
	if data().Drugcar_Actual_Phase != "LEILA":
		#print"Callback-Break:LEILA",data().Drugcar_Actual_Phase
		return
	#if display_drugcar_scene_as_cutscene() and system.is_cutscene():
	
	
	#objects.set_active_state("DRUGMANA",ACTIVE)
	#objects.set_active_state("DRUGMANB",ACTIVE)
	try:
		character.get_out('DRUGMANB')
	except:
		pass
	try:
		character.get_out('DRUGMANA')
	except:
		pass
		
	Delay(10, Lambda("objects.move_to('DRUGMANA', 349.06, 458.87, 'landscape', MT_SLOW)"))
	Delay(7, Lambda("objects.move_to('DRUGMANB', 347.44, 457.54, 'landscape', MT_SLOW, ['ONEND',drugcar_dialog_leila])"))

	#if display_drugcar_scene_as_cutscene() and system.is_cutscene():
	#	system.set_camera_view(const.CamView_Drug_Leila_view2)
	
	character.set_approachable_state("LEILA", NOTAPPROACHABLE)

def drugcar_dialog_leila(bla="666"):
	if data().Drugcar_Actual_Phase != "LEILA":
		#print"Callback-Break:LEILA",data().Drugcar_Actual_Phase
		return
	#print "Phase3:Dialog1", system.get_mission_time().get_day_time()
	objects.turn_to_object('LEILA', 'DRUGMANA')
	objects.turn_to_object('DRUGMANB', 'LEILA')
	objects.turn_to_object('DRUGMANA', 'LEILA')
	if dialogs.check_char_in_range("LEILA"):
		dialogs.initDialog_062_Drogenkuriere_besuchen_Laila_Ankunft()
	else:
		drugcar_into_caravan_1()

def drugcar_into_caravan_1():
	if data().Drugcar_Actual_Phase != "LEILA":
		#print"Callback-Break:LEILA",data().Drugcar_Actual_Phase
		return
	#print "Phase4:in den Wohnwagen", system.get_mission_time().get_day_time()
	if data().Drugcar_Meeting_Leila_is_cutscene and system.is_cutscene():
		system.fade(FADE_OUT, callback = drugcar_into_caravan_1_fade_2)
	else:
		drugcar_into_caravan_2()

def drugcar_into_caravan_1_fade_2():
	system.set_camera_view(const.CamView_Drug_Leila_view3)
	system.fade(FADE_IN, callback = drugcar_into_caravan_2)

def callback_leila_opes_door(char):
	if data().Drugcar_Actual_Phase != "CARAVAN":
		#print"Callback-Break:CARAVAN1",data().Drugcar_Actual_Phase
		return
	objects.move_to(char, 332.80, 474.31, speed=MT_SLOW, grid="landscape")
	objects.turn_to_object('LEILA','ZONE_4_BUILDING_3849', callback=['ONEND', callback_leila_opes_door2])

def callback_leila_opes_door2(char):
	if data().Drugcar_Actual_Phase != "CARAVAN":
		#print"Callback-Break:CARAVAN2",data().Drugcar_Actual_Phase
		return
	character.play_animation(char, "STEHEND_TUERSCHLOSS_KNACKEN")
	data().Drugcar_Changing_Grid = "LEILA"
	objects.move_to('LEILA', 334.17, 476.15, grid="ZONE_4_BUILDING_3849_INTERIOR_GRID", speed=MT_SLOW, callback = ['ONEND', drugcar_into_caravan_3])
	
def drugcar_into_caravan_2():
	if data().Drugcar_Actual_Phase != "LEILA":
		#print"Callback-Break:LEILA",data().Drugcar_Actual_Phase
		return
	data().Drugcar_Actual_Phase = "CARAVAN"
	objects.move_to('LEILA', 330.37, 471.81, "landscape", MT_SLOW, callback=["ONEND",callback_leila_opes_door])
	objects.remove_closed_lock_by_name("ZONE_4_BUILDING_3849", "lock1")
	objects.move_to('DRUGMANA', 329.05, 472.81, "landscape", MT_SLOW)
	objects.turn_to_object('DRUGMANA','ZONE_4_BUILDING_3849')
	objects.move_to('DRUGMANB', 329.17, 474.51, "landscape", MT_SLOW)
	objects.turn_to_object('DRUGMANB','ZONE_4_BUILDING_3849')
	
def callback_enter_house(next):
	if data().Drugcar_Actual_Phase != "CARAVAN":
		print"Callback-Break:CARAVAN",data().Drugcar_Actual_Phase
		return
	if next == "LEILA":
		data().Drugcar_Changing_Grid = "DRUGMANB"
		objects.move_to('DRUGMANB', 335.80, 474.19, grid="ZONE_4_BUILDING_3849_INTERIOR_GRID", speed=MT_SLOW, callback = ['ONEND', drugcar_into_caravan_3])
	else:
		data().Drugcar_Changing_Grid = "DRUGMANA"
		objects.move_to('DRUGMANA', 335.21, 473.18, grid="ZONE_4_BUILDING_3849_INTERIOR_GRID", speed=MT_SLOW, callback = ['ONEND', drugcar_into_caravan_3])

def drugcar_into_caravan_3(param=None):
	data().Drugcar_Changing_Grid = None
	if data().Drugcar_Actual_Phase != "CARAVAN":
		#print"Callback-Break:CARAVAN3",data().Drugcar_Actual_Phase
		data().counter_drugmen_leila_in_caravan = 0
		objects.add_closed_lock("ZONE_4_BUILDING_3849", "lock1", closure_type='normal')
		return
		
	## regionstrigger für dialog 156 - 159 aktivieren
	if not data().region_wohnwagen_notified:
		system.notify_region_entered("REGION_WOHNWAGEN_LEILA", objectid="ALTER_EGO")
		data().region_wohnwagen_notified= True
	if not hasattr(data(), "caravan_comment_active"):
		data().caravan_comment_active = True
	data().caravan_comment_active = True

	#workaround:
	if param=="LEILA":
		objects.set_position_free('LEILA', 334.17, 476.15,0, grid="ZONE_4_BUILDING_3849_INTERIOR_GRID")
	if data().counter_drugmen_leila_in_caravan < 2:
		callback_enter_house(param)
	data().counter_drugmen_leila_in_caravan += 1
	if data().counter_drugmen_leila_in_caravan == 3:
		data().counter_drugmen_leila_in_caravan = 0
		if data().Drugcar_Meeting_Leila_is_cutscene and system.is_cutscene():
			data().Drugcar_Meeting_Leila_is_cutscene = False
			Delay(2, system.end_cutscene)
		objects.add_closed_lock("ZONE_4_BUILDING_3849", "lock1", closure_type='normal')
		data().Drugcar_LeaveLeila_Timer_active = True
		system.notify_timer(data().Timer_DrugCarLeaveLeila, 25 * data().Timervalue_DrugCarCheck)
	
def checked_deactivation(char_id=None):
	if data().Drugcar_Actual_Phase != "CARAVAN":
		#print"Callback-Break:CARAVAN5",data().Drugcar_Actual_Phase
		data().drugmans_inactive = 0
		return
	data().drugmans_inactive += 1
	character.get_in(char_id, 'DRUGCAR')
	if data().drugmans_inactive == 2:
		Delay(4.0, drugcar_to_door_1)
		data().drugmans_inactive = 0

### erste Abschnitt beendet ####################################################

### wenn 4 un 9 complete ist data().DrogenAutoCutscene = True ##################
def drugcar_leaving_caravan_1():
	#print "Phase5:Wohnwagen verlassen", system.get_mission_time().get_day_time()
	if data().Drugcar_Actual_Phase != "CARAVAN" or not data().Drugcar_LeaveLeila_Timer_active:
		#print"Callback-Break:CARAVAN4",data().Drugcar_Actual_Phase
		return
	objects.remove_closed_lock_by_name("ZONE_4_BUILDING_3849", "lock1")
	#Cutscene verzoegern
	if (not system.is_cutscene() and not dialog.is_dialog_active()):
		data().Drugcar_LeaveLeila_Timer_active = False
		if display_drugcar_scene_as_cutscene():
			data().Drugcar_Meeting_Leila_is_cutscene = True
		else:
			data().Drugcar_Meeting_Leila_is_cutscene = False
		if data().Drugcar_Meeting_Leila_is_cutscene:
			system.start_cutscene()
			system.set_camera_view(const.CamView_Drug_Leila_view3)
		data().drugmans_inactive = 0
		if not hasattr(data(), "caravan_comment_active"):
			data().caravan_comment_active = False
		data().caravan_comment_active = False
		objects.move_to("DRUGMANA", 330.73, 472.5, grid="landscape", speed=MT_SLOW)
		objects.move_to("DRUGMANB", 329.33, 471.59, grid="landscape", speed=MT_SLOW)
		objects.move_to('DRUGMANA', 353.16, 457.00, speed=MT_SLOW, callback=["ONEND",checked_deactivation])
		objects.move_to('DRUGMANB', 355.60, 453.47, speed=MT_SLOW, callback=["ONEND",checked_deactivation])
		
		if dialogs.check_char_in_range("LEILA"):
			Delay(2, dialogs.initDialog_137_Drogenkuriere_besuchen_Laila_Abgang)
		else:
			drugcar_leaving_caravan_2()
		
	else:
		system.notify_timer(data().Timer_DrugCarLeaveLeila, data().Timervalue_DrugCarCheck)

def callback_leila_closes_door(char):
	if data().Drugcar_Actual_Phase != "CARAVAN":
		#print"Callback-Break:CARAVAN6",data().Drugcar_Actual_Phase
		return
	objects.move_to(char, 332.80, 474.31, speed=MT_SLOW, grid="landscape")
	objects.turn_to_object(char, "ZONE_4_BUILDING_3849", callback=["ONEND", callback_leila_closes_door2])

def callback_leila_closes_door2(char):
	if data().Drugcar_Actual_Phase != "CARAVAN":
		#print"Callback-Break:CARAVAN",data().Drugcar_Actual_Phase
		return
	character.play_animation(char, "STEHEND_TUERSCHLOSS_KNACKEN")
	objects.remove_closed_lock_by_name("ZONE_4_BUILDING_3849", "lock1")
	objects.move_to('LEILA', 347.17, 459.54, grid="landscape", speed=MT_SLOW)
	objects.turn_to_direction('LEILA', 45)

def drugcar_leaving_caravan_2():
	if data().Drugcar_Actual_Phase != "CARAVAN":
		#print"Callback-Break:CARAVAN",data().Drugcar_Actual_Phase
		return
	objects.move_to('LEILA', 331.20, 473.23, grid="landscape", speed=MT_SLOW, callback=["ONEND",callback_leila_closes_door])

def drugcar_to_door_1(param=None):
	if data().Drugcar_Actual_Phase != "CARAVAN":
		#print"Callback-Break:CARAVAN",data().Drugcar_Actual_Phase
		return
	data().Drugcar_Actual_Phase = "TODOOR"
	#print "Phase7:fahrt zum Tor", system.get_mission_time().get_day_time()
	character.set_approachable_state("LEILA", APPROACHABLE)
	
	if data().Drugcar_Meeting_Leila_is_cutscene and system.is_cutscene():
		system.fade(FADE_OUT, callback = drugcar_to_door_cutscene)
	else:
		vehicle_add_path("DRUGCAR", const.DrugCarWaypoints2)
		objects.move_to('DRUGCAR', 0,0, 'landscape', MT_FAST, callback = ['ONEND', drugcar_to_door_2])

def drugcar_to_door_cutscene():
	#print "Phase7_1:oder Cutscene", system.get_mission_time().get_day_time()
	system.fade(FADE_IN)
	system.set_camera_view([312.73129272460937, 385.69210815429687, 22.061740875244141, 0.23909616470336914, -0.8901706337928772, -0.3878522515296936])#const.CamView_Drug_Gate_view1)
	objects.set_position('DRUGCAR', 330,394)
	objects.set_direction('DRUGCAR',155)
	objects.set_attribute('DRUGCAR','script_path',None)
	vehicle_add_path("DRUGCAR", const.DrugCarWaypoints4)
	objects.move_to('DRUGCAR', 0, 0, 'landscape', MT_FAST, callback = ['ONEND', drugcar_to_door_2])

def drugcar_to_door_2(param=None):
	if data().Drugcar_Actual_Phase != "TODOOR":
		#print"Callback-Break:TODOOR",data().Drugcar_Actual_Phase
		return
	#print "Phase8:Cutscene Tor", system.get_mission_time().get_day_time()
	if not objects.is_destroyed("RSWACHE"):
		#objects.move_to('RSWACHE', 312.35, 372.97, 'landscape', MT_SLOW)
		objects.turn_to_direction('RSWACHE', 60)
		data().Drugcar_Actual_Phase = "DOOR"
		if data().drugcar_bug_installed:
			data().Stop_Car = True
			drugcar_door_bug()
		else:
			drugcar_door_no_bug()
	else:
		#obsolute ?
		for rs in ["DRUGMANA","DRUGMANB"]:
			character.get_out(rs)
			if not objects.has_attribute(rs, 'foes'):
				objects.set_attribute(rs, "foes", ["UISPIELER"])
			elif objects.has_attribute(rs, 'foes'):
				if objects.get_attribute(rs, 'foes') == []:
					objects.set_attribute(rs, "foes", ['UISPIELER'])
			objects.turn_to_object(rs, random.choice(system.get_pcs()))
			objects.set_immortal_state(rs, False)
			data().Stop_Car = True
			if data().Drugcar_Meeting_Leila_is_cutscene and system.is_cutscene():
				data().Drugcar_Meeting_Leila_is_cutscene = False
				system.end_cutscene()

def drugcar_door_bug():
	if not data().player_has_entered_fort:
		dialogs.initDialog_063_Drogenkuriere_wissen_Passwort()

def drugcar_door_no_bug():
	
	if not data().player_has_entered_fort:
		data().Drugcar_Actual_Phase = "DOOR"
		data().Drugcar_Busdoor_Open = True
		objects.play_animation("BUS_TOR_ZU","ANIM_SCHOOLBUSGATE_OPEN", callback=[["ONEND", drugcar_into_base],["ONEND",open_bus_model]])
										       #['ONEND', Lambda('objects.set_active_state("BUS_TOR_OFFEN",1)')],
										       #['ONEND', Lambda('objects.set_active_state("BUS_TOR_ZU",0)')]])

def drugcar_into_base(param=None):
	#print "drugcar_into_base"
	if data().Drugcar_Actual_Phase != "DOOR":
		#print "callback-break:DOOR",data().Drugcar_Actual_Phase
		return
	if data().Drugcar_Meeting_Leila_is_cutscene and system.is_cutscene():
		data().Drugcar_Meeting_Leila_is_cutscene = False
		Delay(2, system.end_cutscene)
	vehicle_add_path("DRUGCAR", const.DrugCarWaypoints3)
	#print "data().Stop_Car",data().Stop_Car
	if not data().Stop_Car:
		data().Drugcar_Actual_Phase = "TURN"
		objects.move_to('DRUGCAR', 0, 0, 'landscape', MT_FAST, callback=["ONEND", drugcar_base_turn_1])
	else:
		data().Drugcar_Actual_Phase = "PARK"
		objects.move_to('DRUGCAR', 0, 0, 'landscape', MT_FAST, callback=["ONEND", drugcar_base_park_1])
	
	Delay(3, Lambda("objects.turn_to_direction('RSWACHE', 150)"))
	#data().Drugcar_Busdoor_Open = True
	Delay(10, Lambda("RSGateClose()"))
"""
def RSGateOpen_DrugTransportPhase10():
	if not data().player_has_entered_fort:
		objects.play_animation("BUS_TOR_ZU","ANIM_SCHOOLBUSGATE_OPEN", callback=[["ONEND", DrugTransportPhase10_1],
										       ['ONEND', Lambda('objects.set_active_state("BUS_TOR_OFFEN",1)')],
										       ['ONEND', Lambda('objects.set_active_state("BUS_TOR_ZU",0)')]])
"""
def drugcar_base_turn_1(id):
	if data().Drugcar_Actual_Phase != "TURN":
		#print "callback-break:TURN",data().Drugcar_Actual_Phase
		return
	vehicle_add_path("DRUGCAR", const.DRUCCAR_WAYPOINTS_TURN["forward"])
	objects.move_to('DRUGCAR',0,0, speed=MT_FAST, callback=['ONEND', drugcar_base_turn_2])

def drugcar_base_turn_2(obj):
	if data().Drugcar_Actual_Phase != "TURN":
		#print "callback-break:TURN",data().Drugcar_Actual_Phase
		return
	objects.set_attribute("DRUGCAR", "reversing", True)
	vehicle_add_path("DRUGCAR", const.DRUCCAR_WAYPOINTS_TURN["reverse"])
	objects.move_to('DRUGCAR',0,0, speed=MT_FAST, callback=['ONEND', drugcar_base_turn_3])

def drugcar_base_turn_3(obj):
	if data().Drugcar_Actual_Phase != "TURN":
		#print "callback-break:TURN",data().Drugcar_Actual_Phase
		return
	#objects.set_direction("DRUGCAR",100)
	objects.set_attribute("DRUGCAR", "reversing", False)
	vehicle_add_path("DRUGCAR", const.DrugCarWaypoints5)
	objects.move_to('DRUGCAR',0,0, speed=MT_FAST, callback=['ONEND', drugcar_leaving_base_1])
	data().DrogenKurriereAbfahrt = False

#helper add a path to vehicle
def vehicle_add_path(car, path):
	temp = []
	for p in path:
		temp.append(p[0])
		temp.append(p[1])
	objects.set_attribute('DRUGCAR','script_path',temp)
	
def drugcar_leaving_base_1(id):
	if data().Drugcar_Actual_Phase != "TURN":
		#print "callback-break:TURN",data().Drugcar_Actual_Phase
		return
	# objects.move_to('RSWACHE', 312.35, 372.97, 'landscape', MT_SLOW)
	data().Drugcar_Actual_Phase = "DOOR"
	RSGateOpen()
	Delay(2, Lambda("drugcar_leaving_base_2()"))

def drugcar_leaving_base_2():
	if data().Drugcar_Actual_Phase != "DOOR":
		#print "callback-break:DOOR",data().Drugcar_Actual_Phase
		return
	#print "Phase10_3:Rueckweg Begin", system.get_mission_time().get_day_time()
	data().Drugcar_Actual_Phase = "RETURN"
	Delay(10, Lambda("RSGateClose()"))
	if not objects.is_destroyed("RSWACHE"):
		#Delay(10, Lambda("objects.move_to('RSWACHE', 313.94, 368.92, 'landscape', MT_SLOW)"))
		Delay(14, Lambda("objects.turn_to_direction('RSWACHE', 150)"))

	vehicle_add_path("DRUGCAR", const.DrugCarWaypointsBack)
	data().Drugcar_Actual_Phase = "DEACTIVATE"
	objects.move_to('DRUGCAR',0,0, speed=MT_FAST, callback=['ONEND', deactivate_drugcar])

def drugcar_base_park_1(id):
	data().Drugcar_Actual_Phase = "END"
	vehicle_add_path("DRUGCAR", const.DRUCCAR_WAYPOINTS_TURN["park"])
	objects.move_to('DRUGCAR',0,0, speed=MT_FAST, callback=['ONEND', drugcar_base_park_2])

def drugcar_base_park_2(obj):
	character.get_out('DRUGMANB')
	character.get_out('DRUGMANA')
	objects.set_immortal_state('DRUGMANB', False)
	objects.set_immortal_state('DRUGMANA', False)
	Delay(2.5, drugmen_ta_active)
	data().drugmen_now_have_a_daily_routine = True
	
def drugmen_ta_active():
	data().FortRatSkulls.append('DRUGMANA')
	data().FortRatSkulls.append('DRUGMANB')
	objects.step_to("DRUGMANA", 319.3,285.43)
	objects.step_to("DRUGMANB", 324.37,289.22)
	
	objects.move_to("DRUGMANA", 345.6,308.9, callback=["ONEND", drugmen_enter_druglab])
	objects.move_to("DRUGMANB", 345.6,308.9, callback=["ONEND", drugmen_enter_druglab])

def drugmen_enter_druglab(char=None):
	if char == "DRUGMANA":
		enemy_script.enter_building_to_position('DRUGMANA', house='BUILDING_90', grid='ZONE_4_BUILDING_90_INTERIOR_GRID', x=329.87, y=307.68)
		objects.turn_to_object("DRUGMANA", "DRUGMANB")
	else:
		enemy_script.enter_building_to_position('DRUGMANB', house='BUILDING_90', grid='ZONE_4_BUILDING_90_INTERIOR_GRID', x=332.2, y=311.6)
		objects.turn_to_object("DRUGMANB", "DRUGMANA")

def deactivate(id):
	objects.set_active_state(id,INACTIVE)

def deactivate_drugcar(id):
	if data().Drugcar_Actual_Phase != "DEACTIVATE":
		#print "callback-break:DEACTIVATE",data().Drugcar_Actual_Phase
		return
	#print "PhaseX:Drugcar abschalten", system.get_mission_time().get_day_time()
	
	print"Drugcar_Deactivate"
	data().Drugcar_Actual_Phase = "INACTIVE"
	data().drugcar_started = False
	objects.set_position("DRUGCAR",742.1,576.06)
	objects.set_direction("DRUGCAR",215)
	system.notify_timer(data().Timer_DrugCarSetInactive, data().Timervalue_DrugCarSetInactive)

def on_grid_enter( object_id, grid_id, old_grid_id ):
	if objects.is_pc(object_id):
		#wachhaus vor dem drogenlabor
		if grid_id == "ZONE_4_BUILDING_1249_INTERIOR_GRID":
			if objects.is_destroyed("RSGUARD_FRONT"):
				return object_events.on_grid_enter( object_id, grid_id, old_grid_id )
			
			if not data().alter_ego_rampage:
				objects.cancel_commandos("RSGUARD_FRONT")
				if objects.get_grid("RSGUARD_FRONT") != "ZONE_4_BUILDING_1249_INTERIOR_GRID":
					objects.move_to("RSGUARD_FRONT", 305.6, 383.3, grid="ZONE_4_BUILDING_1249_INTERIOR_GRID")
					if not hasattr(data(), "watching_player"):
						data().watching_player = None
					data().watching_player = object_id
					rsguard_watches_player()
		
		elif grid_id == "landscape" and old_grid_id == "ZONE_4_BUILDING_1249_INTERIOR_GRID":
			if objects.is_destroyed("RSGUARD_FRONT"):
				return object_events.on_grid_enter( object_id, grid_id, old_grid_id )
			
			if not data().alter_ego_rampage:
				objects.cancel_commandos("RSGUARD_FRONT")
				data().watching_player = None
				rsguard_leaves_building()
	return object_events.on_grid_enter( object_id, grid_id, old_grid_id )
		
def rsguard_watches_player(char=None):
	if data().watching_player != None:
		objects.turn_to_object("RSGUARD_FRONT", data().watching_player, callback=["ONEND", rsguard_watches_player])

def rsguard_leaves_building():
	character.play_animation("RSGUARD_FRONT", "CM_NPC_STEHEN_WARTEN_2")
	character.play_animation("RSGUARD_FRONT", "CM_NPC_STEHEN_WARTEN_5")
	character.play_animation("RSGUARD_FRONT", "CM_NPC_STEHEN_WARTEN_2")
	objects.move_to("RSGUARD_FRONT", 310.56,388.32, speed=MT_SLOW, grid="landscape")
	objects.turn_to_direction("RSGUARD_FRONT", DIR_SOUTH_EAST)

#######
#### Fight events
#######
def FortAlertOn(operator = "666"):
	# print 'FortAlertOn(',operator,'):'
	playSound= Lambda('sounds.play_3d_sound_object(sfx_id="alarm_fort_zone4",object=const.FORT_ALERT_OBJECT)')
	for i in range(1, 20):
		# print 'playSound FortAlertOn'
		Delay(i*2, playSound)
	
	if not objects.is_destroyed('ENEMY_FORT_G11'):
		objects.cancel_commandos('ENEMY_FORT_G11')
		# daily_routine.prohibit_activity('ENEMY_FORT_G11')
		objects.step_to('ENEMY_FORT_G11', 353.23, 288.84)
	
	data().FortAlert += 1
	data().EnemyDefaultOccupation['ENEMY_FORT_G19'][1] = (320.73, 363.81,  30)
	data().EnemyDefaultOccupation['ENEMY_FORT_G20'][1] = (310.42, 368.72, 340)
	if not objects.is_destroyed("ENEMY_FORT_G19") and not objects.is_destroyed("ENEMY_FORT_G20"):
		objects.move_to('ENEMY_FORT_G19', 320.73, 363.81, 'landscape', MT_FAST)
		objects.move_to('ENEMY_FORT_G20', 310.42, 368.72, 'landscape', MT_FAST)
	#	sounds.load_sound(sfx_id='alarm_fort_zone4')
	#	playSound= Lambda('sounds.play_3d_sound_object(sfx_id="alarm_fort_zone4",object=const.FORT_ALERT_OBJECT)')
	#	for i in range(1, 20):
	#		Delay(i*2, playSound)
			
	for id in data().FortRatSkulls:
		#print "making foe", id
		if not objects.is_destroyed(id):
			if not objects.has_attribute(id, 'foes'):
				objects.set_attribute(id, "foes", ["UISPIELER"])
			elif objects.has_attribute(id, 'foes'):
				if objects.get_attribute(id, 'foes') == []:
					objects.set_attribute(id, "foes", ['UISPIELER'])

def FortAlertOff():
	data().FortAlert += 1
	map(lambda c: npc.startEnemyActivity(c), data().FortRatSkulls) # alarm aus

def enableRest():
	data('rest').legal_rest_areas['zone_4'] = const.legalRestAreas
	pass
	
def disableRest():
	data('rest').legal_rest_areas['zone_4'] = const.noRestAreas
	pass
	
def ThresherOn(foo = 'bar'):
	data().Animate_Thresher = True
	treshner_sound()
	ThresherAnim()

def treshner_sound():
	if not sounds.is_sound_playing('sound_treshner_engine'): #data().treshner_sound_playing: # da vor neuladen die variable nicht umgesetzt wurde folge kein sound
		data().treshner_sound_playing = True
		sounds.play_3d_sound_object(sfx_id="treshing_machine",object=const.OBJECT_THRESHER,loop=True, identifier="sound_treshner_engine")

def ThresherAnim(foo = 'bar'):
	if data().Animate_Thresher:
		objects.play_animation('BUILDING_4082', 'ANIM_TRESHER_LOOP',callback=['ONEND', ThresherAnim])

def ThresherOff(foo = 'bar'):
	if data().treshner_sound_playing:
		sounds.play_3d_sound_object(sfx_id="crane_setting_down_container",object=const.OBJECT_THRESHER)
	data().Animate_Thresher = False
	data().treshner_sound_playing = False
	sounds.stop_sound(id="sound_treshner_engine")

def WindmuehleAnimation(id=None):
	objects.play_animation('BUILDING_3817', 'ANIM_WINDMUEHLE',callback=['ONEND', WindmuehleAnimation])

def BuehnenAnimation(id=None):
	objects.play_animation('BUILDING_3918', 'ANIM_KL_BUEHNE',callback=['ONEND', BuehnenAnimation])

### DEBUGCODE ###
################################################################################
# Initialisiert alle SpielerCharaktere der Entwickler
################################################################################

#abschliessen des museeums + gefängnisses
def init_lock_state(building='BUILDING_2421', state='lock'):
	if state=='lock':
		#system.add_text("schliessen")
		objects.add_closed_lock(building, "lock1", closure_type='normal')
	else:
		#system.add_text("oeffnen")
		objects.remove_closed_lock_by_name(building, "lock1")

def can_crack_lock( character_id, object_id, dummy_name ):
	if object_id == 'ZONE_4_BUILDING_3923' and objects.count_in_inventory(character_id, 'Z4PRISON_KEY'):
		return True
	if object_id == "ZONE_4_BUILDING_3849":
		return False
	else:
		return object_events.can_crack_lock( character_id, object_id, dummy_name )

def on_crack_lock( character_id, object_id, dummy_name, x, y, z ):
	#print "on_crack_lock"
	if object_id == 'ZONE_4_BUILDING_3923' and objects.count_in_inventory(character_id, 'Z4PRISON_KEY'):
		if data().Fort_liberated:
			if system.get_qb_entry_state(data().QB_011) == INACTIVE:
				open_knast(character_id, True)
				return False
		else:
			dialogs.initDlg_130_Spieler_will_Gefaengnis_nicht_oeffnen()
			return False
	elif  object_id == 'ZONE_4_BUILDING_3923' and hasattr(data("pick_lock"), "blast_lock") and data("pick_lock").blast_lock:
		#print"blast"
		if data().Fort_liberated:
			if system.get_qb_entry_state(data().QB_011) == INACTIVE:
				open_knast(character_id, False, True)
				return False
		else:
			dialogs.initDlg_130_Spieler_will_Gefaengnis_nicht_oeffnen()
			return False
	elif object_id == 'ZONE_4_BUILDING_3923' and objects.get_attribute(character_id, 'lock_pick') > 90 :
		if data().Fort_liberated:
			if system.get_qb_entry_state(data().QB_011) == INACTIVE:
				open_knast(character_id, False)
				return False
		else:
			dialogs.initDlg_130_Spieler_will_Gefaengnis_nicht_oeffnen()
			return False
	elif object_id == 'ZONE_4_BUILDING_3923' and objects.get_attribute(character_id, 'lock_pick') <= 90 :
		if data().Fort_liberated:
			if system.get_qb_entry_state(data().QB_011) == INACTIVE:
				not_open_knast(character_id)
				return False
		else:
			dialogs.initDlg_130_Spieler_will_Gefaengnis_nicht_oeffnen()
			return False
		
	if object_id == "ZONE_4_BUILDING_3849":
		return False
	
	return object_events.on_crack_lock( character_id, object_id, dummy_name, x, y, z )

def can_blast_lock( character_id, object_id, dummy ):
	if object_id == "ZONE_4_BUILDING_3849":
		return False
	else:
		return object_events.can_blast_lock( character_id, object_id, dummy )

# Funktionalität ist nicht equivalent zur on_crack_lock; on_crack_lock erledigt dies für beide Fälle
"""
def on_blast_lock( character_id, object_id, dummy_name, x, y, z ):
	if object_id == "ZONE_4_BUILDING_3849":
		return False
	else:
		return on_blast_lock( character_id, object_id, dummy_name, x, y, z )
"""

def can_enter_building( character_id, building_id ):
	if building_id == "ZONE_4_BUILDING_3849":
		if character_id in system.get_pcs():
			return False
	return object_events.can_enter_building( character_id, building_id )

def not_open_knast(character_id):
	system.start_cutscene()
	system.set_camera_view([305.1639404296875, 298.60061645507812, 20.010461807250977, -0.65118342638015747, -0.72782915830612183, -0.21499992907047272])
	objects.cancel_commandos(character_id)
	groupe = system.get_pcs()
	del groupe[groupe.index(character_id)]
	enemy_script.evacuate( groupe, [299.85, 292.69], 4, callback = Lambda("objects.turn_to_object(parameter,'ZONE_4_BUILDING_3923')", "parameter"))
	objects.move_to_object(character_id, 'ZONE_4_BUILDING_3923', dummy = 'dmyp_door1_01', callback = ['ONEND', not_open_knast_0])
	
def not_open_knast_0(character_id):
	objects.turn_to_direction(character_id, 0)
	character.play_animation( character_id, "STEHEND_TUERSCHLOSS_KNACKEN", callback=[ "ONEND", not_open_knast_1] )

def not_open_knast_1(character_id):
	dialog.init_dialog( type=DIALOGSMALL )
	dialog.add_text( text = 'CRACK_LOCK_FAILED_003', speaker = character_id, follower = 'ENDDIALOG',  callback = Lambda('not_open_knast_2("%s")' %character_id))
	dialog.start()

def not_open_knast_2(character_id):
	objects.step_away(character_id, callback = ['ONEND', Lambda('system.end_cutscene()')])
	
def open_knast(character_id, key, blast = False):
	data().jail_open=True	
	# print 'open_knast(', character_id, key,')'
	groupe = system.get_pcs()
	del groupe[groupe.index(character_id)]
	system.start_cutscene()
	enemy_script.evacuate( groupe, [299.85, 292.69], 4, callback = Lambda("objects.turn_to_object(parameter,'ZONE_4_BUILDING_3923')", "parameter"))
	objects.cancel_commandos(character_id)
	if character_id != 'ALTER_EGO':
		system.fade(FADE_OUT, callback = Lambda('on_open_knast("%s", %s, %s)' %(character_id, key, blast)))
		if not 'ALTER_EGO' in enemy_script.is_in_area(['ALTER_EGO'], 15, 'ZONE_4_BUILDING_3923'):
			objects.cancel_commandos('ALTER_EGO')
			objects.set_position('ALTER_EGO', 304.17, 302.44)
		#system.set_camera_view([298.1697998046875, 309.07989501953125, 18.841438293457031, 0.18734703958034515, -0.95745652914047241, -0.21949532628059387])
	else:
		on_open_knast_1(character_id, key, blast)
	
def on_open_knast(character_id, key, blast = False):
	system.set_camera_view([298.1697998046875, 309.07989501953125, 18.841438293457031, 0.18734703958034515, -0.95745652914047241, -0.21949532628059387])
	enemy_script.delay(0.5, Lambda('system.fade(FADE_IN)'))
	objects.cancel_commandos('ALTER_EGO')
	objects.move_to('ALTER_EGO', 301.57, 298.44, speed = MT_SLOW, callback = [ "ONEND", Lambda('on_open_knast_1("%s", %s, %s)' %(character_id, key, blast)) ])
	
def on_open_knast_1(character_id, key, blast = False):
	character.unequip_hands(character_id, False)
	objects.step_to(character_id, 299.16, 292.50)
	system.set_camera_view([295.4278564453125, 297.31304931640625, 18.888494491577148, 0.55312168598175049, -0.79921579360961914, -0.23518213629722595])
	character.play_animation( character_id, "STEHEND_TUERSCHLOSS_KNACKEN", callback=[ "ONEND", Lambda('on_open_knast_2("%s", %s, %s)' %(character_id, key, blast)) ] )
	
def on_open_knast_2(character_id, key, blast = False):
	objects.cancel_commandos(character_id)
	system.set_camera_view([291.07470703125, 312.705810546875, 25.019874572753906, 0.45909738540649414, -0.82340872287750244, -0.3335081934928894])
	if blast:
		objects.step_away(character_id, callback = [ "ONEND", Lambda('on_open_knast_2_1("%s", %s)' %(character_id, key)) ])
	else:
		objects.step_away(character_id, callback = [ "ONEND", Lambda('on_open_knast_3("%s", %s)' %(character_id, key)) ])
	
def on_open_knast_2_1(character_id, key):
	#explosion
	x,y,z = objects.get_full_dummy_position('ZONE_4_BUILDING_3923', 'dmyp_door1_01')
	system.start_effect( x, y, z, x, y, z, fx_explosion )
	sounds.play_3d_sound( "grenade_explo_fire", x, y, z) #, callback = [ "ONEND", Lambda('on_open_knast_3("%s", %s)' %(character_id, key)) ])
	on_open_knast_3(character_id, key)
	
	#remove gunpowder
	try:
		objects.remove_item_from_inventory(character_id, 'SET_GUN_POWDER')
	except:
		print "!!!!ERROR: no Gunpowder found"
	
	
def on_open_knast_3(character_id, key):
	objects.move_to(character_id, 299.65, 295.43, speed = MT_SLOW, callback = [ "ONEND", Lambda('on_open_knast_4("%s", %s)' %(character_id, key)) ])
	
def on_open_knast_4(character_id, key):
	objects.turn_to_object(character_id, 'JEFF', callback = [ "ONEND", Lambda('open_knast_1("%s", %s)' %(character_id, key)) ])
	#system.end_cutscene()
	
def open_knast_1(character_id, key):
	objects.remove_closed_lock_by_name('ZONE_4_BUILDING_3923', 'lock1' )
	# print key
	if key:
		dialogs.initDlg_141_Spieler_oeffnet_Gefaengnis()
		#Delay(2,EntryOfTheScientists)
	else:
		dialog.init_dialog( type=DIALOGSMALL )
		dialog.add_text( text = 'CRACK_LOCK_SUCCESS_001', speaker = character_id, follower = 'ENDDIALOG', callback =EntryOfTheScientists)
		dialog.start()

def InitChestsSafes():
	objects.add_closed_lock("BUILDING_16869", "lock1", closure_type='booby-trap')
	objects.add_closed_lock("BUILDING_16870", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_16871", "lock1", closure_type='lock-trap')
	objects.add_closed_lock("BUILDING_16892", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_16928", "lock1", closure_type='booby-trap')
	objects.add_closed_lock("BUILDING_16929", "lock1", closure_type='poison-trap')
	objects.add_closed_lock("BUILDING_16934", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_9656", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_9423", "lock1", closure_type='lock-trap')

def can_steal_from(thief, victim):
	WACHEN = ['RSGUARD_FRONT', 'ENEMY_FORT_G19', 'RSWACHE', 'ENEMY_FORT_G20', "CHUCK"]
	if victim in WACHEN:
		return False
	else:
		return object_events.can_steal_from(thief, victim)

def init_patch():
	if "ANIE" in system.get_npcs():
		if objects.is_active("ANIE"):
			data("zone_7.zone_7").anie_folgt = True
	
	if not system.get_qb_entry_state(data().QB_002) == COMPLETE and not system.get_qb_entry_state(data().QB_003) == COMPLETE and not data().player_has_entered_fort:
		for ratskull in data().FortRatSkulls:
			objects.set_immortal_state(ratskull, True)
			
		for id in ["DRUGMANA", "DRUGMANB", 'RSWACHE']:
			objects.set_immortal_state(id, True)
			
	if system.get_qb_entry_state(data().QB_011) in [COMPLETE, INACTIVE]:
		for ratskull in data().HostageCampRatSkulls:
			if not objects.is_destroyed(ratskull):
				objects.set_immortal_state(ratskull, True)
	
	if system.get_qb_entry_state(data().QB_011) in [UNCOMPLETE]:
		for ratskull in data().HostageCampRatSkulls:
			if not objects.is_destroyed(ratskull):
				objects.set_immortal_state(ratskull, False)
				
	
	if objects.is_destroyed("DRUGMANA"):
		if not objects.is_destroyed("DRUGMANB"):
			if not objects.has_attribute('DRUGMANB', 'foes'):
				objects.set_attribute('DRUGMANB', "foes", ['UISPIELER'])
			elif objects.has_attribute('DRUGMANB', 'foes'):
				if objects.get_attribute('DRUGMANB', 'foes') == []:
					objects.set_attribute('DRUGMANB', "foes", ['UISPIELER'])
			
	if  objects.is_destroyed("DRUGMANB"):
		if not objects.is_destroyed("DRUGMANA"):
			if not objects.has_attribute('DRUGMANA', 'foes'):
				objects.set_attribute('DRUGMANA', "foes", ['UISPIELER'])
			elif objects.has_attribute('DRUGMANA', 'foes'):
				if objects.get_attribute('DRUGMANA', 'foes') == []:
					objects.set_attribute('DRUGMANA', "foes", ['UISPIELER'])
	
	if (objects.is_destroyed("ENEMY_FORT_P02") or objects.is_destroyed("ENEMY_FORT_G03")):
		if not objects.is_destroyed("ENEMY_FORT_P02"):
			if not objects.has_attribute('ENEMY_FORT_P02', 'foes'):
				objects.set_attribute('ENEMY_FORT_P02', "foes", ['UISPIELER'])
			elif objects.has_attribute('ENEMY_FORT_P02', 'foes'):
				if objects.get_attribute('ENEMY_FORT_P02', 'foes') == []:
					objects.set_attribute('ENEMY_FORT_P02', "foes", ['UISPIELER'])
		if not objects.is_destroyed("ENEMY_FORT_G03"):
			if not objects.has_attribute('ENEMY_FORT_G03', 'foes'):
				objects.set_attribute('ENEMY_FORT_G03', "foes", ['UISPIELER'])
			elif objects.has_attribute('ENEMY_FORT_G03', 'foes'):
				if objects.get_attribute('ENEMY_FORT_G03', 'foes') == []:
					objects.set_attribute('ENEMY_FORT_G03', "foes", ['UISPIELER'])
	
	if  (objects.is_destroyed("ENEMY_FORT_G02") or  objects.is_destroyed("ENEMY_FORT_G10")):
		if not objects.is_destroyed("ENEMY_FORT_G02"):
			if not objects.has_attribute('ENEMY_FORT_G02', 'foes'):
				objects.set_attribute('ENEMY_FORT_G02', "foes", ['UISPIELER'])
			elif objects.has_attribute('ENEMY_FORT_G02', 'foes'):
				if objects.get_attribute('ENEMY_FORT_G02', 'foes') == []:
					objects.set_attribute('ENEMY_FORT_G02', "foes", ['UISPIELER'])
		if not objects.is_destroyed("ENEMY_FORT_G10"):
			if not objects.has_attribute('ENEMY_FORT_G10', 'foes'):
				objects.set_attribute('ENEMY_FORT_G10', "foes", ['UISPIELER'])
			elif objects.has_attribute('ENEMY_FORT_G10', 'foes'):
				if objects.get_attribute('ENEMY_FORT_G10', 'foes') == []:
					objects.set_attribute('ENEMY_FORT_G10', "foes", ['UISPIELER'])
			
	if(objects.is_destroyed("RSWACHE") or objects.is_destroyed("ENEMY_FORT_G19") or objects.is_destroyed("ENEMY_FORT_G20") or objects.is_destroyed("RSGUARD_FRONT")):
		if not objects.is_destroyed("RSWACHE"):
			if not objects.has_attribute("RSWACHE", 'foes'):
				objects.set_attribute("RSWACHE", "foes", ['UISPIELER'])
			elif objects.has_attribute('RSWACHE', 'foes'):
				if objects.get_attribute('RSWACHE', 'foes') == []:
					objects.set_attribute('RSWACHE', "foes", ['UISPIELER'])
		if not objects.is_destroyed("ENEMY_FORT_G19"):
			if not objects.has_attribute("ENEMY_FORT_G19", 'foes'):
				objects.set_attribute("ENEMY_FORT_G19", "foes", ['UISPIELER'])
			elif objects.has_attribute('ENEMY_FORT_G19', 'foes'):
				if objects.get_attribute('ENEMY_FORT_G19', 'foes') == []:
					objects.set_attribute('ENEMY_FORT_G19', "foes", ['UISPIELER'])
		if not objects.is_destroyed("ENEMY_FORT_G20"):
			if not objects.has_attribute("ENEMY_FORT_G20", 'foes'):
				objects.set_attribute("ENEMY_FORT_G20", "foes", ['UISPIELER'])
			elif objects.has_attribute('ENEMY_FORT_G20', 'foes'):
				if objects.get_attribute('ENEMY_FORT_G20', 'foes') == []:
					objects.set_attribute('ENEMY_FORT_G20', "foes", ['UISPIELER'])
		if not objects.is_destroyed("RSGUARD_FRONT"):
			objects.set_position('RSGUARD_FRONT', 309.49, 387.48)
			if not objects.has_attribute("RSGUARD_FRONT", 'foes'):
				objects.set_attribute("RSGUARD_FRONT", "foes", ['UISPIELER'])
			elif objects.has_attribute('RSGUARD_FRONT', 'foes'):
				if objects.get_attribute('RSGUARD_FRONT', 'foes') == []:
					objects.set_attribute('RSGUARD_FRONT', "foes", ['UISPIELER'])
	
	if not objects.exists('SALLY'):
		if not hasattr(data("zone_4.zone_4"), "Keno_has_his_Sally"):
			if objects.exists("MERCENARY_KENO"):
				objects.create_item_in_inventory("MERCENARY_KENO", "SET_PSG_1", id = "SALLY")
				objects.create_item_in_inventory("MERCENARY_KENO", "SET_AMMOPACK_7_62NATO_MM")
				objects.set_attribute('SALLY', 'nickname', 'Sally')
				data().Keno_has_his_Sally=True
		else:
			if not data("zone_4.zone_4").Keno_has_his_Sally:
				if objects.exists("MERCENARY_KENO"):
					objects.create_item_in_inventory("MERCENARY_KENO", "SET_PSG_1", id = "SALLY")
					objects.create_item_in_inventory("MERCENARY_KENO", "SET_AMMOPACK_7_62NATO_MM")
					objects.set_attribute('SALLY', 'nickname', 'Sally')
					data().Keno_has_his_Sally=True
				
	if not hasattr(data('zone_4.zone_4'),'Region_Fort_Gate_Angelegt'):
		data().Region_Fort_Gate_Angelegt = False
	
	if not data().player_has_entered_fort:
		if not data().Region_Fort_Gate_Angelegt:
			data().Fort_escape_flag = False
			data().Region_Fort_Gate_Angelegt = True
			system.add_region("Region_Fort_Gate_SAVEGAME", 303, 379, 327, 364)
			system.notify_region_entered(region="Region_Fort_Gate_SAVEGAME", partyid="UISPIELER")
		
	if not hasattr(data('zone_4.zone_4'),'Region_Fort_Gate'):
		data().Region_Fort_Gate = False
		
	if system.get_qb_entry_state(data().QB_016) == UNCOMPLETE and system.get_qb_entry_state(data().QB_013) == COMPLETE:
		system.set_qb_entry_state(data().QB_016, INACTIVE)
		
	if not hasattr(data(), "patch_patrick"):
		objects.create_item_in_inventory("GENE",["SET_OINTMANT_JAR","SET_OINTMANT_JAR","SET_OINTMANT_JAR","SET_ANTIDOTE"])
		#wurfwaffenpatch
		objects.create_item_in_inventory(object='BUILDING_3765', equipment='SET_DART')
		objects.create_item_in_inventory(object='BUILDING_9674', equipment=['SET_SHURIKEN', 'SET_SHURIKEN'] )
		objects.create_item_in_inventory( 'BUILDING_9423', equipment=[ 'SET_THROWING_KNIFE', 'SET_THROWING_KNIFE' ] )
		data().patch_patrick = 2
	else:
		if not data().patch_patrick:
			data().patch_patrick = 1
			objects.create_item_in_inventory("GENE",["SET_OINTMANT_JAR","SET_OINTMANT_JAR","SET_OINTMANT_JAR","SET_ANTIDOTE"])
		if data().patch_patrick < 2:
			data().patch_patrick = 2
			#wurfwaffenpatch
			objects.create_item_in_inventory(object='BUILDING_3765', equipment='SET_DART')
			objects.create_item_in_inventory(object='BUILDING_9674', equipment=['SET_SHURIKEN', 'SET_SHURIKEN'] )
			objects.create_item_in_inventory( 'BUILDING_9423', equipment=[ 'SET_THROWING_KNIFE', 'SET_THROWING_KNIFE' ] )

	if not objects.has_attribute("MILES", "voice_id"):
		objects.set_attribute("MILES", "voice_id", "trader_01")
	
	if not hasattr(data('zone_4.zone_4'), 'ui_spotter_list'):
		data().ui_spotter_list = []

	character.set_approachable_state("DRUGMANB", NOTAPPROACHABLE)
	
	if 'COLIN' in system.get_npcs():
		if objects.has_attribute('COLIN_DAD', 'name'):
			if objects.get_attribute('COLIN_DAD', 'name') == 'Colin':
				import globaltext
				objects.set_attribute('COLIN_DAD', 'name', globaltext.NAME_COLIN_DAD)
		if system.get_qb_entry_state(data().QB_018) != COMPLETE:
			daily_routine.prohibit_activity('COLIN')
	
	if not hasattr(data(),"Play_Dlg_037"):
		data().Play_Dlg_037 = True
	
	if 'CHUCKS_JACKET' in system.get_objects():
		objects.set_attribute(object='CHUCKS_JACKET', attribute="generic_item", value=False)
		
	if not hasattr(data('zone_4.zone_4'),"BuehnenAnimation"):
		data().BuehnenAnimation = True
		BuehnenAnimation('bla')
	
	if data().One_time_only_D098 and not system.get_qb_entry_state(data().QB_018) == COMPLETE:
		objects.set_active_state('COLIN_DAD', True)
	else:
		objects.set_active_state('COLIN_DAD', False)
		
	# Dadkiller auf immer Foes bringen
	for id in ["DADKILLER1","DADKILLER2","DADKILLER3"]:
		if objects.exists(id) and not objects.is_destroyed(id) and not objects.has_attribute(id,"foes"):
			objects.set_attribute(id, attribute="foes", value=['UISPIELER'])
			
	# Zusatzvariablen für Drugcar_Change_Grid -Problem
	if not hasattr(data(),"Drugcar_Changing_Grid"):
		data().Drugcar_Changing_Grid = None
		data().Drugcar_Busdoor_Open = False
		
	init_main_npcs()

def init_main_npcs():
	npcs = system.get_npcs()
	if "MILES" in npcs:
		character.set_main_quest_npc_state(char="MILES", state=True)
	if "GENE" in npcs:
		character.set_main_quest_npc_state(char="GENE", state=True)
	if "MYRIAM" in npcs:
		character.set_main_quest_npc_state(char="MYRIAM", state=True)
		
	if "JIMBOB" in npcs:
		character.set_main_quest_npc_state(char="JIMBOB", state=True)
	if "DANA" in npcs:
		character.set_main_quest_npc_state(char="DANA", state=True)
	if "LUIS" in npcs:
		character.set_main_quest_npc_state(char="LUIS", state=True)
	if "MAREN" in npcs:
		character.set_main_quest_npc_state(char="MAREN", state=True)
	if "CHUCK" in npcs:
		character.set_main_quest_npc_state(char="CHUCK", state=True)
	if "JASON" in npcs:
		character.set_main_quest_npc_state(char="JASON", state=True)
	if "NED" in npcs:
		character.set_main_quest_npc_state(char="NED", state=True)
	if "LAURA" in npcs:
		character.set_main_quest_npc_state(char="LAURA", state=True)
	if "LEILA" in npcs:
		character.set_main_quest_npc_state(char="LEILA", state=True)
	if "RSWACHE" in npcs:
		character.set_main_quest_npc_state(char="RSWACHE", state=True)
	# if "DRUGMANA" in npcs:
	#	character.set_main_quest_npc_state(char="DRUGMANA", state=True)
	# if "DRUGMANB" in npcs:
	#	character.set_main_quest_npc_state(char="DRUGMANB", state=True)
	
	
def drugcar_time_shift():
	if not objects.is_active("DRUGCAR"):
		objects.set_active_state("DRUGCAR",True)
	
	#vehicle.stop_vehicle("DRUGCAR")
	objects.cancel_commandos("DRUGCAR")
	enemy_script.delay(1,Drugcar_Shortcuts_Leila)

